      subroutine dist
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      character*128 ven,venp,venpp
      character*80 radka,t80,atplane(mxa),AtTor(4)
      character*8 text(2),nazev
      dimension w(3),wg(3),fm(3,20),sfm(3,20),isww(4),wt(mxa),idx(mxa),
     1          xplane(3,mxa),sxplane(3,mxa),dx(mxa),fc(3),xs(3)
      logical iesd,ExistFile,opened,PrvniTorzniUhel
      equivalence (atplane,attor),(dxm,dx),(w,fc),(wg,xs)
      data text/'torsion','plane'/
      uloha='Calculating of distances, angles, torsion angles and '//
     1      'best planes'
      LinuxString=fln(:ifln)//'_dist.tmp'
      call DeleteFile(LinuxString)
      call OpenFile(89,LinuxString,'formatted','unknown')
      if(ErrJana.ne.0) go to 9999
      write(89,'(''dist'')')
      call OpenFile(lst,fln(:ifln)//'.dis','formatted','unknown')
      if(ErrJana.ne.0) go to 9999
      LstOpened=.true.
      VolaToDist=.true.
      call DefaultDist
      call NactiDist
      if(ErrJana.ne.0) go to 9999
      call iom50(0,1)
      if(ErrJana.ne.0) go to 9910
      if(ncs.gt.1) then
        ncvt=ns
      else
        ncvt=ns*2
      endif
      if(iuhl.eq.1) FullCoo=1
      write(FormTD(2:2),'(i1)') ndimi
      write(FormTA(2:2),'(i1)') ndimi
      if(.not.ModulationExist.and.ncomp.le.1) call SetIntArrayTo(nt,9,0)
      if(nt(1,1).ne.0) then
        if(kcommen.le.0) then
          do 1005i=1,ndimi
            nt(i,1)=nt(i,1)+1
            dt(i,1)=(tlast(i,1)-tfirst(i,1))/float(nt(i,1)-1)
            do 1000j=2,ncomp
              nt(i,j)=nt(i,1)
              tfirst(i,j)=tfirst(i,1)
              tlast(i,j)=tlast(i,1)
              dt(i,j)=(tlast(i,j)-tfirst(i,j))/float(nt(i,j)-1)
1000        continue
1005      continue
        else
        do 1200isw=1,ncomp
          call SetRealArrayTo(dt(1,isw),3,999.)
          call CopyVek(trez(1,isw,KPhase),tfirst(1,isw),ndimi)
          do 1120ic3=0,ncommen(3,isw,KPhase)-1
            fc(3)=ic3
            do 1110ic2=0,ncommen(2,isw,KPhase)-1
              fc(2)=ic2
              do 1100ic1=0,ncommen(1,isw,KPhase)-1
                fc(1)=ic1
                call qbyx(fc,xs,isw)
                call od0do1(xs,xs,3)
                do 1050i=1,3
                  if(xs(i).gt..0001) dt(i,isw)=min(dt(i,isw),xs(i))
1050            continue
1100          continue
1110        continue
1120      continue
          do 1150i=1,3
            nt(i,isw)=nint(1./dt(i,isw))
1150      continue
          do 1160i=1,ndimi
            tlast(i,isw)=tfirst(i,isw)+float(nt(i,isw)-1)*dt(i,isw)
1160      continue
1200    continue
        endif
      endif
      do 2030j=1,ncomp
        ntall(j)=1
        do 2020i=1,ndimi
          ntall(j)=ntall(j)*nt(i,j)
2020    continue
2030  continue
      if(ntall(1).le.1.or.ndimi.ne.1) ittab=0
      if(ittab.ne.0.and.ieach.eq.0) ieach=max(ntall(1)/10,1)
      pom=0.
      call inm40(iesd)
      if(ErrJana.ne.0) go to 9900
      if(iesd) then
        call newln(2)
        write(lst,'(/''Input e.s.d of fraction coordinates of atoms '',
     1               ''included'')')
      else
        irnd=0
      endif
      call pisat
      call distat
      if(ErrJana.ne.0) go to 9900
4000  nr=0
      inquire(55,opened=opened)
      if(.not.opened) go to 9000
      call NewPg(0)
      call newln(1)
      write(lst,FormA128)
      rewind 55
      PrvniTorzniUhel=.true.
4100  read(55,FormA80,err=7000) radka
      if(radka(1:1).eq.'*') go to 4100
      kk=0
      call mala(radka)
      call kus(radka,kk,nazev)
      if(nazev.eq.'end') go to 7000
      i=islovo(nazev,text,2)
      if(i.le.0) go to 4100
      go to (5000,6000),i
5000  if(PrvniTorzniUhel) then
        call TitulekVRamecku('Calculation of torsion angles')
        PrvniTorzniUhel=.false.
      else
        call NewLn(1)
        write(lst,FormA1)
      endif
      do 5010i=1,4
        call kus(radka,kk,attor(i))
        call uprat(attor(i))
5010  continue
      call DistTorsionAngle(AtTor,Radka)
      go to 4100
6000  call kus(radka,kk,cislo)
      call posun(cislo,0)
      read(cislo,FormI15) n1
      call kus(radka,kk,cislo)
      call posun(cislo,0)
      read(cislo,FormI15) n2
      if(n1.lt.3) then
        call FeChybne(-1.,-1.,radka,'number of atoms defining plane '//
     1                'than 3',1,SeriousError)
        go to 4100
      endif
      do 6001i=1,n2
        if(kk.eq.80) then
          read(55,FormA80) radka
          call mala(radka)
          kk=0
        endif
        call kus(radka,kk,atplane(i))
        call uprat(atplane(i))
        call atsym(atplane(i),n,xplane(1,i),wt,wt(4),jsym,ich)
        if(n.le.0) then
          t80='atom '//atplane(i)(1:idel(atplane(i)))//' isn''t of '//
     1        'the file M40'
          call FeChybne(-1.,-1.,radka,t80,1,SeriousError)
          go to 4100
        else
          if(i.eq.1) then
            isw=iswa(n)
          else
            if(isw.ne.iswa(n)) then
              t80='atoms belong to different composite parts'
              call FeChybne(-1.,-1.,radka,t80,1,SeriousError)
              go to 4100
            endif
          endif
        endif
        if(ich.eq.1) then
          t80='string contains non-numerical character'
          call FeChybne(-1.,-1.,radka,t80,1,SeriousError)
          go to 4100
        else if(ich.eq.3) then
          t80='atom '//atplane(i)(1:idel(atplane(i)))//' has incorrect '
     1        //'symmetry part'
          call FeChybne(-1.,-1.,radka,t80,1,SeriousError)
          go to 4100
        endif
        call multmq(rm(1,iabs(jsym),isw,KPhase),sx(1,n),sxplane(1,i),3,
     1              3,1)
6001  continue
      nr=nr+1
      ven='Equation of best plane through atoms :'
      l=40
      i=idel(atplane(1))
      k=1
      outs(1)='Equation of best plane through atoms :'
      do 6005j=1,n1
        outs(k)=outs(k)(1:l)//atplane(j)(1:i)
        l=l+i
        if(j.eq.n1) go to 6005
        if(l.lt.127) then
          outs(k)=outs(k)(1:l)//' '
          l=l+1
        endif
        i=idel(atplane(j+1))
        if(l.gt.127-i) then
          k=k+1
          l=40
          outs(k)=' '
        endif
 6005 continue
      call newln(k+3+((n2-1)/7+1)*2)
      write(lst,FormA128)
      do 6010i=1,k
        write(lst,FormA128) outs(i)
6010  continue
      do 6100i=1,3
        u(i)=xplane(i,1)-xplane(i,2)
        v(i)=xplane(i,3)-xplane(i,2)
6100  continue
      wg(1)=u(2)*v(3)-u(3)*v(2)
      wg(2)=u(3)*v(1)-u(1)*v(3)
      wg(3)=u(1)*v(2)-u(2)*v(1)
      call multm(MetTensI(1,1,KPhase),wg,w,3,3,1)
      call vecnor(w,wg)
      do 6500i=1,10
        i3=1
        if(abs(w(2)).gt.abs(w(1))) i3=2
        if(abs(w(3)).gt.abs(w(2)).and.abs(w(3)).gt.abs(w(1))) i3=3
        i1=mod(i3,3)+1
        i2=6-i1-i3
        avx=0.
        avy=0.
        avz=0.
        pom=0.
        do 6200j=1,n1
          if(iesd) then
            pom1=0.
            do 6150k=1,3
              pom1=pom1+(wg(k)*sxplane(k,j))**2
6150        continue
            pom1=1./pom1
          else
            pom1=1.
          endif
          avx=avx+xplane(i1,j)*pom1
          avy=avy+xplane(i2,j)*pom1
          avz=avz+xplane(i3,j)*pom1
          pom=pom+pom1
          wt(j)=pom1
6200    continue
        avx=avx/pom
        avy=avy/pom
        avz=avz/pom
        pom3=w(i1)/w(i3)
        pom4=w(i2)/w(i3)
        cx=0.
        cy=0.
        cz=0.
        p1=0.
        p2=0.
        do 6300j=1,n1
          xxx=xplane(i1,j)-avx
          yyy=xplane(i2,j)-avy
          zzz=xplane(i3,j)-avz
          uu=xxx*wg(i1)+yyy*wg(i2)+zzz*wg(i3)
          pom=wt(j)
          pom1=xxx-pom3*zzz
          pom2=yyy-pom4*zzz
          cx=cx+pom1**2  *pom
          cy=cy+pom1*pom2*pom
          cz=cz+pom2**2  *pom
          p1=p1+pom1*uu  *pom
          p2=p2+pom2*uu  *pom
6300    continue
        pom=1./(cx*cz-cy**2)
        cz= cz*pom
        cy=-cy*pom
        cx= cx*pom
        w(i1)=cz*p1+cy*p2
        w(i2)=cy*p1+cx*p2
        w(i3)=-pom3*w(i1)-pom4*w(i2)
        pom1=0.
        pom2=0.
        do 6400j=1,3
          wg(j)=wg(j)-w(j)
          pom1=pom1+abs(w(j))
          pom2=pom2+abs(wg(j))
6400    continue
        call multm(MetTensI(1,isw,KPhase),wg,w,3,3,1)
        call vecnor(w,wg)
        if(pom1/pom2.le..00001) go to 6600
6500  continue
6600  if(wg(1).lt.0.) then
        do 6650i=1,3
          wg(i)=-wg(i)
6650    continue
      endif
      do 6710i=1,3
        fm(i,nr)=wg(i)
        isww(i)=0
        sfm(i,nr)=0.
6710  continue
      isww(4)=0
      if(iesd) then
        isww(i1)=nint(sqrt(cz)*10000.)
        isww(i2)=nint(sqrt(cx)*10000.)
        pom3=w(i1)/w(i3)
        pom4=w(i2)/w(i3)
        pom=pom3**2*cz+pom4**2*cx+2.*pom3*pom4*cy
        isww(i3)=nint(sqrt(pom)*10000.)
        if(i1.eq.1) then
          sfm(1,nr)=cz
          sfm(2,nr)=cx
          sfm(3,nr)=cy*2.
        else if(i1.eq.2) then
          sfm(1,nr)=pom
          sfm(2,nr)=cz
          sfm(3,nr)=-2.*(pom3*cz+pom4*cy)
        else if(i1.eq.3) then
          sfm(1,nr)=cx
          sfm(2,nr)=pom
          sfm(3,nr)=-2.*(pom3*cy+pom4*cx)
        endif
      endif
      uu=-wg(i1)*avx-wg(i2)*avy-wg(i3)*avz
      chiq=0.
      do 6770i=1,n2
        xxx=xplane(i1,i)-avx
        yyy=xplane(i2,i)-avy
        zzz=xplane(i3,i)-avz
        vv=wg(i1)*xxx+wg(i2)*yyy+wg(i3)*zzz
        dx(i)=vv
        idx(i)=0
        if(iesd) then
          pom1=xxx-pom3*zzz
          pom2=yyy-pom4*zzz
          pom=pom1**2*cz+pom2**2*cx+2.*pom1*pom2*cy
          do 6760j=1,3
            pom=pom+(wg(j)*sxplane(j,i))**2
6760      continue
          idx(i)=nint(1000.*sqrt(pom))
          if(i.le.n1) chiq=chiq+vv**2*wt(i)
        endif
6770  continue
      if(iesd) then
        pom1=avx-pom3*avz
        pom2=avy-pom4*avz
        isww(4)=nint(sqrt(pom1**2*cz+pom2**2*cx+2.*pom1*pom2*cy)*10000.)
      endif
      write(lst,'(f8.4,''*x+('',f8.4,'')*y+('',f8.4,'')*z+('',f8.4,
     1            '') = 0.0   chiq ='',f8.2/3x,''('',i4,'')'',6x,
     2            2(''('',i4,'')'',7x),''('',i4,'')'')')
     3      wg,uu,chiq,isww
      ven='Atom name :'
      venp='Distance from plane :'
      venpp=' '
      l=22
      do 6900i=1,n2
        ven=ven(1:l+4)//(atplane(i)(1:8))
        if(idel(atplane(i)).gt.8) venpp=venpp(1:l+4)//(atplane(i)(9:16))
        write(venp(l+1:),'(f7.3,''('',i3,'')'')') dx(i),idx(i)
        l=l+12
        if(l.gt.117) then
          write(lst,FormA128) ven
          if(idel(venpp).gt.0) write(lst,FormA128) venpp
          write(lst,FormA128) venp
          ven=' '
          venp=' '
          l=22
        endif
6900  continue
      if(l.gt.22) then
        write(lst,FormA128) ven
        if(idel(venpp).gt.0) write(lst,FormA128) venpp
        write(lst,FormA128) venp
      endif
      go to 4100
7000  close(55,status='delete')
      if(nr.lt.2) go to 9000
      call NewPg(0)
      call newln(5)
      write(lst,'(/''Table of dihedral angles :''///)')
      do 8300i=1,nr
        call multm(MetTensI(1,isw,KPhase),fm(1,i),u,3,3,1)
        do 8200j=1,nr
          if(i.eq.j) then
            dx(j)=0.
            idx(j)=0
          else
            call multm(MetTensI(1,isw,KPhase),fm(1,j),v,3,3,1)
            pom=scalmul(fm(1,j),u)
            dx(j)=acos(pom)/torad
            pom1=v(1)-u(1)/u(3)*v(3)
            pom2=v(2)-u(2)/u(3)*v(3)
            pom3=u(1)-v(1)/v(3)*u(3)
            pom4=u(2)-v(2)/v(3)*u(3)
            idx(j)=nint(100.*sqrt((sfm(1,i)*pom1**2+sfm(2,i)*pom2**2+
     1                             sfm(3,i)*pom1*pom2+sfm(1,j)*pom3**2+
     2                             sfm(2,j)*pom4**2+sfm(3,j)*pom3*pom4)/
     3                             (1.-pom**2))/torad)
          endif
8200    continue
        write(lst,'(i5,8(f8.2,''('',i5,'')'')/6x,8(f8.2,''('',i5,
     1              '')'')/6x,4(f8.2,''('',i5,'')''))') i,
     2              (dx(j),idx(j),j=1,nr)
8300  continue
9000  call CloseIfOpened(lst)
      write(89,'(''end'')')
      call CloseIfOpened(89)
      call CloseIfOpened(m50)
      call FeShowListing(-1.,-1.,'DIST program','dis',10000,i)
9900  call DeleteFile(PreviousM40)
9910  if(ngc.ne.0) call DeleteFile(PreviousM50)
9999  return
      end
      subroutine DistTorsionAngle(AtTor,Radka)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      dimension xtor(3,4),xtorm(3,4),x4dif(3),tdif(3),nd(3),uxi(3,mxw),
     1          uyi(3,mxw),suxi(3,mxw),suyi(3,mxw),GammaIntInv(9),xp(3),
     2          xpp(3),t(3),sgx0(12),ish(3)
      character*(*) attor(4),Radka
      character*7 t7(4)
      character*8 At(4)
      character*80 t80
      character*128 ven
      k1=1
      do 1500i=1,4
        call AtSymSpec(attor(i),ia,xtor(1,i),x4dif,tdif,isym,icenter,
     1                 ish,ich)
        j=index(attor(i),'#')
        if(j.gt.0) then
          At(i)=attor(i)(:j-1)
        else
          At(i)=attor(i)
        endif
        if(ia.le.0) then
          t80='atom "'//attor(i)(:idel(attor(i)))//
     1        '" isn''t of the file M40'
          go to 9900
        else
          if(i.eq.1) then
            isw=iswa(ia)
          else
            if(isw.ne.iswa(ia)) then
              t80='atoms belong to different composite parts'
              go to 9900
            endif
          endif
        endif
        if(ich.eq.1) then
          t80='string contains non-numerical character'
          go to 9900
        else if(ich.eq.3) then
          t80='atom "'//attor(i)(:idel(attor(i)))//
     1        '" has incorrect symmetry part'
          go to 9900
        endif
        iais=iabs(isym)
        if(isym.gt.0) then
          icntrsm=1
        else
          icntrsm=2
        endif
        call ScodeCIF(iais,icntrsm,icenter,ish,isw,t7(i))
        if(ndim.le.3) go to 1400
        call GetGammaIntInv(isym,isw,KPhase,GammaIntInv)
        do 1150l=1,kmodx(ia)
          call multm (rm(1,iais,isw,KPhase), ux(1,l,ia), uxi(1,l),3,3,1)
          call multmq(rm(1,iais,isw,KPhase),sux(1,l,ia),suxi(1,l),3,3,1)
          if(l.ne.kmodx(ia).or.kfx(ia).eq.0) then
             call multm (rm(1,iais,isw,KPhase), uy(1,l,ia), uyi(1,l),3,
     1                   3,1)
             call multmq(rm(1,iais,isw,KPhase),suy(1,l,ia),suyi(1,l),3,
     1                   3,1)
          else
             call CopyVek( uy(1,l,ia), uyi(1,l),3)
             call CopyVek(suy(1,l,ia),suyi(1,l),3)
          endif
          if(isym.lt.0) then
            do 1100j=1,3
              uxi(j,l)=-uxi(j,l)
              if(l.ne.kmodx(ia).or.kfx(ia).eq.0) uyi(j,l)=-uyi(j,l)
1100        continue
          endif
1150    continue
        call AddVek(tfirst(1,isw),tdif,xpp,3)
        call multm(GammaIntInv,xpp,xp,ndimi,ndimi,1)
        call MakeOccMod(oall(1,i),qcnt(1,ia),xp,nt,dt,a0(ia),ax(1,ia),
     1                  ay(1,ia),kmods(ia),kfs(ia),GammaIntInv)
        if(kfx(ia).gt.0.and.kmodx(ia).gt.0)
     1    call MakeOccModSawTooth(oall(1,i),qcnt(1,ia),xp,nt,dt,
     2      uyi(1,kmodx(ia)),uyi(2,kmodx(ia)),kfx(ia),GammaIntInv)
        call MakePosMod(xdall(1,1,i),qcnt(1,ia),xp,nt,dt,uxi,uyi,
     1                  kmodx(ia),kfx(ia),GammaIntInv)
        call MakePosModS(sxdall(1,1,i),qcnt(1,ia),xp,nt,dt,uxi,uyi,suxi,
     1                   suyi,kmodx(ia),kfx(ia),GammaIntInv)
1400    call multmq(rm(1,iais,isw,KPhase),sx(1,ia),sgx(k1),3,3,1)
        k1=k1+3
1500  continue
      call CopyVek(sgx,sgx0,12)
      call TorsionAngle(xtor,isw,Angle,SAngle)
      if(VolaToDist) then
        j=1
        do 1600i=1,4
          write(ven(j:),FormA1)(attor(i)(k:k),k=1,idel(attor(i)))
          j=idel(ven)+1
          if(i.ne.4) then
            ven(j:j)='-'
          else
            ven(j:j+2)=' : '
            j=j+2
          endif
          j=j+1
1600    continue
        call DistRoundESD(Cislo,Angle,SAngle,2)
        i=idel(Cislo)
        ven(j:)=Cislo(:i)
        call newln(1)
        write(lst,FormA1)(Ven(i:i),i=1,idel(Ven))
        write(89,116) At,Angle,SAngle,(t7(i),i=1,4)
        if(ndim.le.3) go to 9999
      else
        call OpenFile(78,fln(:ifln)//'.scr','unformatted','unknown')
      endif
      dummx=-9999.
      dummn= 9999.
      dumav=0.
      sdumav=0.
      npom=0
      do 3000kt=1,ntall(isw)
        call RecUnpack(kt,nd,nt(1,isw),ndimi)
        do 2000k=1,ndimi
          t(k)=tfirst(k,isw)+(nd(k)-1)*dti(k)
2000    continue
        k1=1
        do 2100i=1,4
          if(oAll(kt,i).le.ocut) then
            oAll(kt,1)=0.
             dumkt=333.
            sdumkt=0.
            go to 2500
          endif
          call AddVek (xtor(1,i),xdall(1,kt,i),xtorm(1,i),3)
          call AddVekQ(sgx0(k1),sxdall(1,kt,i),sgx(k1),3)
2100    continue
        call TorsionAngle(xtorm,isw,dumkt,sdumkt)
2500    if(VolaToDist) then
          if(dumkt.lt.300.) then
            dum (kt)= dumkt
            dums(kt)=sdumkt
            if(dumkt.gt.dummx) then
               dummx= dumkt
              sdummx=sdumkt
            endif
            if(dumkt.lt.dummn) then
               dummn= dumkt
              sdummn=sdumkt
            endif
             dumav= dumav+ dumkt
            sdumav=sdumav+sdumkt
            npom=npom+1
          endif
        else
          write(78) kt,dumkt,oAll(kt,1)
        endif
3000  continue
      if(VolaToDist) then
        ven=' '
        l=1
        if(ieach.ne.0) then
          call newln(1)
          write(lst,'(''Individually:'')')
          do 4000kt=1,ntall(isw),ieach
            call RecUnpack(kt,nd,nt(1,isw),ndimi)
            do 3100i=1,ndimi
              t(i)=tfirsti(i)+(nd(i)-1)*dti(i)
3100        continue
            if(oi(kt).le.ocut) go to 4000
            call DistRoundESD(Cislo,dum(kt),dums(kt),2)
            write(ven(l:),'(f6.3,1x,a)') t(1),Cislo(:idel(Cislo))
            l=l+17
            if(l.gt.111) then
              call newln(1)
              write(lst,FormA1)(Ven(i:i),i=1,idel(Ven))
              l=1
            endif
4000      continue
          if(l.gt.1) then
            call newln(1)
            write(lst,FormA1)(Ven(i:i),i=1,idel(Ven))
          endif
        endif
        pom=1./float(npom)
         dumav= dumav*pom
        sdumav=sdumav*pom
        ven='Average : '
        call DistRoundESD(Cislo,dumav,sdumav,2)
        ven=ven(:idel(ven)+1)//Cislo(:idel(Cislo))
        ven=ven(:idel(ven))//', Minimum : '
        call DistRoundESD(Cislo,dummn,sdummn,2)
        ven=ven(:idel(ven)+1)//Cislo(:idel(Cislo))
        call newln(1)
        ven=ven(:idel(ven))//', Maximum : '
        call DistRoundESD(Cislo,dummx,sdummx,2)
        ven=ven(:idel(ven)+1)//Cislo(:idel(Cislo))
        call newln(1)
        write(lst,FormA1)(Ven(i:i),i=1,idel(Ven))
      endif
      go to 9999
9900  call FeChybne(-1.,-1.,Radka,t80,1,SeriousError)
9999  return
116   format('torsion: ',4(a8,1x),2f9.3/9x,4(a7,2x))
      end
      subroutine TorsionAngle(xtor,isw,Angle,SAngle)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      dimension w(3),wg(3),daw(3),dbu(3),dbv(3),dcv(3),dcw(3),dtw(3),
     1          xtor(3,4)
      do 5100i=1,3
        u(i)=xtor(i,2)-xtor(i,1)
        v(i)=xtor(i,3)-xtor(i,2)
        w(i)=xtor(i,4)-xtor(i,3)
5100  continue
      call multm(MetTens(1,isw,KPhase),u,ug,3,3,1)
      call multm(MetTens(1,isw,KPhase),v,vg,3,3,1)
      call multm(MetTens(1,isw,KPhase),w,wg,3,3,1)
      uu=scalmul(u,ug)
      uv=scalmul(u,vg)
      uw=scalmul(u,wg)
      vv=scalmul(v,vg)
      vw=scalmul(v,wg)
      ww=scalmul(w,wg)
      pa=uv*vw-uw*vv
      pb=uu*vv-uv**2
      pc=vv*ww-vw**2
      do 5200i=1,3
        dau(i)=vg(i)*vw-wg(i)*vv
        dav(i)=ug(i)*vw+wg(i)*uv-2.*vg(i)*uw
        daw(i)=vg(i)*uv-ug(i)*vv
        dbu(i)=2.*(ug(i)*vv-vg(i)*uv)
        dbv(i)=2.*(vg(i)*uu-ug(i)*uv)
        dcv(i)=2.*(vg(i)*ww-wg(i)*vw)
        dcw(i)=2.*(wg(i)*vv-vg(i)*vw)
5200  continue
      pom1=1./(pb*pc)
      pom2=-1./sqrt(1.-pa**2*pom1)
      pom1=sqrt(pom1)
      Angle=acos(pa*pom1)/torad
      pom2=pom2*pom1
      pom3=pa*.5/pb
      pom4=pa*.5/pc
      do 5300i=1,3
        dtu(i)=pom2*(dau(i)-pom3*dbu(i))
        dtv(i)=pom2*(dav(i)-pom3*dbv(i)-pom4*dcv(i))
        dtw(i)=pom2*(daw(i)-pom4*dcw(i))
5300  continue
      do 5400i=1,3
        ddx(i)=-dtu(i)
        ddx(i+3)=dtu(i)-dtv(i)
        ddx(i+6)=dtv(i)-dtw(i)
        ddx(i+9)=dtw(i)
5400  continue
      SAngle=sigma(sgx,ddx,12)/torad
      if(u(1)*v(2)*w(3)+u(3)*v(1)*w(2)+u(2)*v(3)*w(1)-
     1   u(3)*v(2)*w(1)-u(1)*v(3)*w(2)-u(2)*v(1)*w(3).lt.0.)
     2   Angle=-Angle
      return
      end
      subroutine round(x,sx,n)
      if(sx.eq.0.) go to 9999
      if(n) 1000,9999,1000
 1000 f=1.
 1500 isx=sx*f+.05
      if(isx) 9999,1800,3000
 1800 f=f*10.
      go to 1500
 3000 sx=anint(sx*f)/f
      x=anint(x*f)/f
 9999 return
      end
      function sigma(sx,dx,n)
      dimension sx(n),dx(n)
      s=0.
      do 1000i=1,n
        s=s+(sx(i)*dx(i))**2
1000  continue
      sigma=sqrt(s)
      return
      end
      subroutine DefaultDist
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      NactiInt=20
      NactiReal=20
      NactiComposed=20
      NactiKeys=NactiInt+NactiReal+NactiComposed
      if(ndimi.le.1) then
        DefIntDist(nCmdieach)=10
      else
        DefIntDist(nCmdieach)=1
      endif
      call CopyVekI(DefIntDist,NacetlInt   ,NactiInt)
      call CopyVekI(DefIntDist,DefaultInt  ,NactiInt)
      call CopyVekI(DefIntDist,CmdIntDist,NactiInt)
      i=NactiInt+1
      call CopyVek(DefRealDist(i),NacetlReal(i) ,NactiReal)
      call CopyVek(DefRealDist(i),DefaultReal(i),NactiReal)
      call CopyVek(DefRealDist(i),CmdRealDist, NactiReal)
      do 1200i=1,NactiKeys
        NactiKeywords(i)=IdDist(i)
1200  continue
      RejectIdentical=1
      if(ndim.eq.4) then
        j=100
      else
        j=20
      endif
      call SetIntArrayTo(nt,9,j)
      call SetRealArrayTo(tfirst,9,0.)
      call SetRealArrayTo(tlast,9,1.)
      nBondVal=0
      call SetIntArrayTo(iBondVal,225,0)
      call SetRealArrayTo(dBondVal,225,0.)
      iselPrvni=0
      iselDruhyATreti=0
      return
      end
      subroutine NactiDist
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      dimension ip(2),xp(1)
      call OpenFile(m50,fln(:ifln)//'.l51','formatted','old')
      call Najdi('dist',i)
      if(i.ne.1) go to 9999
      i=NactiInt+NactiReal+2
      call SetIntArrayTo(NactiRepeat,i,0)
      call SetIntArrayTo(NactiRepeat(i+1),NactiKeys-i,-1)
      PreskocVykricnik=.true.
1100  call NactiCommon(m50,izpet)
      if(ErrJana.ne.0) go to 9999
1110  if(izpet.eq.0) then
        call CopyVekI(NacetlInt ,CmdIntDist ,NactiInt)
        call CopyVek (NacetlReal(NactiInt+1),CmdRealDist,NactiReal)
        go to 9999
      else if(izpet.eq.nCmdnooft) then
        do 2010i=1,ndimi
          call kus(NactiVeta,PosledniPozice,Cislo)
          call posun(Cislo,0)
          read(Cislo,FormI15) nt(i,1)
2010    continue
      else if(izpet.eq.nCmdtFirst.or.izpet.eq.nCmdtzero) then
        call StToReal(NactiVeta,PosledniPozice,tfirst,ndimi,.false.,ich)
        if(ich.ne.0) go to 8000
      else if(izpet.eq.nCmdtlast) then
        call StToReal(NactiVeta,PosledniPozice,tlast,ndimi,.false.,ich)
        if(ich.ne.0) go to 8000
      else if(izpet.eq.nCmdselect.or.izpet.eq.nCmdSelfirst) then
2100    iselPrvni=iselPrvni+1
        call kus(NactiVeta,PosledniPozice,aselPrvni(iselPrvni))
        call uprat(aselPrvni(iselPrvni))
        if(PosledniPozice.ne.80) go to 2100
      else if(izpet.eq.nCmdSelsecnd) then
2200    iselDruhyATreti=iselDruhyATreti+1
        call kus(NactiVeta,PosledniPozice,
     1           aselDruhyATreti(iselDruhyATreti))
        call uprat(aselDruhyATreti(iselDruhyATreti))
        if(PosledniPozice.ne.80) go to 2200
      else if(izpet.eq.nCmdtorsion.or.izpet.eq.nCmdplane) then
        backspace m50
        call OpenFile(55,fln(:ifln)//'_torpl.tmp','formatted','unknown')
3000    read(m50,FormA80,end=3100) NactiVeta
        write(55,FormA80) NactiVeta
        go to 3000
3100    izpet=0
        go to 1110
      else if(izpet.eq.nCmdbondval) then
        n=nBondVal+1
        call StToInteger(NactiVeta,PosledniPozice,ip,2,.false.,ich)
        if(ich.ne.0) go to 8000
        call StToReal(NactiVeta,PosledniPozice,xp,1,.false.,ich)
        if(ich.ne.0) go to 8000
        dBondVal(ip(1),ip(2))=xp(1)
        dBondVal(ip(2),ip(1))=xp(1)
        iBondVal(ip(1),ip(2))=1
        iBondVal(ip(2),ip(1))=1
        nBondVal=n
        go to 1100
      endif
      if(izpet.ne.0) go to 1100
8000  PosledniPozice=80
9000  call ChybaNacteni(izpet)
      go to 1100
9999  call CloseIfOpened(m50)
      return
102   format(f15.5)
      end
      subroutine inm40(iesd)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      dimension xp(6),xpp(6),sngc(mxw,24,mxa),csgc(mxw,24,mxa),
     1          GammaIntInv(9)
      logical iesd
      call iom40(0,0)
      if(ErrJana.eq.-1) then
        call CrlbCorrectAtomNames(ich)
        if(ich.ne.0) then
          ErrJana=1
          go to 9999
        endif
      else if(ErrJana.ne.0) then
        go to 9999
      endif
      call CopyVek(x,xdst,3*nacalc)
      call CopyVek(beta,betadst,6*nacalc)
      if(ndim.gt.3) then
        call trorthos(0)
        if(kcommen.gt.0.and.VolaToDist) then
          nacalcp=nacalc
          call comsym(0,1)
          call comexp(sngc,csgc)
          if(ErrJana.ne.0) go to 9999
          call specat
          n=nacalcp
          do 5000j=1,ngc
            do 4000i=1,nacalcp
              if(kswa(i).ne.KPhase) go to 4000
              isw=iswa(i)
              n=n+1
              call qbyx(x(1,n),qcnt(1,n),isw)
              call CopyVek(xdst(1,i),xp,3)
              call SetRealArrayTo(xp(4),ndimi,0.)
              call multm(rm6gc(1,j,isw,KPhase),xp,xpp,ndim,ndim,1)
              call multmq(rmgc(1,j,isw,KPhase),sx(1,i),sx(1,n),3,3,1)
              do 2200k=1,3
                xdst(k,n)=xpp(k)+sgc(k,j,isw,KPhase)
2200          continue
              call multm(rtgc(1,j,isw,KPhase),betadst(1,i),betadst(1,n),
     1                   6,6,1)
              call multmq(rtgc(1,j,isw,KPhase),sbeta(1,i),sbeta(1,n),
     1                    6,6,1)
              do 2400k=1,kmodx(i)
                if(kfx(i).ne.1.or.k.ne.kmodx(i)) then
                  call multmq(rmgc(1,j,isw,KPhase),sux(1,k,i),sux(1,k,n)
     1                        ,3,3,1)
                  call multmq(rmgc(1,j,isw,KPhase),sux(1,k,i),sux(1,k,n)
     1                        ,3,3,1)
                else
                  call CopyVek(sux(1,k,i),sux(1,k,n),3)
                  call CopyVek(suy(1,k,i),suy(1,k,n),3)
                endif
2400          continue
4000        continue
5000      continue
        endif
      endif
      iesd=.true.
      s=0.
      call UnitMat(GammaIntInv,ndimi)
      do 6000i=1,nacalc
        if(kswa(i).ne.KPhase) go to 6000
        dxm(i)=0.
        if(ndim.gt.3) then
          isw=iswa(i)
          call MakeOccMod(oi,qcnt(1,i),tfirst(1,isw),nt(1,isw),
     1                    dt(1,isw),a0(i),ax(1,i),ay(1,i),kmods(i),
     2                    kfs(i),GammaIntInv)
          if(kfx(i).gt.0.and.kmodx(i).gt.0)
     1      call MakeOccModSawTooth(oi,qcnt(1,i),tfirst(1,isw),
     2        nt(1,isw),dt(1,isw),uy(1,kmodx(i),i),uy(2,kmodx(i),i),
     3        kfx(i),GammaIntInv)
          call MakePosMod(xdi,qcnt(1,i),tfirst(1,isw),nt(1,isw),
     1      dt(1,isw),ux(1,1,i),uy(1,1,i),kmodx(i),kfx(i),GammaIntInv)
          do 5200j=1,nt(1,isw)
            do 5100k=1,3
              xdi(k,j)=xdi(k,j)+x(k,i)-xdst(k,i)
5100        continue
            if(oi(j).le.ocut) go to 5200
            call multm(MetTens(1,isw,KPhase),xdi(1,j),xp,3,3,1)
            dxm(i)=max(dxm(i),sqrt(scalmul(xdi(1,j),xp)))
5200      continue
        endif
        s=s+sx(1,i)+sx(2,i)+sx(3,i)
6000  continue
      iesd=s.gt.0.
9999  return
      end
      subroutine DistAng(u,ug,vg,uu,vv,sgx,angle,su)
      include 'params.cmn'
      include 'basic.cmn'
      dimension sgx(9),u(3),ug(3),vg(3),dtu(3),dtv(3),ddx(9)
      angle=0.
      su=0.
      uv=scalmul(u,vg)
      pom=sqrt(uu*vv)
      if(abs(pom).lt..0001) go to 9999
      angle=uv/pom
      if(abs(angle).gt..999999) then
        angle=90.-sign(90.,angle)
        go to 9999
      endif
      if(abs(angle).lt..0001) then
        angle=90.
        go to 9999
      endif
      pom=1./(pom*(sqrt(1.-angle**2)*torad))
      angle=acos(angle)/torad
      do 1000l=1,3
        dtu(l)=pom*(vg(l)-ug(l)*uv/uu)
        dtv(l)=pom*(ug(l)-vg(l)*uv/vv)
        ddx(l)=-dtu(l)-dtv(l)
        ddx(l+3)=dtu(l)
        ddx(l+6)=dtv(l)
1000  continue
      su=sigma(sgx,ddx,9)
9999  return
      end
      subroutine inclat
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      character*80 t80,p80
      logical Exist
      if(incl.eq.0) go to 9999
      if(incl.ne.2) then
        inquire(file=fln(1:ifln)//'.m48',exist=exist)
        if(.not.exist) then
          incl=incl-1
          if(incl.ne.0) incl=2
        endif
      endif
      if(incl.ge.2) then
        inquire(file=fln(1:ifln)//'.m47',exist=exist)
        if(.not.exist) then
          incl=incl-2
          if(incl.ne.0) incl=1
        endif
      endif
      if(incl.gt.0) then
        call newln(1)
        if(incl.eq.1) then
          write(lst,'(''Positive peaks from the previous Fourier '',
     1                ''calculation will be included'')')
        else if(incl.eq.2) then
          write(lst,'(''Negative peaks from the previous Fourier '',
     1                ''calculation will be included'')')
        else
          write(lst,'(''Both positive and negative peaks from the '',
     1                ''previous Fourier calculation will be included'')
     2                 ')
        endif
      else
        return
      endif
      l1=1
      l2=1
      if(incl.ge.2) then
        l2=2
        if(incl.eq.2) l1=2
      endif
      do 1500l=l1,l2
        m4=49-l
        t80=fln(1:ifln)//'.m'
        i=idel(t80)+1
        write(t80(i:i+1),'(i2)') m4
        call OpenFile(m4,t80(1:i+1),'formatted','unknown')
        if(ErrJana.ne.0) go to 1500
        read(m4,'(i5,15x,2i5)') n,isw,KPh
        KPh=max(KPh,1)
        if(KPh.ne.KPhase) go to 1500
        read(m4,'(f9.6)')(TOverAll,i=1,4)
        if(nacalc+n.gt.mxa) then
          if(l.eq.1) then
            Cislo='maxima'
          else
            Cislo='minima'
          endif
          t80='the number included '//Cislo(:6)//' from Fourier '//
     1        'calculation'
          n=mxa-nacalc
          write(Cislo,'(i3)') n
          call zhusti(Cislo)
          p80='reduced to '//Cislo(:idel(Cislo))//' to not exceed '//
     1        'maximal number of atoms'
          call FeChybne(-1.,-1.,t80,p80,1,SeriousError)
        endif
        do 1400i=nacalc+1,nacalc+n
          read(m4,'(a8,2i3,4x,4f9.6,6x,3i1,3i3/f9.6)') atom(i),isf(i),
     1                    itf(i),ai(i),(xdst(k,i),k=1,3),j,j,j,j,
     2                    kmodx(i),j,TOverAll
          iswa(i)=isw
          kswa(i)=KPh
          call CopyVek(xdst(1,i),x(1,i),3)
          call SetRealArrayTo(sx(1,i),3,0.)
          call qbyx(x(1,i),qcnt(1,i),isw)
          call SetRealArrayTo( beta(1,i),6,0.)
          call SetRealArrayTo(sbeta(1,i),6,0.)
          do 1300j=1,kmodx(i)
            read(m4,101)(ux(k,j,i),k=1,3),(uy(k,j,i),k=1,3)
1300      continue
          if(kmodx(i).ne.0) read(m4,101) TOverAll
1400    continue
        call CloseIfOpened(m4)
        nacalc=nacalc+n
1500  continue
      call specat
9999  return
101   format(6f9.6)
      end
      subroutine deleq
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      logical IdenticalAtoms
      call newln(1)
      write(lst,FormA1)
      do 1000j=1,nacalc
        BratDruhyATreti(j)=BratDruhyATreti(j).and.ai(j).gt.0.
        BratPrvni(j)=BratPrvni(j).and.ai(j).gt.0.
1000  continue
      if(RejectIdentical.eq.1) then
        do 1160i=1,nacalc-1
          do 1150j=i+1,nacalc
            if(IdenticalAtoms(i,j,.001).and.BratPrvni(i)) then
              call newln(1)
              write(lst,'(''The atom '',a8,'' deleted from the '',
     1                    ''distance calculation as coincides with : '',
     2                    a8)') atom(j),atom(i)
              BratPrvni(j)=.false.
              BratDruhyATreti(j)=.false.
            endif
1150      continue
1160    continue
      endif
      return
      end
      subroutine pisat
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      dimension xp(3)
      logical eqwild,lpomPrvni,lpomDruhyATreti
      character*80 FormOut
      character*8 at
      character*1 znak1,znak2
      data
     1  FormOut/'(i3,2x,a8,a1,1x,a1,6f10.6,3f9.4,f6.2,''('',i3,'')'')'/
      lpomPrvni=iselPrvni.le.0
      lpomDruhyATreti=iselDruhyATreti.le.0
      call inclat
      call addspec
      do 1000j=1,nacalc
        BratPrvni(j)=lpomPrvni
        BratDruhyATreti(j)=lpomDruhyATreti
1000  continue
      if(iselPrvni.gt.0) then
        fullcoo=1
        do 1020i=1,iselPrvni
          if(index(aselPrvni(i),'*').ne.0) then
            do 1010j=1,nacalc
              lpomPrvni=eqwild(atom(j),aselPrvni(i))
              BratPrvni(j)=(BratPrvni(j).or.lpomPrvni).and.
     1                      kswa(j).eq.KPhase
1010        continue
          else
            j=ktat(atom,nacalc,aselPrvni(i))
            if(j.le.0) then
              at=aselPrvni(i)
              k=min(idel(at),7)
              at=at(:k)//''''
              j=ktat(atom,nacalc,at)
            endif
            lpomPrvni=j.gt.0
            BratPrvni(j)=(BratPrvni(j).or.lpomPrvni).and.
     1                    kswa(j).eq.KPhase
          endif
1020    continue
      endif
      if(iselDruhyATreti.gt.0) then
        do 1040i=1,iselDruhyATreti
          if(index(aselDruhyATreti(i),'*').ne.0) then
            do 1030j=1,nacalc
              lpomDruhyATreti=eqwild(atom(j),aselDruhyATreti(i))
              BratDruhyATreti(j)=
     1          (BratDruhyATreti(j).or.lpomDruhyATreti).and.
     2           kswa(j).eq.KPhase
1030        continue
          else
            j=ktat(atom,nacalc,aselDruhyATreti(i))
            if(j.le.0) then
              at=aselDruhyATreti(i)
              k=min(idel(at),7)
              at=at(:k)//''''
              j=ktat(atom,nacalc,at)
            endif
            lpomDruhyATreti=j.gt.0
            BratDruhyATreti(j)=
     1        (BratDruhyATreti(j).or.lpomDruhyATreti).and.
     2         kswa(j).eq.KPhase
          endif
1040    continue
      endif
      if(ngc.gt.0) then
        n=nagcOff(KPhase)
        do 1200j=1,ngc
          do 1150i=1,nacalcb
            if(kswa(i).ne.KPhase) go to 1150
            n=n+1
            BratPrvni(n)=BratPrvni(i)
            BratDruhyATreti(n)=BratDruhyATreti(i)
1150      continue
1200    continue
      endif
      call deleq
      call RestorePhase(KPhaseBasic)
      call newln(3)
      write(lst,'(/38x,''fractional'',36x,''cartesian'')')
      if(lite.eq.1) then
        write(lst,'('' no'',2x,''atom'',10x,''xf'',8x,''yf'',8x,''zf'',
     1              5x,''sigxf'',5x,''sigyf'',5x,''sigzf'',8x,''x'',8x,
     2              ''y'',8x,''z'',6x,''Biso'')')
        FormOut(34:36)='6.2'
      else
        write(lst,'('' no'',2x,''atom'',10x,''xf'',8x,''yf'',8x,''zf'',
     1              5x,''sigxf'',5x,''sigyf'',5x,''sigzf'',8x,''x'',8x,
     2              ''y'',8x,''z'',6x,''Uiso'')')
        FormOut(34:36)='8.4'
      endif
      do 1500i=1,nacalc
        m=isf(i)
        if(m.eq.0.or.kswa(i).ne.KPhase) go to 1500
        call CopyVek(sx(1,i),sxp(1,i),3)
        do 1400j=1,3
          call round(xdst(j,i),sx(j,i),irnd)
1400    continue
        if(itf(i).eq.1) then
          if(lite.eq.0) then
            bizo=beta(1,i)/episq
            pom=sbeta(1,i)/episq
          else
            bizo=beta(1,i)
            pom=sbeta(1,i)
          endif
        else
          call boueq(betadst(1,i),sbeta(1,i),lite,bizo,pom,1)
        endif
        call MultM(TrToOrtho(1,1,KPhase),xdst(1,i),xp,3,3,1)
        if(BratPrvni(i)) then
          znak1='+'
        else
          znak1='-'
        endif
        if(BratDruhyATreti(i)) then
          znak2='+'
        else
          znak2='-'
        endif
        call newln(1)
        write(lst,FormOut) i,atom(i),znak1,znak2,(xdst(j,i),j=1,3),
     1                     (sx(j,i),j=1,3),xp,bizo,nint(pom*100.)
1500  continue
      return
      end
      subroutine distat
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      dimension y0(3),y1(3),y2(3),uz(3),shj(3),shjc(3),umg(3),sx0(6),
     1          uxj(3,mxw),uyj(3,mxw),y0p(6),y1p(3),y2p(3),uzp(3),up(3),
     2          jsh(3),WPr(36),WPri(36),gw4(9),nvx(3),nvy(3),nvz(3),
     3          y3(6),y3p(6),yp(6),ypp(6),idtab(30),iptab(30),nutab(30),
     4          utab(30,30),tztnat(3),dttnat(3),GammaIntInv(9),ts(3),
     5          xp(3),t(3),nd(3),suxj(3,mxw),suyj(3,mxw),sgxm(6),
     6          dstab(30),sutab(30,30),ZdPr(9),gww(9),gwwi(9),TNaT(9),
     7          TNaTi(9),tmina(3),dmod(6)
      character*128 ltab(500)
      character*80 t80,s80
      character*40 t40
      character*8 at1,at2,at3,attab(30),atutab(30,30),sp8
      character*7 t7,t71,t72,t73
      character*2 nty,sp2,Label,Lab2,Lab3
      logical iuhl0,Prvne,Konec,Nacitame,JeToUhel
      equivalence (dmod(1),dumav),(dmod(2),sdumav),
     1            (dmod(3),dummn),(dmod(4),sdummn),
     2            (dmod(5),dummx),(dmod(6),sdummx)
      data sp2,sp8/2*' '/
      iswji=0
      iswki=0
      call SetRealArrayTo(dmd,nf,dmdk)
      if(dmhk.ge.0.) then
        call SetRealArrayTo(dmh,nf,dmhk)
      else
        call CopyVek(AtRadius(1,KPhase),dmh,nf)
      endif
      pom=0.
      do 1100i=1,nf
        if(dmh(i).lt.dmd(i)) dmh(i)=0.
        pom=pom+dmh(i)
1100  continue
      iuhl0=iuhl.eq.0
      if(VolaToDist) then
        if(pom.le.0.) then
          call newln(2)
          write(lst,'(/''Distances and angles will not be calculated'')
     1                ')
          go to 9999
        endif
        do 1110i=1,mxl4
         iven(i)=' '
1110    continue
        call newln(4)
        if(fullcoo.eq.1) then
          write(lst,'(/''Full coordination of atoms will be printed'')')
        else
          write(lst,'(/''Reduced coordination of atoms will be printed''
     1                )')
        endif
        if(iuhl0) then
          write(lst,'(''Distances will be calculated''/)')
        else
          write(lst,'(''Distances and angles will be calculated''/)')
        endif
        if(ndim.gt.3.and.nt(1,1).gt.0.and.ieach.ne.0) then
          do 1150i=1,ndimi
            write(t80,'(''<'',f9.3,'','',f9.3,''>'')')
     1        tfirst(i,1),tlast(i,1)
            call zhusti(t80)
            call newln(1)
            write(lst,'(10x,''for '',a1,'' from the interval '',a,
     1                  '' at '',i3,'' equidistant steps'')')
     2        smbt(i),t80(:idel(t80)),nt(i,1)
1150      continue
          call newln(1)
          if(ieach.eq.1) then
            write(lst,'(10x,''Each step will be printed'')')
          else if(ieach.eq.0) then
            write(lst,'(10x,''Print of steps supressed'')')
          else
            write(lst,'(10x,''Only each'',i3,a2,'' step will be '',
     1                  ''printed'')') ieach,nty(ieach)
          endif
        endif
        call newln(nf+1)
        write(lst,FormA80)
        write(lst,'(''Limits for atom type : '',a7,'' from '',f6.3,
     1              '' to '',f6.3)')(AtTypeFull(l,KPhase),dmd(l),dmh(l),
     2              l=1,nf)
        call newln(1)
        write(lst,FormA80)
        if(line.gt.40) then
          call newpg(0)
          mxl=mxl4
        else
          mxl=mxl4-(line-3)*4
        endif
        line=0
        call OpenFile(61,fln(:ifln)//'.m61','formatted','unknown')
        if(ErrJana.ne.0) go to 9999
        call OpenFile(88,fln(:ifln)//'.l62','unformatted','unknown')
        if(ErrJana.ne.0) go to 9999
      endif
      call OpenFile(78,fln(:ifln)//'.l61','unformatted','unknown')
      if(ErrJana.ne.0) go to 9999
      i=nacalc
      if(fullcoo.eq.1) then
        i=i*nacalc
      else
        i=(i*(nacalc+1))/2
      endif
      if(VolaToDist) call FeFlowChartOpen(-1.,-1.,1,i,
     1                                 'Distance calculation',' ',' ')
      nfloat=0
      n61=0
      do 4100i=1,nacalc
        if(kswa(i).ne.KPhase) go to 4100
        l=isf(i)
        iswi=iswa(i)
        call SpecPos(x(1,i),iswi,.01,n)
        aii=ai(i)*float(n)
        if(.not.BratPrvni(i).or.l.le.0) then
          if(VolaToDist) then
            if(fullcoo.eq.1) then
              nfloat=nfloat+nacalc-1
            else
              nfloat=nfloat+i-1
            endif
            call FeFlowChartEvent(nfloat,ie)
            if(ie.ne.0) then
              call DistBudeBreak
              if(ErrJana.ne.0) go to 9900
            endif
          endif
          go to 4100
        endif
        dmdi=dmd(l)
        dmhi=dmh(l)
        ah=rcp(1,iswi,KPhase)
        bh=rcp(2,iswi,KPhase)
        ch=rcp(3,iswi,KPhase)
        call SetRealArrayTo(tfirsti,3,0.)
        call SetRealArrayTo(dti,3,0.)
        call SetIntArrayTo(nti,3,0)
        call CopyVek(tfirst(1,iswi),tfirsti,ndimi)
        call CopyVek (dt(1,iswi),dti,ndimi)
        call CopyVekI(nt(1,iswi),nti,ndimi)
        call bunka(xdst(1,i),x1,0)
        do 1200l=1,3
          x1p(l)=x(l,i)
1200    continue
        call qbyx(x1,x1(4),iswi)
        t80='x,y,z#'
        t7='.'
        write(78) '#1',atom(i),isf(i),aii,(0.,m=1,6),t80,t7,1
        n61=n61+1
        if(VolaToDist) then
          write(88) '#1',atom(i),isf(i),aii,(0.,m=1,6),t80,t7,1
          if(iuhl0) then
            write(61,'(''Distances concerning atom '',a8/34(''=''))')
     1            atom(i)
          else
            write(61,'(''Distances and angles concerning atom '',a8/
     1                 45(''=''))') atom(i)
          endif
          call fflush
          line=line+1
          write(iven(line),102)
          call fflush
          line=line+1
          write(iven(line),103) atom(i)
          call fflush
          line=line+1
          write(iven(line),102)
          call fflush
        endif
        call CopyVek(sx(1,i),sgx(1),3)
        if(ntall(iswi).gt.0.and.ndim.gt.3) then
          call UnitMat(GammaIntInv,ndimi)
          call MakeOccMod(oi,qcnt(1,i),tfirsti,nti,dti,a0(i),ax(1,i),
     1                    ay(1,i),kmods(i),kfs(i),GammaIntInv)
          if(kfx(i).gt.0.and.kmodx(i).gt.0)
     1      call MakeOccModSawTooth(oi,qcnt(1,i),tfirsti,nti,dti,
     2        uy(1,kmodx(i),i),uy(2,kmodx(i),i),kfx(i),GammaIntInv)
          call MakePosMod(xdi,qcnt(1,i),tfirsti,nti,dti,ux(1,1,i),
     1      uy(1,1,i),kmodx(i),kfx(i),GammaIntInv)
          call MakePosModS(sxdi,qcnt(1,i),tfirsti,nti,dti,ux(1,1,i),
     1                     uy(1,1,i),sux(1,1,i),suy(1,1,i),kmodx(i),
     2                     kfx(i),GammaIntInv)
        endif
        if(fullcoo.eq.1) then
          jp=1
        else
          jp=i
        endif
        do 4000j=jp,nacalc
          if(.not.BratDruhyATreti(j).or.kswa(j).ne.KPhase) go to 4000
          iswj=iswa(j)
          call SpecPos(x(1,j),iswj,.01,n)
          aij=ai(j)*float(n)
          if(VolaToDist) then
            call FeFlowChartEvent(nfloat,ie)
            if(ie.ne.0) then
              call DistBudeBreak
              if(ErrJana.ne.0) go to 9900
            endif
          endif
          l=isf(j)
          if(l.eq.0) go to 4000
          iswjin=iswi*10+iswj
          if(iswj.ne.iswi) then
            if(iswjin.ne.iswji) then
              call multm(zv(1,iswi,KPhase),zvi(1,iswj,KPhase),WPr,ndim,
     1                   ndim,ndim)
              call matinv(WPr,WPri,det,ndim)
              ii=ndim*3+1
              ndc=0
              ntc=0
              do 2010jj=1,3*ndimi,3
                do 2005l=0,2
                  if(abs(WPr(ii+l)).gt.0.) then
                    ndc=ndc+1
                    if(ndc.gt.1) then
                      call FeChybne(-1.,-1.,
     1                  'distance calculation for such a structure not '
     2                //'yet implemented',
     3                  'Please contact the authors',0,FatalError)
                      call FeFlowChartRemove
                      ErrJana=1
                      go to 9900
                    endif
                    call CopyVek(WPr(ii),ZdPr(1),3)
                    ntc=(jj-1)/3+1
                  endif
2005            continue
                ii=ii+ndim
2010          continue
2014          xdmn=tfirsti(ntc)
              xdmx=tfirsti(ntc)+dti(ntc)*float(nti(ntc)-1)
              ii=ndim*(2+ntc)
              do 2020l=1,3
                nvz(l)=nint(WPri(l+ii))
2020          continue
              kolik=0
              do 2030l=1,3
                nvx(l)=0
                nvy(l)=0
                if(nvz(l).ne.0) then
                  kolik=kolik+1
                  kdeneni=l
                else
                  kdeje=l
                endif
2030          continue
              if(kolik.eq.3) then
                nvx(1)=1
                nvy(2)=1
              else if(kolik.eq.2) then
                nvx(mod(kdeje-1,3)+1)=1
                nvy(mod(kdeje,3)+1)=1
              else
                nvx(mod(kdeneni,3)+1)=1
                nvy(mod(kdeneni+1,3)+1)=1
              endif
              call Multm(MetTens(1,iswi,KPhase),ZdPr,gw4,3,3,ndc)
              call Multm(ZdPr,gw4,gww,ndc,3,ndc)
              call MatInv(Gww,Gwwi,pom,ndc)
              call multm(qu(1,ntc,iswi,KPhase),ZdPr,tnat,ndc,3,ndc)
              jj=0
              if(ntc.eq.1) then
                ii=2*ndim+3
              else if(ntc.eq.2) then
                ii=3*ndim+4
              else if(ntc.eq.3) then
                ii=4*ndim+5
              endif
              do 2040l=1,ndc
                ii=ii+ndim
                do 2037k=1,ndc
                  jj=jj+1
                  ii=ii+1
                  tnat(jj)=WPr(ii)-tnat(jj)
2037            continue
2040          continue
              call matinv(TNaT,TNaTi,pom,ndc)
            endif
          else
            ndc=1
            ntc=1
            call UnitMat(TNaT ,ndc)
            call UnitMat(TNaTi,ndc)
          endif
          iswji=iswjin
          call CopyVek(tfirsti,TzTNaT,ndimi)
          call CopyVek(dti   ,DtTNaT,ndimi)
          call multm(TNaTi,tfirsti(ntc),TzTNaT,ndc,ndc,ndc)
          call multm(TNaTi,dti   (ntc),DtTNaT,ndc,ndc,ndc)
          dmhij=dmhi+dxm(i)+dxm(j)
          dmhija=dmhij*ah
          dmhijb=dmhij*bh
          dmhijc=dmhij*ch
          dmhijq=dmhij**2
          dmdijq=dmdi**2
          mxcellx=dmhij*rcp(1,iswj,KPhase)+1
          mxcelly=dmhij*rcp(2,iswj,KPhase)+1
          mxcellz=dmhij*rcp(3,iswj,KPhase)+1
          do 2050l=1,3
            y0(l)=xdst(l,j)
            y0p(l)=x(l,j)
            sx0(l)=sx(l,j)
2050      continue
          js=0
          jst=0
          do 3900jsym=1,ns
            call multm(rm(1,jsym,iswj,KPhase),y0,y1,3,3,1)
            call multm(rm(1,jsym,iswj,KPhase),y0p,y1p,3,3,1)
            call multmq(rm(1,jsym,iswj,KPhase),sx0,sgx(4),3,3,1)
            call GetGammaIntInv(jsym,iswj,KPhase,GammaIntInv)
            do 2100l=1,3
              y1(l)=y1(l)+s6(l,jsym,iswj,KPhase)
              y1p(l)=y1p(l)+s6(l,jsym,iswj,KPhase)
2100        continue
            do 3800jcntrsm=1,3-ncs
              js=js+1
              if(isa(js,j).le.0) go to 3800
              if(jcntrsm.ne.1) then
                call GetGammaIntInv(-jsym,iswj,KPhase,GammaIntInv)
                do 2200l=1,3
                  y1(l)=-y1(l)+s6(l,jsym,iswj,KPhase)*2.
                  y1p(l)=-y1p(l)+s6(l,jsym,iswj,KPhase)*2.
2200            continue
              endif
              do 3700jcenter=1,nvt
                do 2300l=4,ndim
                  ts(l-3)=-s6(l,jsym,iswj,KPhase)
     1                    -vt6(l,jcenter,iswj,KPhase)
2300            continue
                do 2305l=1,3
                  y2(l)=y1(l)+vt6(l,jcenter,iswj,KPhase)
                  y2p(l)=y1p(l)+vt6(l,jcenter,iswj,KPhase)
2305            continue
                if(iswj.eq.iswi) then
                  call bunka(y2,shj,1)
                  do 2310l=1,3
                    uzp(l)=y2p(l)-x1p(l)+shj(l)
                    uz(l)=y2(l)-x1(l)
2310              continue
                else
                  call multm(WPri,x1,yp,ndim,ndim,1)
                  do 2320l=1,3
                    shj(l)=yp(l)-y2(l)
2320              continue
                  do 2330l=1,3
                    shj(l)=ifix(shj(l))
                    y2(l)=y2(l)+shj(l)
                    y2p(l)=y2p(l)+shj(l)
2330              continue
                endif
                do 3600jcellx=-mxcellx,mxcellx
                  cellxj=jcellx
                  if(iswj.eq.iswi) then
                    pom=uz(1)+cellxj
                    if(abs(pom).gt.dmhija) go to 3600
                    u(1)=pom
                    up(1)=uzp(1)+cellxj
                    y2(1)=y2(1)+cellxj
                    y2p(1)=y2p(1)+cellxj
                    jsh(1)=nint(shj(1))+jcellx
                    shjc(1)=shj(1)+cellxj+s6(1,jsym,iswj,KPhase)+
     1                      vt6(1,jcenter,iswj,KPhase)
                  endif
                  do 3500jcelly=-mxcelly,mxcelly
                    cellyj=jcelly
                    if(iswj.eq.iswi) then
                      pom=uz(2)+cellyj
                      if(abs(pom).gt.dmhijb) go to 3500
                      u(2)=pom
                      up(2)=uzp(2)+cellyj
                      y2(2)=y2(2)+cellyj
                      y2p(2)=y2p(2)+cellyj
                      jcellzp=-mxcellz
                      jcellzk= mxcellz
                      jsh(2)=nint(shj(2))+jcelly
                      shjc(2)=shj(2)+cellyj+s6(2,jsym,iswj,KPhase)+
     1                        vt6(2,jcenter,iswj,KPhase)
                    else
                      do 2420l=1,3
                        pom=cellxj*float(nvx(l))+cellyj*float(nvy(l))
                        y3(l)=y2(l)+pom
                        y3p(l)=y2p(l)+pom
                        shjc(l)=shj(l)+pom+s6(l,jsym,iswj,KPhase)+
     1                          vt6(l,jcenter,iswj,KPhase)
                        jsh(l)=nint(shj(l)+pom)
2420                  continue
                      call qbyx(y3,y3(4),iswj)
                      call multm(WPr,y3,yp,ndim,ndim,1)
                      do 2425l=1,3
                        u(l)=yp(l)-x1(l)
2425                  continue
                      call multm(u,gw4,ug,1,3,ndc)
                      v1=ug(1)
                      call multm(Gwwi,ug,tmina,ndc,ndc,1)
                      call multm(MetTens(1,iswi,KPhase),u,ug,3,3,1)
                      uu=scalmul(u,ug)-v1**2*gwwi(1)
                      tmin=-tmina(1)*TNaT(1)
                      if(uu.gt.dmhijq) go to 3500
                      du=sqrt(uu)
                      it=tmin
                      if(tmin.lt.0.) it=it-1
                      do 2430l=1,3
                        pom=-it*nvz(l)
                        y3(l)=y3(l)+pom
                        y3p(l)=y3p(l)+pom
                        shjc(l)=shjc(l)+pom
                        jsh(l)=jsh(l)+nint(pom)
2430                  continue
                      tmin=tmin-float(it)
                      jcellzk=0
2442                  do 2443l=1,3
                        yp(l)=y3(l)+float(nvz(l)*(jcellzk+1))
2443                  continue
                      call qbyx(yp,yp(4),iswj)
                      yp(ntc+3)=yp(ntc+3)+xdmx/tnat(1)
                      call multm(WPr,yp,ypp,ndim,ndim,1)
                      do 2444l=1,3
                        u(l)=ypp(l)-x1(l)
2444                  continue
                      call multm(MetTens(1,iswi,KPhase),u,ug,3,3,1)
                      pom=scalmul(u,ug)
                      tminp=tmin+float(jcellzk+1)
                      if(pom.lt.dmhijq.or.
     1                   (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                        jcellzk=jcellzk+1
                        go to 2442
                      endif
                      jcellzp=0
2452                  do 2453l=1,3
                        yp(l)=y3(l)+float(nvz(l)*(jcellzp-1))
2453                  continue
                      call qbyx(yp,yp(4),iswj)
                      yp(ntc+3)=yp(ntc+3)+xdmn/tnat(1)
                      call multm(WPr,yp,ypp,ndim,ndim,1)
                      do 2454l=1,3
                        u(l)=ypp(l)-x1(l)
2454                  continue
                      call multm(MetTens(1,iswi,KPhase),u,ug,3,3,1)
                      pom=scalmul(u,ug)
                      tminp=tmin+float(jcellzp-1)
                      if(pom.lt.dmhijq.or.
     1                   (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                        jcellzp=jcellzp-1
                        go to 2452
                      endif
                      do 2455l=1,3
                        pom=float(nvz(l)*(jcellzp-1))
                        y3p(l)=y3p(l)+pom
                        y3 (l)=y3 (l)+pom
                        shjc(l)=shjc(l)+pom
                        jsh(l)=jsh(l)+nint(pom)
2455                  continue
                    endif
                    do 3400jcellz=jcellzp,jcellzk
                      jst=jst+1
                      cellzj=jcellz
                      if(iswj.eq.iswi) then
                        pom=uz(3)+cellzj
                        if(abs(pom).gt.dmhijc) go to 3400
                        u(3)=pom
                        up(3)=uzp(3)+cellzj
                        y2(3)=y2(3)+cellzj
                        y2p(3)=y2p(3)+cellzj
                        shjc(3)=shj(3)+cellzj+s6(3,jsym,iswj,KPhase)+
     1                          vt6(3,jcenter,iswj,KPhase)
                        jsh(3)=nint(shj(3))+jcellz
                        call multm(MetTens(1,iswi,KPhase),u,ug,3,3,1)
                        uu=scalmul(u,ug)
                        if(uu.gt.dmhijq.or.uu.lt.dmdijq) go to 3400
                        if(uu.eq.0..and.i.eq.j) go to 3400
                        du=sqrt(uu)
                        do 2500l=1,3
                          if(du.ne.0.) then
                            ddx(l+3)=ug(l)/du
                          else
                            ddx(l+3)=0.
                          endif
                          ddx(l)=-ddx(l+3)
                          y3 (l)=y2 (l)
                          y3p(l)=y2p(l)
2500                    continue
                      else
                        do 2510l=1,3
                          pom=nvz(l)
                          y3 (l)=y3 (l)+pom
                          y3p(l)=y3p(l)+pom
                          shjc(l)=shjc(l)+pom
                          jsh(l)=jsh(l)+nint(pom)
2510                    continue
                      endif
                      call qbyx(y3,y3(4),iswj)
                      call qbyx(y3p,y3p(4),iswj)
                      if(iswi.eq.iswj) then
                        sdu=sigma(sgx,ddx,6)
                        if(sdu.lt..00001) sdu=0.
                      else
                        sdu=0.
                      endif
                      call scode(jsym,jcntrsm,jcenter,shjc,jsh,iswj,t80,
     1                           t40)
                      call ScodeCIF(jsym,jcntrsm,jcenter,jsh,iswj,t7)
                      t80=t80(:idel(t80))//'#'
                      l=idel(t40)
                      if(l.gt.0) t80=t80(:idel(t80))//t40(:l)
                      call zhusti(t80)
                      if(ndim.eq.3.and.VolaToDist) then
                        call DistM61DistHeader(atom(i),atom(j),du,sdu,
     1                                         t80)
                      endif
                      if(j.lt.i.and.BratPrvni(j)) then
                        iflg=0
                      else
                        iflg=1
                      endif
                      write(78) '#2',atom(j),isf(j),aij,du,sdu,
     1                          (0.,m=1,4),t80,t7,iflg
                      n61=n61+1
                      if(VolaToDist) then
                        write(88) '#2',atom(j),isf(j),aij,du,sdu,
     1                            (0.,m=1,4),t80,t7,iflg
                        call fflush
                        line=line+1
                        call DistRoundESD(Cislo,du,sdu,4)
                        iven(line)=atom(j)//'.....'//Cislo(:idel(Cislo))
                        do 2530k=1,8
                          if(iven(line)(k:k).eq.' ') iven(line)(k:k)='.'
2530                    continue
                      endif
                      if(ntall(iswi).le.0.or.ndim.eq.3) go to 3000
                      do 2600m=1,kmodx(j)
                        call multm(rm(1,jsym,iswj,KPhase),ux(1,m,j),
     1                             uxj(1,m),3,3,1)
                        call multmq(rm(1,jsym,iswj,KPhase),sux(1,m,j),
     1                              suxj(1,m),3,3,1)
                        if(kfx(j).eq.0.or.m.ne.kmodx(j)) then
                          call multm (rm(1,jsym,iswj,KPhase),uy(1,m,j),
     1                                uyj(1,m),3,3,1)
                          call multmq(rm(1,jsym,iswj,KPhase),suy(1,m,j),
     1                                suyj(1,m),3,3,1)
                        else
                          call CopyVek( uy(1,m,j), uyj(1,m),3)
                          call CopyVek(suy(1,m,j),suyj(1,m),3)
                        endif
                        if(jcntrsm.eq.2) then
                          do 2550l=1,3
                            uxj(l,m)=-uxj(l,m)
                            if(kfx(j).eq.0.or.m.ne.kmodx(j))
     1                                           uyj(l,m)=-uyj(l,m)
2550                      continue
                        endif
2600                  continue
                      call qbyx(shjc,qx,iswj)
                      call AddVek(qx,ts,xp,ndimi)
                      call AddVek(xp,tztnat,qx,ndimi)
                      call multm(GammaIntInv,qx,xp,ndimi,ndimi,1)
                      call MakeOccMod(oj,qcnt(1,j),xp,nti,dttnat,a0(j),
     1                  ax(1,j),ay(1,j),kmods(j),kfs(j),GammaIntInv)
                      if(kfx(j).gt.0.and.kmodx(j).gt.0)
     1                  call MakeOccModSawTooth(oj,qcnt(1,j),xp,nti,
     2                    dttnat,uyj(1,kmodx(j)),uyj(2,kmodx(j)),kfx(j),
     3                    GammaIntInv)
                      call MakePosMod(xdj,qcnt(1,j),xp,nti,dttnat,uxj,
     1                  uyj,kmodx(j),kfx(j),GammaIntInv)
                      call MakePosModS(sxdj,qcnt(1,j),xp,nti,dttnat,
     1                  uxj,uyj,suxj,suyj,kmodx(j),kfx(j),GammaIntInv)
                      dummx=-9999.
                      dummn= 9999.
                      dumav=0.
                      sdumav=0.
                      y340=y3p(ntc+3)
c    stale otazka jak je to molekularni
                      npom=0
                      do 2700kt=1,ntall(iswi)
                        call RecUnpack(kt,nd,nti,ndimi)
                        do 2620k=1,ndimi
                          t(k)=tfirsti(k)+(nd(k)-1)*dti(k)
2620                    continue
                        if(oi(kt).le.ocut.or.oj(kt).le.ocut) then
                           dumkt=0.
                          sdumkt=0.
                          go to 2700
                        endif
                        npom=npom+1
                        if(iswj.eq.iswi) then
                          do 2651l=1,3
                            um(l,kt)=up(l)+xdj(l,kt)-xdi(l,kt)
2651                      continue
                          dumm(kt)=sqrt(uu)
                        else
                          y3p(ntc+3)=y340+t(ntc)*tnati(1)
                          call multm(WPr,y3p,yp,ndim,
     1                               ndim,1)
                          do 2660l=1,3
                            yp(l)=yp(l)-x1p(l)
2660                      continue
                          call multm(MetTens(1,iswi,KPhase),yp,ypp,3,3,
     1                               1)
                          dumm(kt)=sqrt(scalmul(yp,ypp))
                          do 2661l=1,3
                            yp(l)=yp(l)-xdi(l,kt)
                            ypp(l)=xdj(l,kt)
2661                      continue
                          call qbyx(ypp,ypp(4),iswj)
                          call cultm(WPr,ypp,yp,ndim,ndim,1)
                          call CopyVek(yp,um(1,kt),3)
                        endif
                        call multm(MetTens(1,iswi,KPhase),um(1,kt),umg,
     1                             3,3,1)
                        dumkt=sqrt(scalmul(um(1,kt),umg))
                        dum(kt)=dumkt
                        do 2670l=1,3
                          if(dumkt.ne.0.) then
                            ddx(l+3)=umg(l)/dumkt
                          else
                            ddx(l+3)=0.
                          endif
                          ddx(l)=-ddx(l+3)
2670                    continue
                        call AddVekQ(sgx,sxdi(1,kt),sgxm,3)
                        call AddVekQ(sgx(4),sxdj(1,kt),sgxm(4),3)
                        sdumkt=sigma(sgxm,ddx,6)
                        if(sdumkt.lt..00001) sdumkt=0.
                        dums(kt)=sdumkt
                        if(dumkt.gt.dummx) then
                           dummx= dumkt
                          sdummx=sdumkt
                        endif
                        if(dumkt.lt.dummn) then
                           dummn= dumkt
                          sdummn=sdumkt
                          ktmin=kt
                        endif
                         dumav= dumav+ dumkt
                        sdumav=sdumav+sdumkt
2675                    write(78) sp2,atom(j),kt,dumm(kt),dumkt,sdumkt,
     1                            oi(kt),oj(kt),0.,0.,t80,t7,iflg
                        if(ieach.gt.0.and.VolaToDist) then
                          if(mod(kt-1,ieach).eq.0)
     1                      write(88) sp2,atom(j),kt,dumm(kt),dumkt,
     2                                sdumkt,0.,0.,oi(kt),oj(kt),t80,t7,
     3                                iflg
                        endif
                        n61=n61+1
2700                  continue
                      if(VolaToDist) then
                        if(npom.gt.0.and.dummn.le.dmhi) then
                          call DistM61DistHeader(atom(i),atom(j),du,sdu,
     1                                           t80)
                          call fflush
                          if(iswi.eq.iswj) then
                            dumkt=1./float(npom)
                             dumav= dumav*dumkt
                            sdumav=sdumav*dumkt
                            call fflush
                            line=line+1
                            call DistRoundESD(Cislo,dumav,sdumav,4)
                            l=idel(Cislo)
                            iven(line)=' ave         '//Cislo(:l)
                            s80='  ave : '//Cislo(:l)
                            call fflush
                            line=line+1
                            call DistRoundESD(Cislo,dummn,sdummn,4)
                            l=idel(Cislo)
                            iven(line)=' min         '//Cislo(:l)
                            s80=s80(:idel(s80))//'  min : '//Cislo(:l)
                            call fflush
                            line=line+1
                            call DistRoundESD(Cislo,dummx,sdummx,4)
                            l=idel(Cislo)
                            iven(line)=' max         '//Cislo(:l)
                            s80=s80(:idel(s80))//'  max : '//Cislo(:l)
                            call fflush
                          else
                            call fflush
                            line=line+1
                            call DistRoundESD(Cislo,dummn,sdummn,4)
                            l=idel(Cislo)
                            iven(line)=' min         '//Cislo(:l)
                            s80='  min : '//Cislo(:l)
                            if(ktmin.eq.1.or.ktmin.eq.nti(1))
     1                            iven(line)(9:9)='<'
                            call fflush
                          endif
                          write(88) '#4',atom(j),isf(j),aij,dmod,
     1                              t80,t7,iflg
                          write(61,FormA1)(s80(l:l),l=1,idel(s80))
                        else
                          line=max(line-1,0)
                          go to 3400
                        endif
                        call fflush
                      endif
                      if(ieach.ne.0) then
                        l=0
                        do 2800kt=1,ntall(iswi),ieach
                          call RecUnpack(kt,nd,nti,ndimi)
                          do 2720m=1,ndimi
                            t(m)=tfirsti(m)+(nd(m)-1)*dti(m)
2720                      continue
                          l=l+1
                           dumkt=dum (kt)
                          sdumkt=dums(kt)
                          if(oi(kt).gt.ocut.and.oj(kt).gt.ocut) then
                            if(VolaToDist) then
                              call fflush
                              line=line+1
                              write(iven(line),'(2x,f5.3)') t(1)
                              call DistRoundESD(Cislo,dumkt,sdumkt,4)
                              iven(line)=iven(line)(:13)//
     1                          Cislo(:idel(Cislo))
                              write(61,FormTD)(t(m),m=1,ndimi),
     1                                         dumkt
                              if(oi(kt).le.oind.or.oj(kt).le.oind)
     1                           iven(line)(1:1)='*'
                              call fflush
                            endif
                          endif
2800                    continue
                      endif
                      if(VolaToDist) then
                        call fflush
                        line=line+1
                        write(iven(line),'(26(''-''))')
                        call fflush
                      endif
3000                  if(.not.iuhl0) then
                        call uhelat(i,j)
                        if(ErrJana.ne.0) go to 9900
                        call fflush
                      endif
3400                continue
3500              continue
3600            continue
3700          continue
3800        continue
3900      continue
4000    continue
        if(VolaToDist) then
          write(61,120)
          call fflush
          line=line+1
          iven(line)='*'
          call fflush
        endif
4100  continue
      if(.not.VolaToDist) go to 9999
      call FeFlowChartRemove
      if(line.gt.0) then
        call OutSt
        line=mxline
      endif
      if(nBondVal.ne.0) then
        call newpg(0)
        nfloat=0
        if(ndimi.gt.0) then
          call FeFlowChartOpen(-1.,-1.,1000,n61,
     1                         'Summation of bond-valences',' ',' ')
          call SetRealArrayTo(dum, ntall(iswi),0.)
        endif
        Nacitame=.false.
        Konec=.false.
        Prvne=.true.
        n=0
        rewind 78
5000    read(78,err=5010,end=5010) Label,At2,j,pom,du,sdu,occi,occj
        if(ndimi.gt.0) then
          call FeFlowChartEvent(nfloat,ie)
          if(ie.ne.0) then
            call DistBudeBreak
            if(ErrJana.ne.0) go to 9900
          endif
        endif
        go to 5020
5010    Konec=.true.
        Label='#1'
5020    if(Label.eq.'#1') then
          if(n.gt.0) then
            if(Prvne) then
              call Newln(1)
              write(lst,FormA80)
              Prvne=.false.
            endif
            if(ndimi.eq.0) then
              call Newln(1)
              sdumav=sqrt(sdumav)
              call DistRoundESD(Cislo,dumav,sdumav,3)
              t80='Bond valence for : '//at1//Cislo
              write(lst,FormA1)(t80(i:i),i=1,idel(t80))
            else
              dummx=-9999.
              dummn= 9999.
              dumav=0.
              sdumav=0.
              npom=0
              do 5300kt=1,ntall(iswi)
                 pom=dum (kt)
                spom=sqrt(dums(kt))
                if(pom.gt.0.) then
                  if(pom.gt.dummx) then
                     dummx= pom
                    sdummx=spom
                  endif
                  if(pom.lt.dummn) then
                     dummn= pom
                    sdummn=spom
                  endif
                   dumav=dumav+pom
                  sdumav=sdumav+spom
                  npom=npom+1
                endif
5300          continue
               dumav= dumav/float(npom)
              sdumav=sdumav/float(npom)
              t80='Bond valence for : '//at1//' average : '
              call DistRoundESD(Cislo,dumav,sdumav,3)
              s80=Cislo
              call DistRoundESD(Cislo,dummn,sdummn,3)
              s80=s80(:10)//' minimum : '//Cislo
              call DistRoundESD(Cislo,dummx,sdummx,3)
              s80=s80(:31)//'  maximum : '//Cislo
              call Newln(1)
              write(lst,FormA1)(t80(i:i),i=1,idel(t80)),' ',
     1                         (s80(i:i),i=1,idel(s80))
              call SetRealArrayTo(dum ,ntall(iswi),0.)
              call SetRealArrayTo(dums,ntall(iswi),0.)
            endif
          endif
          if(Konec) go to 5100
          At1=At2
          isfi=j
          aii=pom
          n=0
           dumav=0.
          sdumav=0.
          Nacitame=.false.
        else if(Label.eq.'#2') then
          isfj=j
          aij=pom
          if(ndimi.le.0) then
            if(iBondVal(isfi,isfj).ne.0) then
              n=n+1
              pom=exp((dBondVal(isfi,isfj)-du)/.37)*aij
               dumav= dumav+pom
              sdumav=sdumav+(pom*sdu/.37)**2
            endif
          else
            Nacitame=.true.
          endif
        else if(Label.eq.' '.and.Nacitame) then
          kt=j
          if(iBondVal(isfi,isfj).ne.0.and.occi.gt.ocut.and.
     1                                    occj.gt.ocut) then
            n=n+1
            ppp=exp((dBondVal(isfi,isfj)-du)/.37)*aij*occj
            dum (kt)=dum (kt)+ppp
            dums(kt)=dums(kt)+(ppp*sdu/.37)**2
          endif
        else
          Nacitame=.false.
        endif
        go to 5000
5100    call FeFlowChartRemove
      endif
      if(VolaToDist) then
        rewind 88
        if(ndimi.le.0) then
          Lab2='#2'
          Lab3='#3'
        else
          Lab2='#4'
          Lab3='#5'
        endif
6000    read(88,end=6500) Label,At3,isfj,pom,dmod,t80,t73,iflg3
        if(Label.eq.'#1') then
          At1=At3
          t71=t73
          iflg1=iflg3
        else if(Label.eq.Lab2) then
          At2=At3
          t72=t73
          iflg2=iflg3
          if(iflg1.eq.1.and.iflg2.eq.1) then
            if(ndimi.le.0) then
              write(89,116) At1,At2,dumav,sdumav,t72
            else
              write(89,118) At1,At2,dmod,t72
            endif
          endif
        else if(Label.eq.Lab3) then
          if(iflg1.eq.1.and.iflg3.eq.1) then
            if(ndimi.le.0) then
              write(89,117) At2,At1,At3,dumav,sdumav,t72,t73
            else
              write(89,119) At2,At1,At3,dmod,t72,t73
            endif
          endif
        endif
        go to 6000
      endif
6500  if(ittab.eq.0) go to 9900
      call newln(2)
      write(lst,FormA1)
      write(lst,FormA1)
      do 9000i=1,nacalc
        if(isf(i).le.0.or..not.BratPrvni(i).or.kswa(i).ne.KPhase)
     1  go to 9000
        iswi=iswa(i)
        call newln(3)
        write(lst,101)
        write(lst,'(44x,''** Coordination for atom : '',a8,'' **'')')
     1        atom(i)
        write(lst,101)
        call CopyVek (dt(1,iswi),dti,ndimi)
        call CopyVekI(nt(1,iswi),nti,ndimi)
        call CopyVek(tfirst(1,iswi),tfirsti,ndimi)
        dmhij=dmhi
        t(1)=tfirsti(1)
        l=0
        ip=333
        do 8800kt=1,ntall(iswi),ieach
          l=l+1
          ntb=0
          call SetIntArrayTo(nutab,30,0)
          rewind 88
8200      read(88,end=8340) Label,At1
          if(Label.ne.'#1'.or.At1.ne.Atom(i)) go to 8200
8300      read(88,end=8340) Label,At2
8310      if(Label.ne.'#2'.and.Label.ne.'#3') then
            if(Label.eq.'#1') then
              go to 8340
            else
              go to 8300
            endif
          else
            JeToUhel=Label.eq.'#3'
          endif
8320      read(88,end=8340) Label,At1,k,pom,pom,spom,occi,occi,occi,occk
          if(Label.ne.sp2) then
            At2=At1
            go to 8310
          else
            if(k.lt.kt) then
              go to 8320
            else if(k.gt.kt) then
              go to 8300
            endif
          endif
          if(JeToUhel) then
            if(occi.gt.ocut.and.occj.gt.ocut.and.occk.gt.ocut) then
              nutb=nutab(ntb)+1
              if(nutb.le.30) then
                nutab(ntb)=nutb
                atutab(nutb,ntb)=at2
                utab(nutb,ntb)=pom
                sutab(nutb,ntb)=spom
              else
                call FeChybne(-1.,-1.,'the maximum number of 30 '//
     1                        'neighbours exceeded',' ',1,SeriousError)
                ErrJana=1
                go to 9900
              endif
            endif
          else
            occj=occk
            if(pom.le.dmhij.and.occi.gt.ocut.and.occj.gt.ocut) then
              if(ntb.lt.30) then
                ntb=ntb+1
                attab(ntb)=at2
                idtab(ntb)=nint(pom*10000.)
                dstab(ntb)=spom
              else
                call FeChybne(-1.,-1.,'the maximum number of 30 '//
     1                        'neighbours exceeded',' ',1,SeriousError)
                ErrJana=1
                go to 9900
              endif
            endif
          endif
          go to 8300
8340      if(ip.gt.111) then
            if(ip.ne.333) then
              do 8350n=1,lmax
                if(n.eq.1) then
                  call newln(3)
                  write(lst,120)
                  write(lst,FormA1)(ltab(n)(k:k),k=1,idel(ltab(n)))
                  write(lst,120)
                else
                  call newln(1)
                  write(lst,FormA1)(ltab(n)(k:k),k=1,idel(ltab(n)))
                endif
8350          continue
            endif
            lmax=0
            do 8360n=1,444
              ltab(n)=' '
              do 8355ip=1,128,25
                ltab(n)(ip:ip)='|'
8355          continue
8360        continue
            ip=3
          endif
          n=0
          n=n+1
          write(ltab(n)(ip:ip+22),'(6x,'' t='',f6.3)') t(1)
          if(ntb.gt.0) then
            call indexx(ntb,idtab,iptab)
            do 8400j=1,ntb
              k=iptab(j)
              n=n+1
              call DistRoundESD(Cislo,float(idtab(k))*.0001,dstab(k),4)
              jj=max(idel(Cislo),index(Cislo,'.')+8)
              ltab(n)(ip:ip+7)=attab(k)
              ltab(n)(ip+22-jj:ip+21)=Cislo(:jj)
              do 8370m=0,10
                if(ltab(n)(ip+m:ip+m).eq.' ') ltab(n)(ip+m:ip+m)='-'
8370          continue
              do 8390m=1,nutab(k)
                n=n+1
                call DistRoundESD(Cislo,utab(m,k),sutab(m,k),2)
                jj=idel(Cislo)
                ltab(n)(ip+1:ip+8)=atutab(m,k)
                jj=max(idel(Cislo),index(Cislo,'.')+6)
                ltab(n)(ip+23-jj:ip+22)=Cislo(:jj)
                do 8380mm=1,10
                  if(ltab(n)(ip+mm:ip+mm).eq.' ')
     1                                    ltab(n)(ip+mm:ip+mm)='.'
8380            continue
8390          continue
8400        continue
          endif
8500      t(1)=t(1)+dti(1)*float(ieach)
          lmax=max(n,lmax)
          ip=ip+25
8800    continue
        if(ip.gt.3) then
          do 8810l=1,lmax
            if(l.eq.1) then
              call newln(3)
              write(lst,120)
              write(lst,FormA1)(ltab(l)(kt:kt),kt=1,idel(ltab(l)))
              write(lst,120)
            else
              call newln(1)
              write(lst,FormA1)(ltab(l)(kt:kt),kt=1,idel(ltab(l)))
            endif
8810      continue
        endif
        call newln(1)
        write(lst,120)
9000  continue
9900  close(78)
      if(ittab.eq.1) close(88)
9999  call CloseIfOpened(61)
      return
100   format(a1,a8,i6,3f10.6)
101   format(44x,38('*'))
102   format(26('*'),6x)
103   format('* atom ',a8,10x,'*',6x)
104   format(a1,i6,f9.4)
106   format(1x,a3,9x,f7.4,12x)
116   format('distance: ',2(a8,1x),2f9.4,' .',7x,a7)
117   format('angle: ',3(a8,1x),2f9.4,1x,a7,' .',7x,a7)
118   format('distance: ',2(a8,1x),6f9.4,' .',7x,a7)
119   format('angle: ',3(a8,1x),6f9.4,1x,a7,' .',7x,a7)
120   format(126('-'))
      end
      subroutine uhelat(i,j)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      dimension z0(6),z1(6),z2(3),vz(3),shk(3),shkc(3),vm(3),vmg(3),
     1          uxk(3,mxw),uyk(3,mxw),zp(6),sx0(6),z0p(6),z1p(6),z2p(3),
     2          vzp(3),vp(3),WPr(36),WPri(36),gw4(9),nvx(3),nvy(3),
     3          nvz(3),zpp(6),z3(6),z3p(6),ksh(3),tztnat(3),dttnat(3),
     4          GammaIntInv(9),t(3),nd(3),ts(3),xp(3),suxk(3,mxw),
     5          suyk(3,mxw),sgxm(9),umg(3),gww(9),gwwi(9),TNaT(9),
     6          TNaTi(9),tmina(3),ZdPr(9),umod(6)
      character*80 t80,s80
      character*40 t40
      character*8  sp8
      character*7 t7
      character*2 sp2
      equivalence (umod(1),damav),(umod(2),sdamav),
     1            (umod(3),dammn),(umod(4),sdammn),
     2            (umod(5),dammx),(umod(6),sdammx)
      data sp2,sp8/2*' '/
      do 8000k=j,nacalc
        if(kswa(k).ne.KPhase) go to 8000
        l=isf(k)
        if(.not.BratDruhyATreti(k).or.l.eq.0) go to 8000
        iswk=iswa(k)
        call SpecPos(x(1,j),iswk,.01,n)
        aik=ai(k)*float(n)
        iswkin=iswi*10+iswk
        if(iswk.ne.iswi) then
          iswkin=iswi*10+iswk
          if(iswkin.ne.iswki) then
            call multm(zv(1,iswi,KPhase),zvi(1,iswk,KPhase),WPr,ndim,
     1                 ndim,ndim)
            call matinv(WPr,WPri,det,ndim)
            ii=ndim*3+1
            ndc=0
            ntc=0
            do 2010jj=1,3*ndimi,3
              do 2005l=0,2
                if(WPr(ii+l).gt.0.) then
                  ndc=ndc+1
                  if(ndc.gt.1) then
                    call FeChybne(-1.,-1.,
     1                'distance calculation for such a structure not '
     2              //'yet implemented',
     3                'Please contact the authors',0,FatalError)
                    call FeFlowChartRemove
                    ErrJana=1
                    go to 9999
                  endif
                  call CopyVek(WPr(ii),ZdPr(1),3)
                  ntc=(jj-1)/3+1
                endif
2005          continue
              ii=ii+ndim
2010        continue
            xdmn=tfirsti(ntc)
            xdmx=tfirsti(ntc)+dti(ntc)*float(nti(ntc)-1)
            ii=ndim*(2+ntc)
            do 2020l=1,3
              nvz(l)=nint(WPri(l+ii))
2020        continue
            kolik=0
            do 2030l=1,3
              nvx(l)=0
              nvy(l)=0
              if(nvz(l).ne.0) then
                kolik=kolik+1
                kdeneni=l
              else
                kdeje=l
              endif
2030        continue
            if(kolik.eq.3) then
              nvx(1)=1
              nvy(2)=1
            else if(kolik.eq.2) then
              nvx(mod(kdeje-1,3)+1)=1
              nvy(mod(kdeje,3)+1)=1
            else
              nvx(mod(kdeneni,3)+1)=1
              nvy(mod(kdeneni+1,3)+1)=1
            endif
            call Multm(MetTens(1,iswi,KPhase),ZdPr,gw4,3,3,ndc)
            call Multm(ZdPr,gw4,gww,ndc,3,ndc)
            call MatInv(Gww,Gwwi,pom,ndc)
            call multm(qu(1,ntc,iswi,KPhase),ZdPr,tnat,ndc,3,ndc)
            jj=0
            if(ntc.eq.1) then
              ii=2*ndim+3
            else if(ntc.eq.2) then
              ii=3*ndim+4
            else if(ntc.eq.3) then
              ii=4*ndim+5
            endif
            do 2040l=1,ndc
              ii=ii+ndim
              do 2037m=1,ndc
                jj=jj+1
                ii=ii+1
                tnat(jj)=WPr(ii)-tnat(jj)
2037          continue
2040        continue
            call matinv(TNaT,TNaTi,pom,ndc)
          endif
        else
          ndc=1
          ntc=1
          call UnitMat(TNaT ,ndc)
          call UnitMat(TNaTi,ndc)
        endif
        iswki=iswkin
        call CopyVek(tfirsti,TzTNaT,ndimi)
        call CopyVek(dti   ,DtTNaT,ndimi)
        call multm(TNaTi,tfirsti(ntc),TzTNaT,ndc,ndc,ndc)
        call multm(TNaTi,dti   (ntc),DtTNaT,ndc,ndc,ndc)
        dmhik=dmhi+dxm(i)+dxm(k)
        mxcellx=dmhik*rcp(1,iswk,KPhase)+1
        mxcelly=dmhik*rcp(2,iswk,KPhase)+1
        mxcellz=dmhik*rcp(3,iswk,KPhase)+1
        dmhika=dmhik*ah
        dmhikb=dmhik*bh
        dmhikc=dmhik*ch
        dmhikq=dmhik**2
        dmdikq=dmdi**2
        do 2050l=1,3
          z0(l)=xdst(l,k)
          z0p(l)=x(l,k)
          sx0(l)=sx(l,k)
2050    continue
        ks=0
        kst=0
        do 7900ksym=1,ns
          call multm(rm(1,ksym,iswk,KPhase),z0,z1,3,3,1)
          call multm(rm(1,ksym,iswk,KPhase),z0p,z1p,3,3,1)
          call multmq(rm(1,ksym,iswk,KPhase),sx0,sgx(7),3,3,1)
          call GetGammaIntInv(ksym,iswk,KPhase,GammaIntInv)
          do 2100l=1,3
            z1(l)=z1(l)+s6(l,ksym,iswk,KPhase)
            z1p(l)=z1p(l)+s6(l,ksym,iswk,KPhase)
2100      continue
          do 7800kcntrsm=1,3-ncs
            ks=ks+1
            if(isa(ks,k).le.0) go to 7800
            if(kcntrsm.ne.1) then
              call GetGammaIntInv(-ksym,iswk,KPhase,GammaIntInv)
              do 2200l=1,3
                z1(l)=-z1(l)+s6(l,ksym,iswk,KPhase)*2.
                z1p(l)=-z1p(l)+s6(l,ksym,iswk,KPhase)*2.
2200          continue
            endif
            do 7700kcenter=1,nvt
              do 2300l=4,ndim
                ts(l-3)=-s6(l,ksym,iswk,KPhase)
     1                  -vt6(l,kcenter,iswk,KPhase)
2300          continue
              do 2305l=1,3
                z2(l)=z1(l)+vt6(l,kcenter,iswk,KPhase)
                z2p(l)=z1p(l)+vt6(l,kcenter,iswk,KPhase)
2305          continue
              if(iswk.eq.iswi) then
                call bunka(z2,shk,1)
                do 2310l=1,3
                  vzp(l)=z2p(l)-x1p(l)+shk(l)
                  vz(l)=z2(l)-x1(l)
2310            continue
              else
                call multm(WPri,x1,zp,ndim,ndim,1)
                do 2320l=1,3
                  shk(l)=zp(l)-z2(l)
2320            continue
                do 2330l=1,3
                  shk(l)=ifix(shk(l))
                  z2(l)=z2(l)+shk(l)
                  z2p(l)=z2p(l)+shk(l)
2330            continue
              endif
              do 7600kcellx=-mxcellx,mxcellx
                cellxk=kcellx
                if(iswk.eq.iswi) then
                  pom=vz(1)+cellxk
                  if(abs(pom).gt.dmhika) go to 7600
                  v(1)=pom
                  vp(1)=vzp(1)+cellxk
                  z2(1)=z2(1)+cellxk
                  z2p(1)=z2p(1)+cellxk
                  ksh(1)=nint(shk(1))+kcellx
                  shkc(1)=shk(1)+cellxk+s6(1,ksym,iswk,KPhase)+
     1                    vt6(1,kcenter,iswk,KPhase)
                endif
                do 7500kcelly=-mxcelly,mxcelly
                  cellyk=kcelly
                  if(iswk.eq.iswi) then
                    pom=vz(2)+cellyk
                    if(abs(pom).gt.dmhikb) go to 7500
                    v(2)=pom
                    vp(2)=vzp(2)+cellyk
                    z2(2)=z2(2)+cellyk
                    z2p(2)=z2p(2)+cellyk
                    kcellzp=-mxcellz
                    kcellzk= mxcellz
                    ksh(2)=nint(shk(2))+kcelly
                    shkc(2)=shk(2)+cellyk+s6(2,ksym,iswk,KPhase)+
     1                      vt6(2,kcenter,iswk,KPhase)
                  else
                    do 2420l=1,3
                      pom=cellxk*float(nvx(l))+cellyk*float(nvy(l))
                      z3(l)=z2(l)+pom
                      z3p(l)=z2p(l)+pom
                      shkc(l)=shk(l)+pom+s6(l,ksym,iswk,KPhase)+
     1                        vt6(l,kcenter,iswk,KPhase)
                      ksh(l)=nint(shk(l)+pom)
2420                continue
                    call qbyx(z3,z3(4),iswk)
                    call multm(WPr,z3,zp,ndim,ndim,1)
                    do 2425l=1,3
                      v(l)=zp(l)-x1(l)
2425                continue
                    call multm(v,gw4,vg,1,3,ndc)
                    v1=vg(1)
                    call multm(Gwwi,vg,tmina,ndc,ndc,1)
                    call multm(MetTens(1,iswi,KPhase),v,vg,3,3,1)
                    vv=scalmul(v,vg)-v1**2*gwwi(1)
                    tmin=-tmina(1)*TNaT(1)
                    if(vv.gt.dmhikq) go to 7500
                    dv=sqrt(vv)
                    angle=0.
                    su=0.
                    it=tmin
                    if(tmin.lt.0.) it=it-1
                    do 2430l=1,3
                      pom=-it*nvz(l)
                      z3(l)=z3(l)+pom
                      z3p(l)=z3p(l)+pom
                      shkc(l)=shkc(l)+pom
                      ksh(l)=ksh(l)+nint(pom)
2430                continue
                    tmin=tmin-float(it)
                    kcellzk=0
2442                do 2443l=1,3
                      zp(l)=z3(l)+float(nvz(l)*(kcellzk+1))
2443                continue
                    call qbyx(zp,zp(4),iswk)
                    zp(ntc+3)=zp(ntc+3)+xdmx/tnat(1)
                    call multm(WPr,zp,zpp,ndim,ndim,1)
                    do 2444l=1,3
                      v(l)=zpp(l)-x1(l)
2444                continue
                    call multm(MetTens(1,iswi,KPhase),v,vg,3,3,1)
                    pom=scalmul(v,vg)
                    tminp=tmin+float(kcellzk+1)
                    if(pom.lt.dmhikq.or.
     1                 (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                      kcellzk=kcellzk+1
                      go to 2442
                    endif
                    kcellzp=0
2452                do 2453l=1,3
                      zp(l)=z3(l)+float(nvz(l)*(kcellzp-1))
2453                continue
                    call qbyx(zp,zp(4),iswk)
                    zp(ntc+3)=zp(ntc+3)+xdmn/tnat(1)
                    call multm(WPr,zp,zpp,ndim,ndim,1)
                    do 2454l=1,3
                      v(l)=zpp(l)-x1(l)
2454                continue
                    call multm(MetTens(1,iswi,KPhase),v,vg,3,3,1)
                    pom=scalmul(v,vg)
                    tminp=tmin+float(kcellzp-1)
                    if(pom.lt.dmhikq.or.
     1                 (tminp.ge.xdmn.and.tminp.le.xdmx)) then
                      kcellzp=kcellzp-1
                      go to 2452
                    endif
                    do 2455l=1,3
                      pom=float(nvz(l)*(kcellzp-1))
                      z3p(l)=z3p(l)+pom
                      z3 (l)=z3 (l)+pom
                      shkc(l)=shkc(l)+pom
                      ksh(l)=ksh(l)+nint(pom)
2455                continue
                  endif
                  do 7400kcellz=kcellzp,kcellzk
                    kst=kst+1
                    cellzk=kcellz
                    if(k.eq.j.and.kst.eq.jst) go to 7400
                    if(iswk.eq.iswi) then
                      pom=vz(3)+cellzk
                      if(abs(pom).gt.dmhikc) go to 7400
                      v(3)=pom
                      vp(3)=vzp(3)+cellzk
                      z2(3)=z2(3)+cellzk
                      z2p(3)=z2p(3)+cellzk
                      shkc(3)=shk(3)+cellzk+s6(3,ksym,iswk,KPhase)+
     1                        vt6(3,kcenter,iswk,KPhase)
                      ksh(3)=nint(shk(3))+kcellz
                      call multm(MetTens(1,iswi,KPhase),v,vg,3,3,1)
                      vv=scalmul(v,vg)
                      if(vv.gt.dmhikq.or.vv.lt.dmdikq) go to 7400
                      if(vv.eq.0..and.i.eq.k) go to 7400
                      dv=sqrt(vv)
                      do 2500l=1,3
                        z3 (l)=z2 (l)
                        z3p(l)=z2p(l)
2500                  continue
                      call DistAng(u,ug,vg,uu,vv,sgx,angle,su)
                      if(su.lt..0001) su=0.
                    else
                      do 2510l=1,3
                        pom=nvz(l)
                        z3 (l)=z3 (l)+pom
                        z3p(l)=z3p(l)+pom
                        shkc(l)=shkc(l)+pom
                        ksh(l)=ksh(l)+nint(pom)
2510                  continue
                    endif
                    call qbyx(z3,z3(4),iswk)
                    call qbyx(z3p,z3p(4),iswk)
                    call scode(ksym,kcntrsm,kcenter,shkc,ksh,iswk,t80,
     1                         t40)
                    t80=t80(:idel(t80))//'#'
                    l=idel(t40)
                    if(l.gt.0) t80=t80(:idel(t80))//t40(:l)
                    call ScodeCIF(ksym,kcntrsm,kcenter,ksh,iswk,t7)
                    if(ndim.eq.3.and.VolaToDist) then
                      call DistM61AngleHeader(Atom(j),Atom(i),Atom(k),
     1                                        angle,su,t80)
                    endif
                    write(78) '#3',atom(k),isf(k),aik,angle,su,
     1                        (0.,m=1,4),t80,t7,1
                    if(VolaToDist) then
                      write(88) '#3',atom(k),isf(k),aik,angle,su,
     1                          (0.,m=1,4),t80,t7,1
                      call fflush
                      line=line+1
                      call DistRoundESD(Cislo,Angle,su,2)
                      iven(line)='  '//atom(k)//'...'//
     1                           Cislo(:idel(Cislo))
                      do 2530l=3,10
                        if(iven(line)(l:l).eq.' ') iven(line)(l:l)='.'
2530                  continue
                      call fflush
                    endif
                    if(nt(1,1).le.0.or.ndim.eq.3) go to 7400
                    do 2600m=1,kmodx(k)
                      call multm(rm(1,ksym,iswk,KPhase),ux(1,m,k),
     1                           uxk(1,m),3,3,1)
                      call multmq(rm(1,ksym,iswk,KPhase),sux(1,m,k),
     1                            suxk(1,m),3,3,1)
                      if(kfx(k).eq.0.or.m.ne.kmodx(k)) then
                        call multm(rm(1,ksym,iswk,KPhase),uy(1,m,k),
     1                             uyk(1,m),3,3,1)
                        call multmq(rm(1,ksym,iswk,KPhase),sux(1,m,k),
     1                              suyk(1,m),3,3,1)
                      else
                        call CopyVek( uy(1,m,k), uyk(1,m),3)
                        call CopyVek(suy(1,m,k),suyk(1,m),3)
                      endif
                      if(kcntrsm.eq.2) then
                        do 2550l=1,3
                          uxk(l,m)=-uxk(l,m)
                          if(kfx(k).eq.0.or.m.ne.kmodx(k))
     1                       uyk(l,m)=-uyk(l,m)
2550                    continue
                      endif
2600                continue
                    call qbyx(shkc,qx,iswk)
                    call AddVek(qx,ts,xp,ndimi)
                    call AddVek(xp,tztnat,qx,ndimi)
                    call multm(GammaIntInv,qx,xp,ndimi,
     1                         ndimi,1)
                    call MakeOccMod(ok,qcnt(1,k),xp,nti,dttnat,
     1                a0(k),ax(1,k),ay(1,k),kmods(k),kfs(k),GammaIntInv)
                    if(kfx(k).gt.0.and.kmodx(k).gt.0)
     1                call MakeOccModSawTooth(ok,qcnt(1,k),xp,
     2                  nti,dttnat,uyk(1,kmodx(k)),uyk(2,kmodx(k)),
     3                  kfx(k),GammaIntInv)
                    call MakePosMod(xdk,qcnt(1,k),xp,nti,dttnat,
     1                uxk,uyk,kmodx(k),kfx(k),GammaIntInv)
                    call MakePosModS(sxdk,qcnt(1,k),xp,nti,dttnat,
     1                uxk,uyk,suxk,suyk,kmodx(k),kfx(k),GammaIntInv)
                    dammx=-9999.
                    dammn= 9999.
                    damav=0.
                    sdamav=0.
                    npom=0
                    z340=z3p(ntc+3)
                    do 2700kt=1,ntall(iswi)
                      call RecUnpack(kt,nd,nti,ndimi)
                      do 2620l=1,ndimi
                        t(l)=tfirsti(l)+(nd(l)-1)*dti(l)
2620                  continue
                      if(oi(kt).le.ocut.or.oj(kt).le.ocut.
     1                                  or.ok(kt).le.ocut) go to 2700
c     1                                  or.ok(kt).le.ocut) go to 2675
                      npom=npom+1
                      if(iswk.eq.iswi) then
                        do 2651l=1,3
                          vm(l)=vp(l)+xdk(l,kt)-xdi(l,kt)
2651                    continue
                      else
                        z3p(ntc+3)=z340+t(ntc)*tnati(1)
                        call multm(WPr,z3p,zp,ndim,ndim,
     1                             1)
                        do 2660l=1,3
                          zp(l)=zp(l)-x1p(l)
2660                    continue
                        call multm(MetTens(1,iswi,KPhase),zp,zpp,3,3,1)
                        dumm(kt)=sqrt(scalmul(zp,zpp))
                        do 2661l=1,3
                          zp(l)=zp(l)-xdi(l,kt)
                          zpp(l)=xdj(l,kt)
2661                    continue
                        call qbyx(zpp,zpp(4),iswj)
                        call cultm(WPr,zpp,zp,ndim,ndim,
     1                             1)
                        call CopyVek(zp,vm,3)
                      endif
                      call multm(MetTens(1,iswi,KPhase),vm,vmg,3,3,1)
                      call multm(MetTens(1,iswi,KPhase),um(1,kt),umg,3,
     1                           3,1)
                      vv=scalmul(vm,vmg)
                      call AddVekQ(sgx,sxdi(1,kt),sgxm,3)
                      call AddVekQ(sgx(4),sxdj(1,kt),sgxm(4),3)
                      call AddVekQ(sgx(7),sxdk(1,kt),sgxm(7),3)
                      call DistAng(um(1,kt),umg,vmg,dum(kt)**2,vv,sgxm,
     1                             pom,spom)
                      if(spom.lt..0001) spom=0.
                      dam (kt)= pom
                      dams(kt)=spom
                      if(pom.gt.dammx) then
                         dammx= pom
                        sdammx=spom
                      endif
                      if(pom.lt.dammn) then
                         dammn= pom
                        sdammn=spom
                      endif
                       damav= damav+ pom
                      sdamav=sdamav+spom
2675                  write(78) sp2,atom(k),kt,0.,pom,spom,oi(kt),
     1                          ok(kt),0.,0.,t80,t7,1
                      if(ieach.gt.0.and.VolaToDist) then
                        if(mod(kt-1,ieach).eq.0)
     1                    write(88) sp2,atom(k),kt,0.,pom,spom,oi(kt),
     2                              ok(kt),0.,0.,t80,t7,1
                      endif
2700                continue
                    if(VolaToDist) then
                      if(npom.gt.0) then
                        call DistM61AngleHeader(Atom(j),Atom(i),Atom(k),
     1                                          angle,su,t80)
                        if(iswi.eq.iswk) then
                          pom=1./float(npom)
                           damav= damav*pom
                          sdamav=sdamav*pom
                          call fflush
                          line=line+1
                          call DistRoundESD(Cislo,damav,sdamav,2)
                          l=idel(Cislo)
                          iven(line)='  ave        '//Cislo(:l)
                          s80='  ave : '//Cislo(:l)
                          call fflush
                          line=line+1
                          call DistRoundESD(Cislo,dammn,sdammn,2)
                          l=idel(Cislo)
                          iven(line)='  min        '//Cislo(:l)
                          s80=s80(:idel(s80))//'  min : '//Cislo(:l)
                          call fflush
                          line=line+1
                          call DistRoundESD(Cislo,dammx,sdammx,2)
                          l=idel(Cislo)
                          iven(line)='  max        '//Cislo(:l)
                          s80=s80(:idel(s80))//'  max : '//Cislo(:l)
                          call fflush
                          write(88) '#5',atom(k),isf(k),aik,umod,
     1                              t80,t7,1
                          write(61,FormA1)(s80(l:l),l=1,idel(s80))
                        endif
                        call fflush
                      else
                        line=max(line-1,0)
                        go to 7400
                      endif
                    endif
                    if(ieach.ne.0) then
                      l=0
                      do 2800kt=1,ntall(iswi),ieach
                        call RecUnpack(kt,nd,nti,ndimi)
                        do 2720m=1,ndimi
                          t(m)=tfirsti(m)+(nd(m)-1)*dti(m)
2720                    continue
                        l=l+1
                        pom=dam(kt)
                        spom=dams(kt)
                        if(oi(kt).gt.ocut.and.oj(kt).gt.ocut.and.
     1                     ok(kt).gt.ocut) then
                          if(VolaToDist) then
                            call fflush
                            line=line+1
                            write(iven(line),'(3x,f5.3)') t(1)
                            call DistRoundESD(Cislo,pom,spom,4)
                            iven(line)=iven(line)(:13)//
     1                        Cislo(:idel(Cislo))
                            write(61,FormTA)(t(m),m=1,ndimi),pom
                            if(oi(kt).le.oind.or.oj(kt).le.oind
     1                                       .or.ok(kt).le.oind)
     2                         iven(line)(2:2)='*'
                            call fflush
                          endif
                        endif
2800                  continue
                    endif
                    if(VolaToDist) then
                      call fflush
                      line=line+1
                      write(iven(line),'(26(''-''))')
                      call fflush
                    endif
7400              continue
7500            continue
7600          continue
7700        continue
7800      continue
7900    continue
8000  continue
9999  return
      end
      subroutine DistM61DistHeader(Atom1,Atom2,Value,ESD,Symmetry)
      include 'params.cmn'
      include 'basic.cmn'
      character*256 t256
      character*80  SymmetryOld
      character*(*) Atom1,Atom2,Atom3,Symmetry
      save SymmetryOld
      Klic=0
      i=4
      SymmetryOld=Symmetry
      go to 1000
      entry DistM61AngleHeader(Atom1,Atom2,Atom3,Value,ESD,Symmetry)
      Klic=1
      i=3
1000  call RoundESD(Cislo,Value,ESD,i,0,0)
      call zhusti(Cislo)
      t256=Atom1(:idel(Atom1))//'-'//Atom2(:idel(Atom2))
      if(Klic.eq.1) t256=t256(:idel(t256))//'-'//Atom3(:idel(Atom3))
      if(Klic.eq.0) then
        i=19
      else
        i=27
      endif
      t256(i:)=Cislo(:idel(Cislo))
      i=i+15
      t256(i:)=' symmetry : '//SymmetryOld(:idel(SymmetryOld))
      write(61,FormA1)(t256(k:k),k=1,idel(t256))
      if(Klic.eq.1) then
        t256=' '
        t256(i:)=' symmetry : '//Symmetry(:idel(Symmetry))
        write(61,FormA1)(t256(k:k),k=1,idel(t256))
      endif
      return
      end
      subroutine DistBudeBreak
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      logical FeYesNo
      if(FeYesNo(-1.,30.,'Do you really want to cancel the '//
     1           'distance calculation?',0)) then
        call DeleteFile(fln(:ifln)//'.m61')
        call FeFlowChartRemove
        ErrJana=1
        go to 9999
      endif
      ButtonFr=21
      ButtonTo=23
9999  return
      end
      subroutine outst
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      n=(mxl-1)/4+1
      do 1000i=1,n
       write(lst,'(4a32)')(iven(i+(j-1)*n),j=1,4)
1000  continue
      call SetStringArrayTo(iven,line,' ')
      return
      end
      subroutine fflush
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      if(line.eq.mxl) then
        call outst
        line=mxline
        call newpg(0)
        line=0
        mxl=mxl4
      endif
      return
      end
      subroutine ScodeCIF(jsym,jcntrsm,jcenter,jsh,isw,t7)
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      dimension jsh(3),jshp(3)
      character*(*) t7
      do 1000i=1,3
       jshp(i)=jsh(i)+5
       if(abs(vt6(i,jcenter,isw,KPhase)+s6(i,jsym,isw,KPhase)).gt..999)
     1   jshp(i)=jshp(i)-1
1000  continue
      write(t7,'(i3,''_'',3i1)')(jcenter-1)*ncvt+(jcntrsm-1)*ns+jsym,
     1                           jshp
      call zhusti(t7)
      if(t7.eq.'1_555') t7='.'
      return
      end
      subroutine SetCommandsDist
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      character*80 t80
      character*30 Men(6)
      integer FeMenu
      data Men/'%Basic commands','%Select central atoms',
     1         'S%elect neighbour atoms','%Torsion angles',
     2         '%Planes','%Modulation commands'/
      call RewriteTitle('Dist-commands')
      call iom50(0,0)
      if(ErrJana.ne.0) return
      call iom40(0,0)
      if(ErrJana.eq.-1) then
        call CrlbCorrectAtomNames(ich)
        if(ich.ne.0) then
          ErrJana=1
          go to 9999
        endif
      else if(ErrJana.ne.0) then
        go to 9999
      endif
      call DefaultDist
      NacetlReal(nCmddmhk)=-1.
      call NactiDist
      call DeleteFile(fln(:ifln)//'_torpl.tmp')
      do 1000i=nCmdTorsion,nCmdbondval
        call MakeKeyWordFile(NactiKeywords(i)(:idel(NactiKeywords(i))),
     1                       'dist')
1000  continue
      call MakeStarFile('dist')
      call OpenFile(lst,CmdFileName(:LCmdFileName),'formatted','unknown'
     1              )
      call pisat
      call CloseIfOpened(lst)
      if(ndim.eq.3) then
        nmen=5
      else
        nmen=6
      endif
1010  i=FeMenu(-1.,-1.,men,1,nmen,1,0)
      if(i.eq.1) then
        call BasicCommandsD
      else if(i.eq.2) then
        call SelAtomsFromPhase('The central atoms for distance '//
     1                         'calculation',Atom,BratPrvni,kswa,isf,
     2                         nacalc,.false.,ich)
      else if(i.eq.3) then
        call SelAtomsFromPhase('The neighbour atoms for distance '//
     1                         'calculation',Atom,BratDruhyATreti,kswa,
     2                         isf,nacalc,.false.,ich)
      else if(i.eq.4) then
        call ReadTorsion
      else if(i.eq.5) then
        call ReadPlane
      else if(i.eq.6) then
        call ModulationCommandsD
      endif
      if(i.ge.1.and.i.le.nmen) go to 1010
      call WriteKeys('dist')
      if(ndimi.gt.0) then
        if(ndimi.eq.1) then
          k=100
        else
          k=20
        endif
        do 1120i=1,ndimi
          if(nt(i,1).ne.k) then
            write(t80,'(3i10)')(nt(j,1),j=1,ndimi)
            k=0
            call WriteLabeledRecord(55,NactiKeywords(nCmdnooft),t80,k)
            go to 1130
          endif
1120    continue
1130    do 1135i=1,ndimi
          if(tfirst(i,1).ne.0.) then
            write(t80,'(3f8.6)')(tfirst(j,1),j=1,ndimi)
            k=0
            call WriteLabeledRecord(55,NactiKeywords(nCmdtfirst),t80,k)
            go to 1140
          endif
1135    continue
1140    do 1145i=1,ndimi
          if(tlast(i,1).ne.1.) then
            write(t80,'(3f8.6)')(tlast(j,1),j=1,ndimi)
            k=0
            call WriteLabeledRecord(55,NactiKeywords(nCmdtlast),t80,k)
            go to 1150
          endif
1145    continue
      endif
1150  do 1155i=1,nacalc
        if(.not.BratPrvni(i).and.kswa(i).eq.KPhase) then
          t80=IdDist(nCmdSelfirst)
          do 1152j=1,nacalc
            if(BratPrvni(j).and.kswa(j).eq.KPhase) then
              if(idel(t80).gt.72) then
                write(55,FormA1)(t80(k:k),k=1,idel(t80))
                t80=IdDist(nCmdSelfirst)
              endif
              t80=t80(:idel(t80))//' '//atom(j)
            endif
1152      continue
          if(idel(t80).gt.idel(IdDist(nCmdSelfirst)))
     1      write(55,FormA1)(t80(k:k),k=1,idel(t80))
          go to 1157
        endif
1155  continue
1157  do 1160i=1,nacalc
        if(.not.BratDruhyATreti(i).and.kswa(i).eq.KPhase) then
          t80=IdDist(nCmdSelsecnd)
          do 1158j=1,nacalc
            if(BratDruhyATreti(j).and.kswa(j).eq.KPhase) then
              if(idel(t80).gt.72) then
                write(55,FormA1)(t80(k:k),k=1,idel(t80))
                t80=IdDist(nCmdSelsecnd)
              endif
              t80=t80(:idel(t80))//' '//atom(j)
            endif
1158      continue
          if(idel(t80).gt.idel(IdDist(nCmdSelsecnd)))
     1      write(55,FormA1)(t80(k:k),k=1,idel(t80))
          go to 1170
        endif
1160  continue
1170  do 1200i=nCmdTorsion,nCmdbondval
         call MergeFileToM50(NactiKeywords(i))
1200  continue
      call MergeFileToM50('star')
      write(55,'(''end'')')
      call DopisKeys(0)
      call RewriteTitle(' ')
9999  return
      end
      subroutine BasicCommandsD
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      character*256 EdwStringQuest
      character*80 t80
      integer CrwStateQuest
      logical CrwLogicQuest
      id=NextQuestId()
      call FeQuestCreate(id,-1.,-1.,220.,0,9,'Basic commands',0,
     1                   LightGray,0,0)
      il=1
      call FeQuestEdwMake(id,5.,il,30.,il,'%Title','L',185.,EdwYd,0)
      nEdwTitle=EdwLastMade
      call FeQuestStringEdwOpen(EdwLastMade,Title)
      il=il+1
      call FeQuestCrwMake(id,5.,il,100.,il,'%Round input coordinates',
     1                    'L',CrwXd,CrwYd,0,0)
      nCrwRound=CrwLastMade
      call FeQuestCrwMake(id,145.,il,207.,il,'%Calculate angles','L',
     1                    CrwXd,CrwYd,1,0)
      nCrwAngles=CrwLastMade
      il=il+1
      call FeQuestCrwMake(id,5.,il,100.,il,'List %full coordination',
     1                    'L',CrwXd,CrwYd,0,0)
      nCrwFullCoor=CrwLastMade
      do 1000i=1,2
        if(i.eq.1) then
          j=nCmdirnd
          nCrw=nCrwRound
        else if(i.eq.2) then
          j=nCmdiuhl
          nCrw=nCrwAngles
        else
          j=nCmdfullcoo
          nCrw=nCrwFullCoor
        endif
        call FeQuestCrwOpen(nCrw,NacetlInt(j).eq.1)
1000  continue
      do 1100i=1,2
        if(i.eq.1) then
          t80='d(mi%n)'
        else
          t80='d(ma%x)'
        endif
        il=il+1
        call FeQuestEdwMake(id,145.,il,170.,il,t80,'L',45.,EdwYd,0)
        if(i.eq.1) then
          nEdwDmin=EdwLastMade
          call FeQuestRealEdwOpen(EdwLastMade,NacetlReal(nCmddmdk),
     1                            .false.,.false.)
        else
          nEdwDmax=EdwLastMade
          call FeQuestCrwMake(id,5.,il,125.,il,'d(max) according '//
     1                        'to chemical t%ype','L',CrwXd,CrwYd,1,0)
          nCrwChemType=CrwLastMade
          call FeQuestCrwOpen(CrwLastMade,NacetlReal(nCmddmhk).lt.0.)
        endif
1100  continue
      il=il+1
      call FeQuestLineMake(id,il)
      il=il+1
      call FeQuestLabelMake(id,110.,il,'Include peaks from Fourier '//
     1                      'calculation','C')
      xpom=27.5
      il=il+1
      do 1200i=1,4
        if(i.eq.1) then
          t80='n%one'
        else if(i.eq.2) then
          t80='m%axima'
        else if(i.eq.3) then
          t80='m%inima'
        else
          t80='%both'
        endif
        call FeQuestCrwMake(id,xpom,il,xpom-4.,il+1,t80,'C',CrwgXd,
     1                      CrwgYd,0,1)
        if(i.eq.1) nCrwFromFourier=CrwLastMade
        call FeQuestCrwOpen(CrwLastMade,NacetlInt(nCmdincl).eq.i-1)
        xpom=xpom+55.
1200  continue
      icont=0
2000  if(.not.CrwLogicQuest(nCrwChemType))
     1  call FeQuestRealEdwOpen(nEdwDmax,NacetlReal(nCmddmhk),.false.,
     2                          .false.)
      if(CrwLogicQuest(nCrwAngles)) then
        call FeQuestCrwClose(nCrwFullCoor)
        NacetlInt(nCmdfullcoo)=1
      else
        if(CrwStateQuest(nCrwFullCoor).eq.CrwClosed)
     1    call FeQuestCrwOpen(nCrwFullCoor,NacetlInt(nCmdfullcoo).eq.1)
      endif
2500  call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.eq.EventCrw.and.CheckNumber.eq.nCrwChemType) then
        if(CrwLogicQuest(nCrwChemType)) then
          EventType=0
          NacetlReal(nCmddmhk)=-1.
          call FeQuestEdwClose(nEdwDmax)
        else
          NacetlReal(nCmddmhk)=2.5
          EventType=EventEdw
          EventNumber=nEdwDmax
          go to 2000
        endif
        go to 2500
      else if(CheckType.eq.EventCrw.and.CheckNumber.eq.nCrwAngles) then
        icont=0
        go to 2000
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      if(ich.eq.0) then
        do 3000i=1,3
          if(i.eq.1) then
            j=nCmdirnd
            nCrw=nCrwRound
          else if(i.eq.2) then
            j=nCmdiuhl
            nCrw=nCrwAngles
          else
            j=nCmdfullcoo
            nCrw=nCrwFullCoor
          endif
          if(CrwStateQuest(nCrw).ne.CrwClosed) then
            if(CrwLogicQuest(nCrw)) then
              nacetlInt(j)=1
            else
              nacetlInt(j)=0
            endif
          endif
3000    continue
        nCrw=nCrwFromFourier
        do 3100i=1,4
          if(CrwLogicQuest(nCrw)) then
            NacetlInt(nCmdincl)=i-1
            go to 3300
          endif
          nCrw=nCrw+1
3100    continue
3300    Title=EdwStringQuest(nEdwTitle)
        call FeQuestRealFromEdw(nEdwDMin,NacetlReal(nCmddmdk))
        if(.not.CrwLogicQuest(nCrwChemType))
     1    call FeQuestRealFromEdw(nEdwDMax,NacetlReal(nCmddmhk))
      endif
      call FeQuestRemove(id)
      return
      end
      subroutine ModulationCommandsD
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      include 'fepc.cmn'
      logical CrwLogicQuest
      id=NextQuestId()
      if(kcommen.le.0) then
        il=7
      else
        il=4
      endif
      call FeQuestCreate(id,-1.,-1.,140.,0,il,'Modulation commands',0,
     1                   LightGray,0,0)
      il=1
      if(kcommen.le.0) then
        call FeQuestEdwMake(id,5.,il,105.,il,'%First t','L',30.,EdwYd,0)
        nEdwTfirst=EdwLastMade
        call FeQuestRealAEdwOpen(EdwLastMade,tfirst,ndimi,.false.,
     1                           .false.)
        il=il+1
        call FeQuestEdwMake(id,5.,il,105.,il,'%Last t','L',30.,EdwYd,0)
        nEdwTlast=EdwLastMade
        call FeQuestRealAEdwOpen(EdwLastMade,tlast,ndimi,.false.,
     1                           .false.)
        il=il+1
        call FeQuestEdwMake(id,5.,il,105.,il,'%Number of steps in t',
     1                      'L',30.,EdwYd,0)
        nEdwNoOfT=EdwLastMade
        call FeQuestIntAEdwOpen(EdwLastMade,nt,ndimi,.false.)
        il=il+1
        call FeQuestEdwMake(id,5.,il,105.,il,'%Print t period','L',30.,
     1                      EdwYd,0)
        nEdwTPrint=EdwLastMade
        call FeQuestIntEdwOpen(EdwLastMade,NacetlInt(nCmdieach),.false.)
      else
        nEdwTfirst=0
        nEdwTlast=0
        nEdwNoOfT=0
        call FeQuestCrwMake(id,5.,il,105.,il,'Print %individual '//
     1                      'distances','L',CrwXd,CrwYd,0,0)
        call FeQuestCrwOpen(CrwLastMade,NacetlInt(nCmdieach).gt.0)
        nCrwTPrint=CrwLastMade
      endif
      il=il+1
      call FeQuestCrwMake(id,5.,il,105.,il,'Make coordination '//
     1                    't-%tables','L',CrwXd,CrwYd,0,0)
      nCrwTCoor=CrwLastMade
      call FeQuestCrwOpen(CrwLastMade,NacetlInt(nCmdittab).eq.1)
      il=il+1
      call FeQuestEdwMake(id,5.,il,105.,il,'Occupancy %calculation '//
     1                    'limit','L',30.,EdwYd,0)
      nEdwOcut=EdwLastMade
      call FeQuestRealEdwOpen(EdwLastMade,NacetlReal(nCmdocut),.false.,
     1                        .false.)
      il=il+1
      call FeQuestEdwMake(id,5.,il,105.,il,'Occupancy in%dication '//
     1                    'limit','L',30.,EdwYd,0)
      nEdwOind=EdwLastMade
      call FeQuestRealEdwOpen(EdwLastMade,NacetlReal(nCmdoind),.false.,
     1                        .false.)
      icont=0
2500  call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.ne.0) then
        call NebylOsetren
        go to 2500
      endif
      if(ich.eq.0) then
        if(CrwLogicQuest(nCrwTCoor)) then
          NacetlInt(nCmdittab)=1
        else
          NacetlInt(nCmdittab)=0
        endif
        if(kcommen.le.0) then
          call FeQuestIntAFromEdw(nEdwNoOfT,nt)
          call FeQuestRealAFromEdw(nEdwTfirst,tfirst)
          call FeQuestRealAFromEdw(nEdwTlast ,tlast)
          call FeQuestIntFromEdw(nEdwTPrint,NacetlInt(nCmdieach))
        else
          if(CrwLogicQuest(nCrwTPrint)) then
            NacetlInt(nCmdieach)=1
          else
            NacetlInt(nCmdieach)=0
          endif
        endif
        call FeQuestRealFromEdw(nEdwOcut,NacetlReal(nCmdocut))
        call FeQuestRealFromEdw(nEdwOind,NacetlReal(nCmdoind))
      endif
      call FeQuestRemove(id)
      return
      end
      subroutine ReadTorsion
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      character*256 t80
      character*4 t4
      character*2 nty
      external TorsionMakeCommand,TorsionEdwCheck
      RepEmptyString='torsion'
      call RepeatCommandsProlog(id,'torsion')
      call FeQuestCreate(id,-1.,-1.,200.,0,5,' ',1,LightGray,0,0)
      call RepeatCommandsBottomId(id,nRepAll.ne.0,'Torsion command',4)
      xpom=5.
      do 1050i=1,4
        write(t4,'(''%'',i1,a2)') i,nty(i)
        call FeQuestEdwMake(id,xpom+20.,2,xpom,3,t4//' atom','C',40.,
     1                      EdwYd,1)
        nEdw=EdwLastMade
        if(i.eq.1) nRepEdwFr=nEdw
        xpom=xpom+50.
1050  continue
      nRepEdwTo=nEdw
      nRepCrwFr=0
      nRepCrwTo=0
      icont=0
      nRepActive=max(1,nRepAll)
1100  call RepeatCommandsUpDown
      k=0
      call kus(RepActiveCommand(1),k,t80)
      RepButEnableLogic=t80(1:1).ne.'!'
      do 1200nEdw=nRepEdwFr,nRepEdwTo
        call kus(RepActiveCommand(1),k,t80)
        call UprAt(t80)
        call FeQuestStringEdwOpen(nEdw,t80)
1200  continue
1300  call RepeatEvent(id,icont,ich,TorsionMakeCommand,
     1                 TorsionEdwCheck)
      if(ich.eq.1) then
        go to 1100
      else if(ich.eq.2) then
        go to 1300
      endif
      return
      end
      subroutine TorsionMakeCommand
      include 'const.cmn'
      include 'fepc.cmn'
      character*256 EdwStringQuest,t256
      call RepeatMakeCommandHeader
      do 1000nEdw=nRepEdwFr,nRepEdwTo
        t256=EdwStringQuest(nEdw)
        id=idel(t256)
        if(id.le.0) go to 9000
        RepActiveCommand(1)=
     1   RepActiveCommand(1)(:idel(RepActiveCommand(1))+1)//t256(:id)
1000  continue
      go to 9999
9000  RepActiveCommand(1)=RepEmptyString
9999  return
      end
      subroutine TorsionEdwCheck(ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      character*256 EdwStringQuest,t256
      do 1000nEdw=nRepEdwFr,nRepEdwTo
        t256=EdwStringQuest(nEdw)
        call TestAtomsString(t256,0,1,0,1,ich)
        if(ich.ne.0) go to 9999
        call FeQuestStringEdwOpen(nEdw,t256)
1000  continue
9999  return
      end
      subroutine ReadPlane
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      dimension nn(2)
      character*256 t256
      character*80 t80
      external PlaneMakeCommand,PlaneEdwCheck
      RepEmptyString='plane 0 0'
      call RepeatCommandsProlog(id,'plane')
      call FeQuestCreate(id,-1.,-1.,200.,0,8,' ',1,LightGray,0,0)
      call RepeatCommandsBottomId(id,nRepAll.ne.0,'Plane command',7)
      call FeQuestEdwMake(id,100.,2,5.,3,'Atoms defining the best '//
     1                    '%plane','C',190.,EdwYd,1)
      nRepEdwFr=EdwLastMade
      call FeQuestEdwMake(id,100.,4,5.,5,'Additional atoms to calculate'
     1                  //' distanes %from the plane','C',190.,EdwYd,1)
      nRepEdwTo=EdwLastMade
      nRepCrwFr=0
      nRepCrwTo=0
      icont=0
      nRepActive=max(1,nRepAll)
1100  call RepeatCommandsUpDown
      do 1102nEdw=nRepEdwFr,nRepEdwTo
        call FeQuestStringEdwOpen(nEdw,' ')
1102  continue
      k=0
      call kus(RepActiveCommand(1),k,t80)
      RepButEnableLogic=t80(1:1).ne.'!'
      call StToInteger(RepActiveCommand(1),k,nn(1),1,.false.,ich)
      if(ich.ne.0) then
        nn(1)=0
        nn(2)=0
      else
        call StToInteger(RepActiveCommand(1),k,nn(2),1,.false.,ich)
        if(ich.ne.0) nn(2)=0
      endif
      if(RepActiveCommand(1).ne.RepEmptyString) then
        idl=0
        n=0
        nEdw=nRepEdwFr
        do 1150i=2,nRepActiveCommand
          k=0
1110      call kus(RepActiveCommand(i),k,t80)
          idp=idel(t80)
          n=n+1
          if(idl.eq.0.or.(n.eq.nn(1)+1.and.nn(1).gt.0)) then
            if(idl.gt.0) then
              call FeQuestStringEdwOpen(nEdw,t256)
              nEdw=nEdw+1
            endif
            t256=t80
            idl=idp
          else
            t256=t256(:idl)//' '//t80(:idp)
            idl=idl+idp+1
          endif
          if(k.lt.80) go to 1110
1150    continue
        call FeQuestStringEdwOpen(nEdw,t256)
        if(nn(1).le.0) nn(1)=n
        if(nn(2).le.0) nn(2)=n
      endif
1300  call RepeatEvent(id,icont,ich,PlaneMakeCommand,PlaneEdwCheck)
      if(ich.eq.1) then
        go to 1100
      else if(ich.eq.2) then
        go to 1300
      endif
      return
      end
      subroutine PlaneEdwCheck(ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      character*256 EdwStringQuest,t256
      do 1000nEdw=nRepEdwFr,nRepEdwTo
        t256=EdwStringQuest(nEdw)
        call TestAtomsString(t256,1,1,0,1,ich)
        if(ich.ne.0) go to 9999
        call FeQuestStringEdwOpen(nEdw,t256)
1000  continue
9999  return
      end
      subroutine PlaneMakeCommand
      include 'const.cmn'
      include 'fepc.cmn'
      character*80 t80
      character*256 EdwStringQuest,t256
      dimension nn(2)
      call RepeatMakeCommandHeader
      nEdw=nRepEdwFr
      n=1
      do 2000i=1,2
        t256=EdwStringQuest(nEdw)
        nn(i)=0
        if(idel(t256).le.0) go to 2000
        k=0
        id=0
1000    call kus(t256,k,t80)
        nn(i)=nn(i)+1
        idp=idel(t80)
        if(id.eq.0.or.id+idp+1.gt.80) then
          n=n+1
          RepActiveCommand(n)=t80
          id=idp
        else
          RepActiveCommand(n)=RepActiveCommand(n)(:id)//' '//t80(:idp)
          id=id+1+idp
        endif
        if(k.lt.256) go to 1000
        nEdw=nEdw+1
2000  continue
      nRepActiveCommand=n
      write(t80,'(2i5)') nn(1),nn(1)+nn(2)
      call ZdrcniCisla(t80,2)
      RepActiveCommand(1)=
     1  RepActiveCommand(1)(:idel(RepActiveCommand(1)))//' '//t80
      return
      end
      subroutine DistRoundESD(String,Value,SValue,DecimalPoints)
      character*(*) String
      integer DecimalPoints
      call RoundESD(String,Value,SValue,6,0,0)
      if(index(String,'(').le.0) then
        k=index(String,'.')
        if(k.gt.0) String(k+DecimalPoints+1:)=' '
      endif
      return
      end

