      subroutine Grapht
      include 'params.cmn'
      include 'basic.cmn'
      call GrtSetBondValCoeff
      call GrtRightButtons
      if(ngc.ne.0) call DeleteFile(PreviousM50)
      call DeleteFile(PreviousM40)
      return
      end
      subroutine GrtRightButtons
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      include 'grapht.cmn'
      include 'contour.cmn'
      include 'dist.cmn'
      character*12 jmena(11)
      integer GraphtQuest,ButtonStateQuest
      logical GraphExists
      data jmena/'%Quit','%Print','%Save','%New/Edit','G%-','G%+',
     1           '%Go to','%Contours','%Locator','Cur%ves','%Options'/
      VolaToDist=.false.
      call inm40(GraphExists)
c      call ComSym(KPhase,0)
      GraphtQuest=NextQuestId()
      CheckMouse=.true.
      call FeQuestAbsCreate(GraphtQuest,0.,0.,XMaxBasWin,YMaxBasWin,
     1                      ' ',0,0,-1,-1)
      call FeMakeGrWin(0.,40.,14.,14.)
      call FeMakeAcWin(20.,8.,10.,10.)
      pom=YMaxGrWin
      ypom=YMaxBasWin-24.
      wpom=34.
      xpom=(XMaxBasWin+XMaxGrWin-wpom)*.5
      call FeTwoPixLineHoriz(XMaxGrWin+PixelX,XMaxBasWin,pom,
     1                       Gray,White)
      ContourYSep(1)=pom
      k=1
      if(KCommen.le.0) then
        ik=10
      else
        ik=11
      endif
      do 1100i=1,ik
        ActiveButtBas(i)=.false.
        call FeQuestAbsButtonMake(GraphtQuest,xpom,ypom,
     1                            wpom,ButYd,Jmena(i))
        if(i.eq.1) then
          nButtQuit=ButtonLastMade
        else if(i.eq.2) then
          nButtPrint=ButtonLastMade
        else if(i.eq.3) then
          nButtSave=ButtonLastMade
        else if(i.eq.4) then
          nButtNewGraph=ButtonLastMade
          wpom=wpom/2.-2.5
          nButtBasFr=ButtonLastMade
        else if(i.eq.5) then
          nButtMinus=ButtonLastMade
          xpom=xpom+wpom+5.
          ypom=ypom+10.
        else if(i.eq.6) then
          nButtPlus=ButtonLastMade
          wpom=34.
          xpom=(XMaxBasWin+XMaxGrWin-wpom)*.5
        else if(i.eq.7) then
          nButtGoTo=ButtonLastMade
        else if(i.eq.8) then
          nButtContours=ButtonLastMade
        else if(i.eq.9) then
          nButtLocator=ButtonLastMade
        else if(i.eq.10) then
          nButtCurves=ButtonLastMade
        else if(i.eq.11) then
          nButtOptions=ButtonLastMade
        endif
        if(i.le.4.or.ndimi.gt.1.or.
     1     (i.eq.11.and.kcommen.gt.0.and.ndimi.eq.1)) then
          j=ButtonOff
        else
          j=ButtonDisabled
        endif
        ActiveButtBas(i)=.true.
        call FeQuestButtonOpen(ButtonLastMade,j)
        ypom=ypom-10.
1050    if(i.eq.3.or.i.eq.7.or.i.eq.10.or.i.eq.11) then
          ypom=ypom-4.
          pom=ypom+(14.+ButYd)*.5
          call FeTwoPixLineHoriz(XMaxGrWin+PixelX,XMaxBasWin,pom,
     1                           Gray,White)
          k=k+1
          ContourYSep(k)=pom
        endif
1100  continue
      nButtBasTo=ButtonLastMade
      do 1300i=1,3
        if(i.eq.1) then
          xpom=XMinBasWin+2.
          ypom=YmaxBasWin-11.
          dpom=60.
        else if(i.eq.2) then
          xpom=xpom+190.
          dpom=dpom+ 25.
        else if(i.eq.3) then
          xpom=xpom+35.
          ypom=YMinGrWin-12.
          dpom=50.
        endif
        call FeQuestAbsEdwMake(GraphtQuest,0.,0.,xpom,ypom,' ','C',
     1                         dpom,EdwYd,0)
        ContourEdwInfo(i)=EdwLastMade
1300  continue
      GraphExists=.false.
      icont=0
      ib=nButtNewGraph
2000  if(GraphExists) then
        j=ButtonOff
      else
        j=ButtonDisabled
      endif
      call FeQuestButtonOpen(nButtSave,j)
      call FeQuestButtonOpen(nButtPrint,j)
      call FeQuestButtonOpen(nButtLocator,j)
      if(kcommen.ne.0) call FeQuestButtonOpen(nButtOptions,j)
      if(WhatToDraw.eq.1) then
        call FeQuestButtonOpen(nButtCurves,j)
        call FeQuestButtonOpen(nButtContours,j)
      else
        call FeQuestButtonOpen(nButtCurves,ButtonDisabled)
        call FeQuestButtonOpen(nButtContours,ButtonDisabled)
      endif
      if(ndimi.gt.1) then
        if(NMapGrt.gt.1) then
          j=ButtonOff
        else
          j=ButtonDisabled
        endif
        call FeQuestButtonOpen(nButtMinus,j)
        if(NMapGrt.lt.NxMapMx) then
          j=ButtonOff
        else
          j=ButtonDisabled
        endif
        call FeQuestButtonOpen(nButtPlus,j)
      endif
      if(ButtonStateQuest(nButtPlus ).eq.ButtonOff.or.
     1   ButtonStateQuest(nButtMinus).eq.ButtonOff) then
        call FeQuestButtonOff(nButtGoto)
      else
        call FeQuestButtonDisable(nButtGoto)
      endif
2090  ButtonFlash=.true.
      i=ib+ButtonFr-1
      call FeMoveMouseTo((ButtonXMin(i)+ButtonXMax(i))*.5,
     1                   (ButtonYMin(i)+ButtonYMax(i))*.5)
      call FeQuestEvent(GraphtQuest,icont,ich)
2100  HardCopy=0
      ErrJana=0
2110  if(CheckType.eq.EventButton) then
        ib=CheckNumber
        call FeQuestButtonOn(ib)
        if(CheckNumber.eq.nButtQuit) then
          call FeQuestRemove(GraphtQuest)
          go to 9999
        else if(CheckNumber.eq.nButtNewGraph) then
          call GrtDefParams(ich)
          if(ich.eq.0) call GrtDrawCurveOrMap(0)
          GraphExists=.true.
        else if(CheckNumber.eq.nButtPrint.or.CheckNumber.eq.nButtSave)
     1    then
          i=CheckNumber
          if(EventNumber.eq.nButtPrint) then
            HardCopy=-PrintStyle
          else
            call FeSavePicture('graph',6)
            if(HardCopy.le.0) then
              HardCopy=0
              go to 2900
            endif
          endif
          call GrtDrawCurveOrMap(0)
        else if(CheckNumber.eq.nButtMinus) then
          call GrtDrawCurveOrMap(-1)
        else if(CheckNumber.eq.nButtPlus) then
          call GrtDrawCurveOrMap( 1)
        else if(CheckNumber.eq.nButtGoto) then
          call GrtGoTo(ich)
          if(ich.eq.0) call GrtDrawCurveOrMap(0)
        else if(CheckNumber.eq.nButtContours) then
          call DefContour(ich)
          if(ich.eq.0) call GrtDrawMap(0)
        else if(CheckNumber.eq.nButtLocator) then
          if(WhatToDraw.eq.0) then
            call GrtLocator
          else
            call PCurves(1)
          endif
        else if(CheckNumber.eq.nButtOptions) then
          call GrtReadOptions(ich)
          if(ich.eq.0) call GrtDrawCurveOrMap(0)
        else if(CheckNumber.eq.nButtCurves) then
          call PCurves(0)
        endif
2900    call FeQuestButtonOff(ib)
        if(ib.eq.nButtLocator) ib=nButtNewGraph
        go to 2000
      else if(CheckType.eq.EventMouse.and.CheckNumber.eq.JeRightDown)
     1  then
        go to 2100
      else
        go to 2090
      endif
      go to 2000
9999  return
      end
      subroutine GrtDefParams(ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      include 'grapht.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      dimension xsym(3),x4dif(3),tdif(3)
      character*256 EdwStringQuest
      character*80  SymPom,Veta
      character*40  Label,LabelOld
      character*20  MenuParType(7)
      character*15  LabelTypeOfGraph
      character*8   AtPom
      character*2   nty
      integer FeMenu,ColorOrder,WhatToDrawOld,PocetParType,EdwStateQuest
     1       ,CrwStateQuest
      logical CrwLogicQuest
      data icolor/-1/,LabelTypeOfGraph/'Type of graph :'/
      data MenuParType/'Occupancy','Position','ADP parameter',
     1                 'Torsion angle','Distances','Bond valence sum',
     2                 'Angles'/
      data PocetParType/7/
      call GrtSaveDrawAtom
      HardCopy=0
      WhatToDrawOld=-1
      NParOld=-1
      NAtomsOld=0
      id=NextQuestId()
      xdq=220.
      xdqp=xdq*.5
      if(ndimi.gt.1) then
        il=11+ndimi
      else
        il=11
      endif
      call FeQuestCreate(id,-1.,-1.,xdq,0,il,' ',1,LightGray,0,0)
      il=1
      LabelOld=' '
      call FeQuestUpDownMake(id,xdqp-40.-UpDownXd,il,UpDownXd,
     1                       UpDownYd,'down')
      nUpDownPrevious=UpDownLastMade
      call FeQuestUpDownMake(id,xdqp+40.,il,UpDownXd,UpDownYd,'up')
      nUpDownNext=UpDownLastMade
      nCrwGroup=0
      if(ndimi.gt.1) then
        nCrwGroup=nCrwGroup+1
        il=il+1
        tpom=5.
        call FeQuestLabelMake(id,tpom,il,LabelTypeOfGraph,'L')
        tpom=FeTxLengthUnder(LabelTypeOfGraph)+10.
        do 1010i=0,1
          if(i.eq.0) then
            Veta='%1d graph'
            dpom=FeTxLengthUnder(Veta)+3.
          else
            Veta='  %2d map'
          endif
          xpom=tpom+dpom+3.
          call FeQuestCrwMake(id,tpom,il,xpom,il,Veta,'L',CrwgXd,CrwgYd,
     1                        1,nCrwGroup)
          call FeQuestCrwOpen(CrwLastMade,WhatToDraw.eq.i)
          if(i.eq.0) nCrwTypeFirst=CrwLastMade
          tpom=xpom+12.
1010    continue
        nCrwTypeLast=CrwLastMade
      else
        WhatToDraw=0
      endif
      do 1011i=1,4
        il=il+1
        write(Veta,'(''%'',i1,a2,'' atom'')') i,nty(i)
        tpom=5.
        xpom=tpom+FeTxLengthUnder(Veta)+3.
        dpom=FeTxLengthUnder('XXXXXXXX')+5.
        call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,1)
        if(i.eq.1) nEdwName=EdwLastMade
        xpom=xpom+dpom+5.
        Veta='List'
        dpom=FeTxLengthUnder(Veta)+5.
        xpom=xpom+2.
        call FeQuestButtonMake(id,xpom,il,dpom,ButYd,Veta)
        if(i.eq.1) then
          nButtAtomList=ButtonLastMade
          call FeQuestButtonOpen(ButtonLastMade,ButtonOff)
        endif
        tpom=xpom+dpom+10.
        Veta='Symmetry code'
        xpom=tpom+FeTxLengthUnder(Veta)+5.
        dpom=xdq-xpom-5.
        call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,1)
        if(i.eq.1) nEdwSymCode=EdwLastMade
1011  continue
      Veta='D%efine neighbour atoms'
      dpom=FeTxLengthUnder(Veta)+10.
      xpom=xdq-dpom-5.
      call FeQuestButtonMake(id,xpom,3,dpom,ButYd,Veta)
      nButtNeighbours=ButtonLastMade
      il=il+1
      dpom=25.
      posun=dpom+8.
      tpom=5.
      xpom=tpom+FeTxLengthUnder('X')+5.+dpom*.5
      do 1020i=1,3
        if(i.eq.1) then
          Veta='Minimum'
        else if(i.eq.2) then
          Veta='Maximum'
        else if(i.eq.3) then
          Veta='Step'
        endif
        call FeQuestLabelMake(id,xpom,il,Veta,'C')
        xpom=xpom+posun
1020  continue
      ilp=il
      do 1050i=1,ndimi+1
        il=il+1
        tpom=5.
        xpom=tpom+FeTxLengthUnder('X')+5.
        if(i.le.ndimi) then
          k=3
          Veta=smbt(i)
        else
          k=2
          Veta='p'
        endif
        do 1045j=1,3
          if(j.le.k) then
            call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,
     1                          0)
            if(i.eq.1.and.j.eq.1) then
              nEdwTLim=EdwLastMade
            else if(i.eq.ndimi+1.and.j.eq.1) then
              nEdwPLim=EdwLastMade
            endif
            if(i.le.ndimi) then
              pom=gx(j,i)
            else
              pom=gy(j)
            endif
            call FeQuestRealEdwOpen(EdwLastMade,pom,.false.,.false.)
          endif
          tpom=tpom+posun
          xpom=xpom+posun
          Veta=' '
1045    continue
1050  continue
      dpom=0.
      do 1060i=1,PocetBarev
        dpom=max(dpom,FeTxLength(ColorNames(i)))
1060  continue
      tpom=xpom
      dpom=dpom+10.
      Veta='%Color'
      xpom=tpom+FeTxLengthUnder(Veta)+3.
      call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,0)
      xpom1=FeXPixRound(xpom)+FeXPixRound(dpom)+5.*PixelX
      nEdwColor=EdwLastMade
      call FeQuestUpDownMake(id,xpom1,il,UpDownXd,UpDownYd,'up')
      nUpDownColor=UpDownLastMade
      Veta='Draw n%on-modulated curves'
      call FeQuestCrwMake(id,tpom+CrwXd+3.,il,tpom,il,Veta,'L',
     1                    CrwXd,CrwYd,0,0)
      nCrwNonMod=CrwLastMade
      xpom=tpom
      if(ndimi.gt.1) then
        xpom=xpom+5.
        do 1070i=1,ndimi
          nCrwGroup=nCrwGroup+1
          il=ilp
          write(Veta,'(i1,a2)') i,nty(i)
          call FeQuestLabelMake(id,xpom+4.,il,Veta,'C')
          do 1065j=1,ndimi
            il=il+1
            call FeQuestCrwMake(id,xpom,il,xpom,il,' ','C',CrwgXd,
     1                          CrwgYd,1,nCrwGroup)
            if(i.eq.1.and.j.eq.1) nCrwOrientFirst=CrwLastMade
1065      continue
          xpom=xpom+15.
1070    continue
        nCrwOrientLast=CrwLastMade
      endif
      if(ndimi.gt.1) then
        il=il+1
        Veta='%Reference level explicitely'
        xpom=5.
        tpom=xpom+CrwXd+3.
        call FeQuestCrwMake(id,tpom,il,xpom,il,Veta,'L',CrwXd,CrwYd,1,0)
        nCrwRefLevel=CrwLastMade
        tpom=tpom+FeTxLengthUnder(Veta)+2.
        Veta='=>'
        xpom=tpom+FeTxLengthUnder(Veta)+2.
        call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,0)
        nEdwRefLevel=EdwLastMade
      endif
      il=il+1
      Veta='%Parameter to draw'
      tpom=5.
      xpom=tpom+FeTxLengthUnder(Veta)+5.
      dpom=0.
      do 1075i=1,PocetParType
        dpom=max(dpom,FeTxLength(MenuParType(i)))
1075  continue
      dpom=dpom+10.
      call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,0)
      xpom1=FeXPixRound(xpom)+FeXPixRound(dpom)+5.*PixelX
      nEdwParType=EdwLastMade
      call FeQuestUpDownMake(id,xpom1,il,UpDownXd,UpDownYd,'up')
      nUpDownParType=UpDownLastMade
      call FeQuestUpDownOpen(UpDownLastMade,UpDownOff)
      il=il+1
      Veta='Ma%ximal distance'
      dpom=25.
      call FeQuestEdwMake(id,tpom,il,xpom,il,Veta,'L',dpom,EdwYd,0)
      nEdwDMax=EdwLastMade
      Veta='De%fine bond valence coefficients'
      dpom=FeTxLengthUnder(Veta)+10.
      pom=xdq-dpom-5.
      call FeQuestButtonMake(id,pom,il,dpom,ButYd,Veta)
      nButtBondVal=ButtonLastMade
      nCrwGroup=nCrwGroup+1
      Veta='xxxx'
      dpom=FeTxLength('xxxx')+3.
      do 1100i=1,4
        call FeQuestCrwMake(id,xpom,il,xpom+dpom,il,Veta,'L',CrwgXd,
     1                      CrwgYd,0,nCrwGroup)
        if(i.eq.1) nCrwParFirst=CrwLastMade
        xpom=xpom+dpom+CrwgXd+3.
1100  continue
      il=il+1
      dpom=40.
      xpom=xdqp-10.-dpom
      Veta='Ne%w item'
      call FeQuestButtonMake(id,xpom,il,dpom,ButYd,Veta)
      nButtNew=ButtonLastMade
      xpom=xdqp+10.
      Veta='%Delete item'
      call FeQuestButtonMake(id,xpom,il,dpom,ButYd,Veta)
      nButtDelete=ButtonLastMade
      ia=1
      iao=0
      if(DrawN.gt.0) go to 1220
      DrawN=1
1200  if(ia.eq.1) then
        call SetStringArrayTo(DrawAtom(1,ia),4,' ')
        DrawParam(ia)=21
      else
        DrawParam(ia)=NPar*10+1
        do 1210i=1,4
          DrawAtom(i,ia)=DrawAtom(i,ia-1)
1210    continue
      endif
      DrawColor(ia)=ColorOrder('White')
1220  NPar=DrawParam(ia)/10
      IPar=max(mod(DrawParam(ia),10),1)
      if(NPar.eq.IdDrawTorsion) then
        NAtoms=4
      else
        NAtoms=1
      endif
      icont=0
      if(WhatToDraw.eq.0.and.NPar.le.IdDrawTorsion) then
        write(Label,'(i2,''/'',i2)') ia,DrawN
        call zhusti(Label)
        Label=Label(:idel(Label))//' item to be drawn'
        if(WhatToDraw.ne.WhatToDrawOld) then
          if(ndimi.gt.1) then
            call FeQuestEdwClose(nEdwRefLevel)
            call FeQuestCrwClose(nCrwRefLevel)
          endif
          call FeQuestCrwClose(nCrwNonMod)
          call FeQuestUpDownOpen(nUpDownColor,UpDownOff)
          call FeQuestButtonOpen(nButtNew,ButtonOff)
          call FeQuestButtonOpen(nButtDelete,ButtonOff)
          call FeQuestStringEdwOpen(nEdwColor,'White')
          call GrtSetParLimits(nEdwPLim,NPar)
        endif
      else
        Label='Item to be drawn'
        if(WhatToDraw.ne.WhatToDrawOld) then
          call FeQuestUpDownClose(nUpDownColor)
          call FeQuestButtonClose(nButtNew)
          call FeQuestButtonClose(nButtDelete)
          call FeQuestEdwClose(nEdwColor)
          if((NPar.eq.IdDrawDist.or.NPar.eq.IdDrawVal).and.
     1        WhatToDraw.eq.0) then
            call FeQuestCrwOpen(nCrwNonMod,DrawNonMod)
          else
            call FeQuestCrwClose(nCrwNonMod)
          endif
          if(NPar.eq.IdDrawDist.or.NPar.eq.IdDrawAngles.or.
     1       WhatToDraw.eq.0) then
            if(ndimi.gt.1) then
              call FeQuestCrwClose(nCrwRefLevel)
              call FeQuestEdwClose(nEdwRefLevel)
            endif
            call GrtSetParLimits(nEdwPLim,NPar)
          else if(WhatToDraw.ne.0) then
            call FeQuestEdwClose(nEdwPLim)
            call FeQuestEdwClose(nEdwPLim+1)
            call FeQuestCrwOpen(nCrwRefLevel,UseRefLevel)
            if(UseReflevel)
     1        call FeQuestRealEdwOpen(nEdwRefLevel,RefLevel,.false.,
     2                                .false.)
          endif
        endif
      endif
      if(NPar.ne.NParOld) then
        if(ndimi.gt.1) then
          tpom=5.
          if(NPar.ge.IdDrawDist) then
            nCrw=nCrwTypeFirst
            if(NPar.ne.IdDrawVal) then
              call FeQuestLabelRemove(id,tpom,2,LabelTypeOfGraph,'L')
               do 1240i=0,1
                call FeQuestCrwClose(nCrw)
                nCrw=nCrw+1
1240          continue
            endif
          endif
          if(NPar.ne.IdDrawDist.and.NPar.ne.IdDrawAngles) then
            nCrw=nCrwTypeFirst
            call FeQuestLabelMake(id,tpom,2,LabelTypeOfGraph,'L')
            do 1250i=0,1
              call FeQuestCrwOpen(nCrw,WhatToDraw.eq.i)
              nCrw=nCrw+1
1250        continue
          endif
        endif
        if(NAtoms.ne.NAtomsOld) then
          if(NAtoms.lt.NAtomsOld) then
            nEdw=nEdwName+2*NAtoms
            nButt=nButtAtomList+NAtoms
            do 1245i=NAtoms+1,NAtomsOld
              call FeQuestButtonClose(nButt)
              nButt=nButt+1
              call FeQuestEdwClose(nEdw)
              nEdw=nEdw+1
              call FeQuestEdwClose(nEdw)
              nEdw=nEdw+1
1245        continue
          else if(NAtoms.gt.NAtomsOld) then
            nEdw=nEdwName+2*NAtomsOld
            nButt=nButtAtomList+NAtomsOld
            do 1252i=NAtomsOld+1,NAtoms
              call FeQuestButtonOpen(nButt,ButtonOff)
              nButt=nButt+1
              call FeQuestStringEdwOpen(nEdw,' ')
              nEdw=nEdw+1
              call FeQuestStringEdwOpen(nEdw,' ')
              nEdw=nEdw+1
1252        continue
          endif
          if(NAtoms.eq.1) then
            Veta='%Name'
          else
            Veta='%1st atom'
          endif
          call FeQuestEdwLabelChange(id,nEdwName,Veta)
        endif
        if(NAtoms.eq.1.and.NAtoms.ne.NAtomsOld)
     1    call FeQuestEdwLabelChange(id,nEdwName,'%Name')
        if(NPar.ge.IdDrawDist) then
          call FeQuestEdwClose(nEdwSymCode)
          call FeQuestButtonOff(nButtNeighbours)
        else
          call FeQuestButtonClose(nButtNeighbours)
          call FeQuestStringEdwOpen(nEdwSymCode,' ')
        endif
      endif
      WhatToDrawOld=WhatToDraw
      if(Label.ne.LabelOld) then
        if(LabelOld.ne.' ') call FeQuestLabelRemove(id,xdqp,1,LabelOld,
     1                                              'C')
        call FeQuestLabelMake(id,xdqp,1,Label,'C')
        LabelOld=Label
      endif
1300  if(WhatToDraw.eq.0.and.NPar.le.IdDrawTorsion) then
        if(ia.lt.DrawN) then
          call FeQuestUpDownOff(nUpDownNext)
        else
          call FeQuestUpDownDisable(nUpDownNext)
        endif
        if(ia.gt.1) then
          call FeQuestUpDownOff(nUpDownPrevious)
        else
          call FeQuestUpDownDisable(nUpDownPrevious)
        endif
      else
        call FeQuestUpDownClose(nUpDownNext)
        call FeQuestUpDownClose(nUpDownPrevious)
      endif
      if(ia.ne.iao) then
        nEdw=nEdwName
        do 1310i=1,NAtoms
          if(ia.gt.DrawN) then
            AtPom=' '
            SymPom=' '
          else
            j=index(DrawAtom(i,ia),'#')
            if(j.gt.0) then
              AtPom=DrawAtom(i,ia)(:j-1)
              SymPom=DrawAtom(i,ia)(j+1:)
            else
              AtPom=DrawAtom(i,ia)
              SymPom=' '
            endif
          endif
          call FeQuestStringEdwOpen(nEdw,AtPom)
          nEdw=nEdw+1
          if(NPar.le.IdDrawTorsion)
     1      call FeQuestStringEdwOpen(nEdw,SymPom)
          nEdw=nEdw+1
1310    continue
        if(ia.gt.DrawN) then
          icolor=ColorOrder('White')
        else
          icolor=DrawColor(ia)
        endif
        NPar=DrawParam(ia)/10
        if(NPar.eq.IdDrawTorsion) then
          NAtoms=4
        else
          NAtoms=1
        endif
        IPar=max(mod(DrawParam(ia),10),1)
        if(NPar.le.IdDrawTorsion) then
          call FeQuestStringEdwOpen(nEdwSymCode,SymPom)
          if(WhatToDraw.eq.0)
     1      call FeQuestStringEdwOpen(nEdwColor,ColorNames(icolor))
        endif
        call FeQuestStringEdwOpen(nEdwParType,MenuParType(NPar))
      endif
      if(NPar.eq.IdDrawXYZ) then
        ik=3
      else if(NPar.eq.IdDrawADP) then
        ik=4
      else
        ik=0
      endif
      if(NParOld.ge.IdDrawVal.and.NPar.ne.NParOld) then
        call FeQuestEdwClose(nEdwDMax)
        if(NParOld.eq.IdDrawVal) call FeQuestButtonClose(nButtBondVal)
      endif
      nCrw=nCrwParFirst
      do 1355i=1,4
        if(i.le.ik) then
          if(NPar.eq.IdDrawXYZ) then
            call FeQuestCrwLabelChange(id,nCrw,'   '//smbx(i))
          else if(NPar.eq.IdDrawADP) then
            call FeQuestCrwLabelChange(id,nCrw,smbu(i))
          endif
          call FeQuestCrwOpen(nCrw,i.eq.IPar)
        else
          call FeQuestCrwClose(nCrw)
        endif
        nCrw=nCrw+1
1355  continue
      if(NPar.ge.IdDrawVal.and.NPar.ne.NParOld) then
        call FeQuestRealEdwOpen(nEdwDMax,DrawDMax,.false.,.false.)
        if(NPar.eq.IdDrawVal) call FeQuestButtonOff(nButtBondVal)
      endif
      NParOld=NPar
      NAtomsOld=NAtoms
      if(ndimi.gt.1) then
        nCrw=nCrwOrientFirst-1
        do 1380i=1,ndimi
         do 1370j=1,ndimi
            nCrw=nCrw+1
            do 1360k=1,i-1
              if(ior(k).eq.j) then
                call FeQuestCrwClose(nCrw)
                go to 1370
              endif
1360        continue
            if(ior(1).gt.0) call FeQuestCrwOpen(nCrw,j.eq.ior(i))
1370      continue
1380    continue
      endif
      iao=ia
1500  call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.eq.EventButton.and.CheckNumberAbs.eq.ButtonOk) then
        nEdw=nEdwName
        do 1505i=1,NAtoms
          if(EdwStringQuest(nEdw).eq.' ') then
            if(NAtoms.eq.1) then
              Veta='no atom defined, try again'
            else
              write(Veta,'(''Atom #'',i1,'' not defined, try again'')')
     1              i
            endif
            call FeChybne(-1.,-1.,Veta,' ',0,SeriousError)
            go to 1514
          endif
          nEdw=nEdw+2
1505    continue
        if(NPar.ge.IdDrawDist) then
          do 1510i=1,nacalc
            if(BratDruhyATreti(i)) go to 1512
1510      continue
          call FeChybne(-1.,-1.,'no neighbour atom defined',' ',0,
     1                  SeriousError)
          go to 1514
        endif
1512    QuestCheck(id)=0
        go to 1500
1514    call FeButtonOff(ButtonOk)
        icont=0
        go to 1500
      else if(CheckType.eq.EventEdw.and.CheckNumber.ge.nEdwName.and.
     1        CheckNumber.le.nEdwSymCode+2*NAtoms-2)
     2  then
        nEdw=CheckNumber
        ip=(CheckNumber-nEdwName)/2+1
        call GrtUpdateDrawAtom(ia)
        if(DrawAtom(ip,ia).ne.' '.and.
     1     (EventType.ne.EventButton.or.EventNumber.lt.nButtAtomList.or.
     2      EventNumber.gt.nButtAtomList+NAtoms-1))
     3   call atsymi(DrawAtom(ip,ia),i,xsym,x4dif,tdif,isym,k,*1520)
        go to 1500
1520    EventType=EventEdw
        EventNumber=nEdw
        go to 1500
      else if(CheckType.eq.EventButton.and.CheckNumber.ge.nButtAtomList
     1        .and.CheckNumber.le.nButtAtomList+NAtoms-1) then

        ip=CheckNumber-nButtAtomList+1
        nEdw=nEdwName+2*ip-2
        if(DrawAtom(ip,ia).eq.' ') then
          i=1
        else
          i=ktat(atom,nacalc,DrawAtom(ip,ia))
        endif
        call SelOneAtomFromPhase('Select atom from the list',Atom,kswa,
     1                           i,nacalc,ich)
        call FeQuestButtonOff(nButtAtomList+ip-1)
        if(ich.eq.0) then
          call FeQuestStringEdwOpen(nEdwName+2*ip-2,Atom(i))
          call GrtUpdateDrawAtom(ia)
        endif
        EventType=EventEdw
        EventNumber=nEdw
        go to 1500
      else if(CheckType.eq.EventButton.and.CheckNumber.eq.nButtNew) then
        call GrtUpdateDrawAtom(ia)
        DrawN=DrawN+1
        ia=DrawN
        call FeQuestButtonoff(nButtNew)
        go to 1200
      else if(CheckType.eq.EventButton.and.CheckNumber.eq.nButtDelete)
     1  then
        do 1530i=ia,DrawN-1
          DrawAtom(1,i)=DrawAtom(1,i+1)
          DrawParam(i)=DrawParam(i+1)
          DrawColor(i)=DrawColor(i+1)
1530    continue
        DrawN=max(0,DrawN-1)
        ia=min(ia,DrawN)
        ia=max(ia,1)
        call FeQuestButtonoff(nButtDelete)
        iao=0
        go to 1220
      else if(CheckType.eq.EventButton.and.
     1        CheckNumber.eq.nButtNeighbours) then
        call SelAtomsFromPhase('Select atoms for distance calculation',
     1                         Atom,BratDruhyATreti,kswa,isf,nacalc,
     2                         .false.,ich)
        call FeQuestButtonoff(nButtNeighbours)
        icont=0
        go to 1500
      else if(CheckType.eq.EventButton.and.
     1        CheckNumber.eq.nButtBondVal) then
        call GrtChangeBondValCoeff
        call FeQuestButtonOff(nButtBondVal)
        icont=0
        go to 1500
      else if(CheckType.eq.EventUpDown.and.CheckNumber.eq.nUpDownColor)
     1  then
        j=nEdwColor+EdwFr-1
        i=FeMenu(EdwXmin(j)+2.5,EdwYMin(j),ColorNames,1,PocetBarev,
     1           icolor,1)
        call FeQuestUpDownOff(nUpDownColor)
        if(i.le.0) i=ColorOrder('White')
        EventType=EventEdw
        EventNumber=nEdwColor
        if(icolor.ne.i) then
          DrawColor(ia)=i
          iao=0
          go to 1300
        else
          go to 1500
        endif
      else if(CheckType.eq.EventUpDown.and.
     1        CheckNumber.eq.nUpDownParType) then
        j=nEdwParType+EdwFr-1
        NPar=FeMenu(EdwXmin(j)+2.5,EdwYMin(j),MenuParType,1,
     1              PocetParType,NPar,1)
        call FeQuestUpDownOff(nUpDownParType)
        if(NPar.le.0) NPar=IdDrawXYZ
        EventType=EventEdw
        EventNumber=nEdwParType
        if(NPar.ne.NParOld) then
          DrawParam(ia)=NPar*10+1
          iao=0
          if(NPar.eq.IdDrawDist.or.NPar.eq.IdDrawAngles) WhatToDraw=0
          WhatToDrawOld=-1
          go to 1220
        else
          go to 1500
        endif
      else if(CheckType.eq.EventUpDown.and.CheckNumber.eq.nUpDownNext)
     1  then
        call GrtUpdateDrawAtom(ia)
        ia=min(ia+1,DrawN)
        call FeQuestUpDownOff(nUpDownNext)
        go to 1220
      else if(CheckType.eq.EventUpDown.and.
     1        CheckNumber.eq.nUpDownPrevious) then
        call GrtUpdateDrawAtom(ia)
        ia=max(ia-1,1)
        call FeQuestUpDownOff(nUpDownPrevious)
        go to 1220
      else if(CheckType.eq.EventCrw.and.
     1        CheckNumber.ge.nCrwTypeFirst.and.
     2        CheckNumber.le.nCrwTypeLast) then
        WhatToDraw=CheckNumber-nCrwTypeFirst
        if(WhatToDraw.eq.0) then
          ia=1
        else
          UseRefLevel=.false.
        endif
        go to 1220
      else if(CheckType.eq.EventCrw.and.
     1        CheckNumber.ge.nCrwOrientFirst.and.
     2        CheckNumber.le.nCrwOrientLast) then
        j=CheckNumber-nCrwOrientFirst
        i=j/ndim+1
        j=mod(j,ndim)+1
        ipp=ior(i)
        ior(i)=j
        do 1540k=i+1,ndim
          if(ior(k).eq.j) then
            ior(k)=ipp
            go to 1220
          endif
1540    continue
      else if(CheckType.eq.EventCrw.and.CheckNumber.eq.nCrwRefLevel)
     1  then
        if(CrwLogicQuest(nCrwRefLevel)) then
          if(EdwStateQuest(nEdwRefLevel).ne.EdwOpened) then
            RefLevel=GrtSetRefLevel(ia,isw,NPar,IPar)
            call FeQuestRealEdwOpen(nEdwRefLevel,RefLevel,.false.,
     1                              .false.)
            UseRefLevel=.true.
            EventType=EventEdw
            EventNumber=nEdwRefLevel
          endif
        else
          call FeQuestEdwClose(nEdwRefLevel)
          UseRefLevel=.false.
          icont=0
        endif
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        nEdw=nEdwTLim
        if(WhatToDraw.eq.0) then
          ik=ndimi+1
          RefLevel=0.
          UseRefLevel=.false.
        else
          ik=ndimi
          if(UseRefLevel) call FeQuestRealFromEdw(nEdwRefLevel,RefLevel)
        endif
        if(NPar.ge.IdDrawVal) call FeQuestRealFromEdw(nEdwDMax,DrawDMax)
        do 1610i=1,ik
          if(i.le.ndimi) then
            k=3
          else
            k=2
          endif
          do 1600j=1,k
            call FeQuestRealFromEdw(nEdw,pom)
            if(i.le.ndimi) then
              gx(j,i)=pom
            else
              gy(j)=pom
            endif
            nEdw=nEdw+1
1600      continue
1610    continue
        DrawN=max(ia,DrawN)
        if(NPar.eq.IdDrawXYZ.or.NPar.eq.IdDrawADP) then
          if(NPar.eq.IdDrawXYZ) then
            ik=3
          else
            ik=4
          endif
          nCrw=nCrwParFirst
          do 1650i=1,ik
            if(CrwLogicQuest(nCrw)) go to 1660
            nCrw=nCrw+1
1650      continue
          i=1
        else
          i=0
        endif
1660    DrawColor(ia)=icolor
        if(CrwStateQuest(nCrwNonMod).ne.CrwClosed)
     1    DrawNonMod=CrwLogicQuest(nCrwNonMod)
      endif
      call FeQuestRemove(id)
      if(ich.ne.0) then
        call GrtRestoreDrawAtom
        go to 9999
      endif
      call SetRealArrayTo(DxMod,3,0.)
      call SetIntArrayTo(NxMod,3,1)
      call SetIntArrayTo(NxMap,2,1)
      NxMapMx=1
      if(WhatToDraw.eq.0) then
        i1=ior(1)
        DrawPoints=nint((gx(2,i1)-gx(1,i1))/gx(3,i1))+1
        DxMod(i1)=gx(3,i1)
        do 2000i=2,ndimi
          j=ior(i)
          n=nint((gx(2,j)-gx(1,j))/gx(3,j))+1
          NxMapMx=NxMapMx*n
          NxMap(i-1)=n
2000    continue
        NxMod(i1)=DrawPoints
        xomn=gx(1,i1)
        xomx=gx(2,i1)
        yomn=gy(1)
        yomx=gy(2)
      else
        DrawPoints=1
        do 2200i=1,ndimi
          n=nint((gx(2,i)-gx(1,i))/gx(3,i))+1
          DrawPoints=DrawPoints*n
          NxMod(i)=n
          DxMod(i)=gx(3,i)
2200    continue
      endif
      NMapGrt=1
9999  return
      end
      subroutine GrtDrawCurves(Klic)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      dimension tp(3),xp(3),xo(3),Gamma(9)
      character*4 YLabel,LabelP
      character*80 t80
      if(Klic.ne.0) go to 2000
      call UnitMat(F2O,3)
      call FeSetTransXo2X(xomn,xomx,yomn,yomx,.false.)
      call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 9999
      call FeClearGrWin
      call FeOutSt(0,XCenGrWin,(YMaxGrWin+YMaxAcWin)*.5,GraphtLabel,
     1             'C',White)
      call FeMakeAcFrame
      call FeMakeAxisLabels(1,xomn,xomx,yomn,yomx,smbt(ior(1)))
2000  do 3000i=1,DrawN
        do 2010j=1,DrawPoints
          if(DrawOcc(j,i).gt.0.) go to 2020
2010    continue
        go to 3000
2020    NPar=DrawParam(i)/10
        IPar=max(mod(DrawParam(i),10),1)
        jc=DrawColor(i)
        if(NPar.eq.IdDrawOcc) then
          LabelP='occ'
        else if(NPar.eq.IdDrawXYZ) then
          LabelP=smbx(IPar)
        else if(NPar.eq.IdDrawADP) then
          LabelP=SmbU(IPar)
        else if(NPar.eq.IdDrawTorsion) then
          LabelP='Tors'
        else if(NPar.eq.IdDrawDist) then
          LabelP='Dist'
        else if(NPar.eq.IdDrawVal) then
          LabelP='Val'
        else if(NPar.eq.IdDrawAngles) then
          LabelP='Ang'
        endif
        if(HardCopy.eq.6) then
          if(NPar.le.IdDrawTorsion) then
            t80='# '//LabelP(:idel(LabelP))//'-'//
     1          smbt(ior(1))//' plot for '//
     2          DrawAtom(1,i)(:idel(DrawAtom(1,i)))
            write(85,FormA1)(t80(j:j),j=1,idel(t80))
          else if(NPar.eq.IdDrawDist.or.NPar.eq.IdDrawAngles) then
            if(Klic.eq.0.and.i.eq.1) then
              if(NPar.eq.IdDrawDist) then
                t80='distance'
              else
                t80='angle'
              endif
              t80='# '//t80(:idel(t80))//'-t plot for '//
     1             DrawAtom(1,1)(:idel(DrawAtom(1,1)))
              write(85,FormA1)(t80(j:j),j=1,idel(t80))
            endif
            t80='# to '//DrawSymSt(i)(:idel(DrawSymSt(i)))
            if(NPar.eq.IdDrawAngles) t80=t80(:idel(t80))//' and '//
     1                               DrawSymStU(i)(:idel(DrawSymStU(i)))
            write(85,FormA1)(t80(j:j),j=1,idel(t80))
            if(jc.gt.0) then
              write(85,'(''# curve includes modulation'')')
            else
              write(85,'(''# curve doesn''''t include modulation'')')
            endif
          endif
        endif
        call GrtGrawPerPartes(DrawT,DrawValue(1,i),DrawOcc(1,i),
     1                        DrawPoints,jc.gt.0,
     2                        ColorNumbers(iabs(jc)))
        if(HardCopy.eq.6) write(85,'(''# end of curve'')')
        if(i.eq.1) then
          YLabel=LabelP
        else if(YLabel.ne.LabelP) then
          if(NPar.eq.IdDrawXYZ) then
            YLabel='xyz'
          else if(NPar.eq.IdDrawADP) then
            YLabel='U'
          endif
        endif
3000  continue
      if(DrawTCommen) then
        n=ncommen(1,1,KPhase)*ncommen(2,1,KPhase)*ncommen(3,1,KPhase)
        fn=1./float(n)
        xp(3)=0.
        call FeLineType(1)
        do 4000k=0,ngc
          if(k.eq.0) then
            call CopyVek(trez(1,1,KPhase),tp,ndimi)
          else
            do 3040j=4,ndim
              call CopyVek(rm6gc(4+(j-1)*ndim,k,1,KPhase),
     1                     Gamma(1+(j-4)*ndimi),ndimi)
3040        continue
            call Multm(Gamma,trez(1,1,KPhase),tp,ndimi,ndimi,1)
            call AddVek(tp,sgc(4,k,1,KPhase),tp,ndimi)
            tp(1)=tp(1)-scalmul(sgc(1,k,1,KPhase),qu(1,1,1,KPhase))
          endif
          pom=tp(1)
          do 3500i=1,n
            xp(1)=pom
3100        if(xp(1).gt.xomn) then
              xp(1)=xp(1)-1.
              go to 3100
            endif
3200        if(xp(1).lt.xomx) then
              if(xp(1).ge.xomn) then
                xp(2)=yomn
                call multm(F2O,xp,xo,3,3,1)
                xu(1)=FeXo2X(xo(1))
                yu(1)=FeYo2Y(xo(2))
                xp(2)=yomx
                call multm(F2O,xp,xo,3,3,1)
                xu(2)=FeXo2X(xo(1))
                yu(2)=FeYo2Y(xo(2))
                call FePolyLine(2,xu,yu,White)
              endif
              xp(1)=xp(1)+1.
              go to 3200
            endif
            pom=pom+fn
3500      continue
4000    continue
        call FeLineType(0)
      endif
      if(Klic.eq.0) call FeMakeAxisLabels(2,yomn,yomx,xomn,xomx,YLabel)
9999  return
      end
      subroutine GrtDrawCurveOrMap(Klic)
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      include 'grapht.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      dimension xsym(3),x4dif(3),tdif(3),nd(3),uxi(3,mxw),
     1          uyi(3,mxw),bxi(6,mxw),byi(6,mxw),xpp(3),xp(6),rmb(36),
     2          GammaIntInv(9),bi(6),tfirstg(3)
      character*80 t80,u80
      character*8 at1,at2
      character*2 Label
      integer ColorOrder,RecModToRecMap
      if(ndimi.gt.1.and.WhatToDraw.eq.0) then
        if(Klic.gt.0) then
          NMapGrt=min(NMapGrt+1,NxMapMx)
        else if(Klic.lt.0) then
          NMapGrt=max(NMapGrt-1,1)
        endif
        call RecUnpack(NMapGrt,nd,NxMap,ndimi-1)
        tfirstg(ior(1))=xomn
        do 1000i=2,ndimi
          j=ior(i)
          tfirstg(j)=gx(1,j)+(nd(i-1)-1)*gx(3,j)
1000    continue
      else
        do 1100i=1,ndimi
          tfirstg(i)=gx(1,i)
1100    continue
      endif
      NPar=DrawParam(1)/10
      if(WhatToDraw.eq.0) then
        if(ndimi.gt.1) then
          write(GraphtLabel,'(a1,''='',f10.3,'','')')
     1      (smbt(ior(j)),tfirstg(ior(j)),j=2,ndimi)
          call Zhusti(GraphtLabel)
          j=idel(GraphtLabel)
          GraphtLabel(j:j)=' '
        else
          GraphtLabel=' '
        endif
      else
        do 1200i=1,ndimi
          NxMap(i)=NxMod(ior(i))
1200    continue
      endif
      if(NPar.le.IdDrawTorsion) then
        if(NPar.eq.IdDrawTorsion) then
          NAtoms=4
        else
          NAtoms=1
        endif
        do 2500i=1,DrawN
          IPar=max(mod(DrawParam(i),10),1)
          do 1300j=1,NAtoms
            call atsymi(DrawAtom(j,i),ia,xsym,x4dif,tdif,isym,k,*2500)
            if(j.eq.1) then
              isw=iswa(ia)
              iais=iabs(isym)
            else
              if(isw.ne.iswa(ia)) then


              endif
            endif
1300      continue
          if(NPar.ne.IdDrawTorsion) then
            call GetGammaIntInv(isym,isw,KPhase,GammaIntInv)
            if(NPar.eq.IdDrawXYZ) then
              do 1750l=1,kmodx(ia)
                call multm(rm(1,iais,isw,KPhase),ux(1,l,ia),uxi(1,l),3,
     1                     3,1)
                if(l.ne.kmodx(ia).or.kfx(ia).eq.0) then
                   call multm(rm(1,iais,isw,KPhase),uy(1,l,ia),uyi(1,l),
     1                        3,3,1)
                else
                   call CopyVek(uy(1,l,ia),uyi(1,l),3)
                endif
                if(isym.lt.0) then
                  do 1700j=1,3
                    uxi(j,l)=-uxi(j,l)
                    if(l.ne.kmodx(ia).or.kfx(ia).eq.0)
     1                uyi(j,l)=-uyi(j,l)
1700              continue
                endif
1750          continue
            else if(NPar.eq.IdDrawADP) then
              call srotb(rm(1,iais,isw,KPhase),rm(1,iais,isw,KPhase),
     1                   rmb)
              call multm(rmb,beta(1,ia),bi,6,6,1)
              do 1800j=1,kmodx(ia)
                call multm(rmb,bx(1,j,ia),bxi(1,j),6,6,1)
                call multm(rmb,by(1,j,ia),byi(1,j),6,6,1)
1800          continue
            endif
            call AddVek(tdif,tfirstg,xpp,ndimi)
            call multm(GammaIntInv,xpp,xp,ndimi,ndimi,1)
            call MakeOccMod(DrawOcc(1,i),qcnt(1,ia),xp,NxMod,DxMod,
     1                      a0(ia),ax(1,ia),ay(1,ia),kmods(ia),kfs(ia),
     2                      GammaIntInv)
            if(kfx(ia).gt.0.and.kmodx(ia).gt.0)
     1        call MakeOccModSawTooth(DrawOcc(1,i),qcnt(1,ia),xp,NxMod,
     2          DxMod,uyi(1,kmodx(ia)),uyi(2,kmodx(ia)),kfx(ia),
     3          GammaIntInv)
            if(NPar.eq.IdDrawXYZ) then
              call MakePosMod(XMod,qcnt(1,ia),xp,NxMod,DxMod,uxi,uyi,
     1                        kmodx(ia),kfx(ia),GammaIntInv)
              NRank=3
            else if(NPar.eq.IdDrawADP) then
              call MakeBetaMod(XMod,qcnt(1,ia),xp,NxMod,DxMod,bxi,byi,
     1                        kmodb(ia),kfb(ia),GammaIntInv)
              NRank=6
            endif
          else
            call GrtSetDistKeys(NPar,tfirstg)
            call DistTorsionAngle(DrawAtom(1,i),' ')
            rewind 78
            if(WhatToDraw.eq.0) t=xomn
1900        read(78,end=2000) k,pom,Occ
            if(WhatToDraw.eq.0) then
              DrawT(k)=t
              kk=k
              t=t+DxMod(ior(1))
            else
              kk=RecModToRecMap(k,NxMod,ior,ndimi)
            endif
            DrawValue(kk,i)=pom
            DrawOcc(kk,i)=Occ
            go to 1900
2000        IPar=1
            NRank=1
            close(78,status='delete')
            go to 2500
          endif
          if(WhatToDraw.eq.0) t=xomn
          if(IPar.le.3) then
            j=IPar
          else
            j=1
          endif
          do 2300k=1,DrawPoints
            if(WhatToDraw.eq.0) then
              DrawT(k)=t
              kk=k
            else
              kk=RecModToRecMap(k,NxMod,ior,ndimi)
            endif
            if(NPar.eq.IdDrawOcc) then
              DrawValue(kk,i)=DrawOcc(k,i)
              if(WhatToDraw.eq.0) DrawOcc(k,i)=1.
            else if(NPar.eq.IdDrawXYZ) then
              DrawValue(kk,i)=(XMod(j)+x(IPar,ia)-xdst(IPar,ia))*
     1                         CellPar(IPar,isw,KPhase)
            else if(NPar.eq.IdDrawADP) then
              if(IPar.le.3) then
                DrawValue(kk,i)=(XMod(j)+bi(IPar))/urcp(IPar,isw,KPhase)
              else
                call AddVek(XMod(j),bi,XMod(j),6)
                call boueq(XMod(j),sbeta(1,ia),0,DrawValue(kk,i),pom,
     1                     isw)
              endif
            else

            endif
            if(UseRefLevel) DrawValue(kk,i)=DrawValue(kk,i)-RefLevel
            if(WhatToDraw.eq.0) t=t+DxMod(ior(1))
            j=j+NRank
2300      continue
2500    continue
      else if(NPar.le.IdDrawAngles) then
        do 3000i=1,10
          DrawColor(i)=ColorOrder('White')
          if(DrawNonMod.and.mod(i,2).eq.0) DrawColor(i)=-DrawColor(i)
3000    continue
        ia=ktat(atom,nacalc,DrawAtom(1,1))
        IPar=max(mod(DrawParam(1),10),1)
        if(.not.UseRefLevel) RefLevel=GrtSetRefLevel(1,1,NPar,IPar)
        do 3005i=1,nacalc
          BratPrvni(i)=.false.
3005    continue
        BratPrvni(ia)=.true.
        call GrtSetDistKeys(NPar,tfirstg)
        call DistAt
        rewind 78
        DrawN=0
        iprv=0
        NPar10=NPar*10
3300    read(78,end=5000) Label,At1,isfi,(pom,i=1,7),t80
        if(Label.ne.'#1'.or.At1.ne.DrawAtom(1,1)) go to 3300
3310    read(78,end=5000) Label,At2,isfj,aij,(pom,i=1,6),t80
3315    if(Label.eq.'#2'.or.Label.eq.'#3')
     1    t80=At2(:idel(At2))//'#'//t80(:idel(t80))
        if(Label.eq.'#2') then
          if(NPar.eq.IdDrawAngles) then
           u80=t80
           go to 3310
          else
            PomCoeff=BondValCoeff(isfi,isfj,KPhase)
            go to 3320
          endif
        else if(Label.eq.'#3') then
          if(NPar.eq.IdDrawAngles) then
            go to 3320
          else
            go to 3310
          endif
        else
          go to 3310
        endif
3320    if(NPar.ne.IdDrawVal.or.DrawN.eq.0) then
          DrawN=DrawN+1
          call SetRealArrayTo(DrawOcc(1,DrawN),DrawPoints,0.)
          call SetRealArrayTo(DrawValue(1,DrawN),DrawPoints,-RefLevel)
          if(DrawNonMod) then
            call SetRealArrayTo(DrawOcc(1,DrawN+1),DrawPoints,0.)
            call SetRealArrayTo(DrawValue(1,DrawN+1),DrawPoints,
     1                          -RefLevel)
          endif
        endif
        if(Label.eq.'#2') then
          DrawSymSt(DrawN)=t80
          DrawParam(DrawN)=NPar10
          if(DrawNonMod) then
            DrawSymSt(DrawN+1)=t80
            DrawParam(DrawN+1)=NPar10
          endif
        else if(Label.eq.'#3') then
          DrawSymSt(DrawN)=u80
          DrawSymStU(DrawN)=t80
          DrawParam(DrawN)=NPar10
          if(DrawNonMod) then
            DrawSymSt(DrawN+1)=u80
            DrawSymStU(DrawN+1)=t80
            DrawParam(DrawN+1)=NPar10
          endif
        endif
3325    read(78,end=5000) Label,At2,k,pomn,pom,spom,occi,occj,pp,pp,t80
        if(Label.ne.' ') then
          isfj=k
          aij=pomn
          if(DrawNonMod.and.
     1       (NPar.eq.IdDrawDist.or.NPar.eq.IdDrawAngles)) DrawN=DrawN+1
          if(DrawN.ge.10) then
            call GrtDrawCurves(iprv)
            iprv=1
            DrawN=0
          endif
          go to 3315
        endif
        call RecUnpack(k,nd,nt(1,1),ndimi)
        if(WhatToDraw.eq.0) then
          kk=k
        else
          kk=RecModToRecMap(k,NxMod,ior,ndimi)
        endif
        if(WhatToDraw.eq.0) then
          DrawT(kk)=tfirst(ior(1),1)+(nd(ior(1))-1)*dt(ior(1),1)
          DrawOcc(kk,DrawN)=1.
          if(DrawNonMod) DrawOcc(kk,DrawN+1)=1.
        endif
        if(NPar.eq.IdDrawDist.or.NPar.eq.IdDrawAngles) then
          if((occi.le..0001.or.occj.le..0001).and.NPar.eq.IdDrawDist)
     1      then
            DrawOcc(kk,DrawN)=0.
            go to 3325
          endif
          DrawValue(kk,DrawN)=pom
          if(DrawNonMod) DrawValue(kk,DrawN+1)=pomn
        else
          if(occi.le..0001.or.occj.le..0001.or.PomCoeff.le.0.or.
     1       pom.gt.DrawDMax) go to 3325
          DrawValue(kk,DrawN)=DrawValue(kk,DrawN)+
     1                        exp((PomCoeff-pom)/.37)*aij*occj
          if(DrawNonMod)
     1      DrawValue(kk,DrawN+1)=DrawValue(kk,DrawN+1)+
     2                            exp((PomCoeff-pomn)/.37)*aij*occj
        endif
        go to 3325
5000    if(NPar.ne.IdDrawVal) then
          if(DrawN.gt.0) then
             call GrtDrawCurves(iprv)
          endif
        else
          if(DrawNonMod) DrawN=DrawN+1
        endif
        if(NPar.eq.IdDrawDist.or.NPar.eq.IdDrawAngles) DrawN=1
        close(78,status='delete')
      endif
      if(NPar.ne.IdDrawDist.and.NPar.ne.IdDrawAngles) then
        if(WhatToDraw.eq.0) then
          call GrtDrawCurves(0)
        else
          call GrtDrawMap(1)
        endif
      endif
      if(WhatToDraw.eq.0) then
        if(HardCopy.eq.6) write(85,'(''# end of file'')')
        call FeHardCopy(HardCopy,'close',ich)
      endif
      return
133   format(a2,1x,a8,i6,3f10.4,1x,a80)
      end
      subroutine GrtUpdateDrawAtom(ia)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      character*256 EdwStringQuest
      character*80  SymPom
      character*12  ColorName
      character*8   AtPom
      logical CrwLogicQuest
      NPar=DrawParam(ia)/10
      if(NPar.eq.IdDrawTorsion) then
        NAtoms=4
      else
        NAtoms=1
      endif
      nEdw=nEdwName
      do 1000i=1,NAtoms
        AtPom=EdwStringQuest(nEdw)
        nEdw=nEdw+1
        SymPom=EdwStringQuest(nEdw)
        nEdw=nEdw+1
        if(AtPom.ne.' ') then
          call UprAt(AtPom)
          if(SymPom.ne.' ') then
            DrawAtom(i,ia)=AtPom(:idel(AtPom))//'#'//
     1                     SymPom(:idel(SymPom))
          else
            DrawAtom(i,ia)=AtPom
          endif
        else
          DrawAtom(i,ia)=' '
        endif
1000  continue
      if(NPar.ge.2.and.NPar.le.3) then
        if(NPar.eq.2) then
          ik=3
        else
          ik=4
        endif
        nCrw=nCrwParFirst
        do 1500i=1,ik
          if(CrwLogicQuest(nCrw)) go to 2000
          nCrw=nCrw+1
1500    continue
        i=1
      else
        i=0
      endif
2000  DrawParam(ia)=10*NPar+i
      if(WhatToDraw.eq.0) then
        ColorName=EdwStringQuest(nEdwColor)
        do 3000i=1,PocetBarev
          if(ColorNames(i).eq.ColorName) go to 3100
3000    continue
        i=1
3100    DrawColor(ia)=i
      endif
      return
      end
      subroutine GrtSaveDrawAtom
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      dimension iorSave(3)
      character*80 DrawAtomSave(4,10)
      integer DrawColorSave(10),DrawParamSave(10)
      save DrawNSave,DrawAtomSave,DrawColorSave,DrawParamSave,iorSave
      DrawNSave=DrawN
      do 1100i=1,DrawN
        do 1000j=1,4
          DrawAtomSave(j,i)=DrawAtom(j,i)
1000    continue
        DrawParamSave(i)=DrawParam(i)
        DrawColorSave(i)=DrawColor(i)
1100  continue
      do 1200i=1,ndimi
        iorSave(i)=ior(i)
1200  continue
      go to 9999
      entry GrtRestoreDrawAtom
      DrawN=DrawNSave
      do 2100i=1,DrawN
        do 2000j=1,4
          DrawAtom(j,i)=DrawAtomSave(j,i)
2000    continue
        DrawParam(i)=DrawParamSave(i)
        DrawColor(i)=DrawColorSave(i)
2100  continue
      do 2200i=1,ndimi
        ior(i)=iorSave(i)
2200  continue
9999  return
      end
      subroutine GrtDrawMap(Klic)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      include 'contour.cmn'
      if(Klic.eq.0) go to 2000
      VolaToContour=.false.
      ContourRefLevel=RefLevel
      DensityType=2
      do 1000i=1,ndimi
        cx(i)=smbt(ior(i))
        iorien(i)=ior(i)
1000  continue
      if(ndimi.eq.2) then
        iorien(3)=6-iorien(1)-iorien(2)
        zmap(1)=0.
      else
        zmap(1)=0.
c   to bude jinak for 6d !!!
      endif
      do 1050i=4,ndim
        iorien(i)=i
        zmap(i-2)=0.
1050  continue
      call GrtSetTr
      DMin= 999.
      DMax=-999.
      do 1200i=1,DrawPoints
        pom=DrawValue(i,1)
        DMin=min(pom,DMin)
        DMax=max(pom,DMax)
        table(i)=pom
1200  continue
      nx(1)=NxMod(1)
      nx(2)=NxMod(2)
      nxny=DrawPoints
      call SetContours(0)
      Obecny=.false.
      call UnitMat(tm3,3)
      do 1310i=1,ndimi
        do 1300j=1,ndimi
          if(j.eq.ior(i)) then
            tm3(i,j)=1.
          else
            tm3(i,j)=0.
          endif
1300    continue
1310  continue
      call MatInv(tm3,tm3i,pom,3)
2000  call FeHardCopy(HardCopy,'open',ich)
      if(ich.ne.0) go to 9999
      call FeClearGrWin
      call FeMakeAcFrame
      call FeMakeAxisLabels(1,xmin(1),xmax(1),xmin(2),xmax(2),cx(1))
      call FeMakeAxisLabels(2,xmin(2),xmax(2),xmin(1),xmax(1),cx(2))
      call vrstvy(-1)
      if(ErrJana.ne.0) go to 9999
      call vrstvy( 1)
9999  return
      end
      subroutine GrtGoTo(ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      dimension nd(2)
      character*5 t5
      il=ndimi-1
      call RecUnpack(NMapGrt,nd,NxMap,il)
      id=NextQuestId()
      call FeQuestCreate(id,-1.,-1.,60.,0,il,'Next graph to be drawn',0,
     1                   LightGray,0,0)
      il=0
      do 1100i=2,ndimi
        il=il+1
        j=ior(i)
        t5='%'//smbt(j)//' ='
        call FeQuestEudMake(id,5.,il,20.,il,t5,'L',30.,EdwYd,0)
        pom=gx(1,j)+(nd(i-1)-1)*gx(3,j)
        if(i.eq.2) nEdwFirst=EdwLastMade
        call FeQuestRealEdwOpen(EdwLastMade,pom,.false.,.false.)
        call FeQuestEudOpen(EdwLastMade,1,1,1,gx(1,j),gx(2,j),gx(3,j))
1100  continue
      icont=0
1500  call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        nEdw=nEdwFirst
        NMapGrt=0
        do 1600i=2,ndimi
          j=ior(i)
          call FeQuestRealFromEdw(nEdw,pom)
          if(gx(3,j).ne.0.) then
            n=nint((pom-gx(1,j))/gx(3,j))+1
          else
            n=1
          endif
          NMapGrt=NMapGrt+n
          nEdw=nEdw+1
1600    continue
      endif
      call FeQuestRemove(id)
      return
      end
      subroutine GrtSetParLimits(nEdwPLim,NPar)
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'grapht.cmn'
      data NParSave/-1/
      nEdw=nEdwPLim
      j=nEdw+EdwFr-1
      if(NPar.eq.NParSave) then
        pom=EdwReal(1,j)
      else if(NPar.eq.IdDrawOcc) then
        pom=0.
      else if(NPar.eq.IdDrawXYZ) then
        pom=-.5
      else if(NPar.eq.IdDrawADP) then
        pom=0.
      else if(NPar.eq.IdDrawTorsion) then
        pom=-180.
      else if(NPar.eq.IdDrawDist) then
        pom=2.
      else if(NPar.eq.IdDrawVal) then
        pom=1.
      else if(NPar.eq.IdDrawAngles) then
        pom=90.
      endif
      call FeQuestRealEdwOpen(nEdw,pom,.false.,.false.)
      nEdw=nEdw+1
      j=j+1
      if(NPar.eq.NParSave) then
        pom=EdwReal(1,j)
      else if(NPar.eq.IdDrawOcc) then
        pom=1.
      else if(NPar.eq.IdDrawXYZ) then
        pom=.5
      else if(NPar.eq.IdDrawADP) then
        pom=.1
      else if(NPar.eq.IdDrawTorsion) then
        pom=180.
      else if(NPar.eq.IdDrawDist) then
        pom=4.
      else if(NPar.eq.IdDrawVal) then
        pom=3.
      else if(NPar.eq.IdDrawAngles) then
        pom=180.
      endif
      call FeQuestRealEdwOpen(nEdw,pom,.false.,.false.)
      NParSave=NPar
      return
      end
      function GrtSetRefLevel(ia,isw,NPar,IPar)
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'grapht.cmn'
      if(NPar.eq.IdDrawOcc) then
        GrtSetRefLevel=0.
      else if(NPar.eq.IdDrawXYZ) then
        GrtSetRefLevel=0.
      else if(NPar.eq.IdDrawADP) then
        if(IPar.le.3) then
          GrtSetRefLevel=beta(IPar,ia)/urcp(IPar,isw,KPhase)
        else
          call boueq(beta(1,ia),sbeta(1,ia),0,pom,spom,isw)
          GrtSetRefLevel=spom
        endif
      else if(NPar.eq.IdDrawDist) then
        GrtSetRefLevel=0.
      else if(NPar.eq.IdDrawVal) then
        if(WhatToDraw.eq.0) then
          GrtSetRefLevel=0.
        else
          GrtSetRefLevel=2.
        endif
      else if(NPar.eq.IdDrawTorsion) then
        GrtSetRefLevel=0.
      else if(NPar.eq.IdDrawAngles) then
        GrtSetRefLevel=0.
      endif
      return
      end
      subroutine GrtSetBondValCoeff
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      character*2 At1,At2,Atp1,Atp2
      logical ExistFile
      call SetRealArrayTo(BondValCoeff(1,1,KPhase),225,0.)
      ln=NextLogicNumber()
      if(OpSystem.le.0) then
        LinuxString=JanaDir(:idel(JanaDir))//'bondval'//ObrLom//
     1              'brese.dat'
      else
        LinuxString=JanaDir(:idel(JanaDir))//'source/data/brese.dat'
      endif
      if(ExistFile(LinuxString)) then
        call OpenFile(ln,LinuxString,'formatted','old')
        if(ErrJana.eq.0) then
          do 2000i=1,nf
            Atp1=AtType(i,KPhase)
            do 1500j=1,nf
              Atp2=AtType(j,KPhase)
              rewind ln
1000          read(ln,'(2(a2,i4,1x),f6.3)',end=1500) At1,i1,At2,i2,pom
              call UprAt(At1)
              call UprAt(At2)
              if(At1.ne.Atp1.and.At1.ne.Atp2) go to 1000
              if(At2.ne.Atp1.and.At2.ne.Atp2) go to 1000
              BondValCoeff(i,j,KPhase)=pom
1500        continue
2000      continue
        endif
        call CloseIfOpened(ln)
      endif
      return
      end
      subroutine GrtChangeBondValCoeff
      include 'params.cmn'
      include 'basic.cmn'
      include 'atoms.cmn'
      include 'fepc.cmn'
      include 'grapht.cmn'
      dimension BondValCoeffO(15,15)
      id=NextQuestId()
      call CopyVek(BondValCoeff(1,1,KPhase),BondValCoeffO,225)
      call FeQuestCreate(id,-1.,-1.,115.,nf,0,
     1                   'Bond valence coefficients',0,LightGray,0,0)
      do 1200i=1,nf
        call FeQuestSelwMake(id, 5.,i,AtType(i,KPhase),10.,SelwYd,1,1)
        call FeQuestSelwOpen(SelwLastMade,i.eq.1)
        call FeQuestSelwMake(id,20.,i,AtType(i,KPhase),10.,SelwYd,1,2)
        call FeQuestSelwOpen(SelwLastMade,i.eq.1)
1200  continue
      i=(nf+1)/2
      call FeQuestEdwMake(id,40.,i,80.,i,'Coefficient','L',30.,EdwYd,0)
      i=1
      j=1
      icont=0
1500  call FeQuestRealEdwOpen(1,BondValCoeff(i,j,KPhase),.false.,
     1                        .false.)
      call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.eq.EventSelw) then
        call FeQuestRealFromEdw(1,BondValCoeff(i,j,KPhase))
        if(i.ne.j) BondValCoeff(j,i,KPhase)=BondValCoeff(i,j,KPhase)
        iw=(CheckNumber-1)/2+1
        if(mod(CheckNumber,2).eq.1) then
          i=iw
        else
          j=iw
        endif
        EventType=EventEdw
        EventNumber=1
        go to 1500
      else if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) call FeQuestRealFromEdw(1,BondValCoeff(i,j,KPhase))
      call FeQuestRemove(id)
      if(ich.ne.0) call CopyVek(BondValCoeffO,BondValCoeff(1,1,KPhase),
     1                          225)
      return
      end
      integer function RecModToRecMap(k,nx,ior,n)
      dimension ior(n),nx(n),nd(3)
      call RecUnpack(k,nd,nx,n)
      RecModToRecMap=0
      do 1000i=n,1,-1
        j=ior(i)
        RecModToRecMap=RecModToRecMap*nx(j)+nd(j)-1
1000  continue
      RecModToRecMap=RecModToRecMap+1
      return
      end
      subroutine GrtSetTr
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'contour.cmn'
      include 'grapht.cmn'
      call UnitMat(F2O,3)
      call UnitMat(O2F,3)
      do 1100i=1,ndimi
        xmin(i)=gx(1,i)
        xmax(i)=gx(2,i)
        dx(i)=gx(3,i)
1100  continue
      call FeSetTransXo2X(xmin(1),xmax(1),xmin(2),xmax(2),.true.)
      return
      end
      subroutine GrtGrawPerPartes(x,y,o,nn,plne,Colour)
      dimension x(nn),y(nn),o(nn)
      integer Colour
      logical plne
      n=0
      np=1
      do 1000i=1,nn
        if(o(i).gt.0.) then
          n=n+1
        else
          if(n.gt.0) then
            call FeXYPlot(x(np),y(np),n,plne,Colour)
            np=i
            n=0
          endif
          np=np+1
        endif
1000  continue
      if(n.gt.0) call FeXYPlot(x(np),y(np),n,plne,Colour)
      return
      end
      subroutine GrtSetDistKeys(NPar,xpp)
      include 'params.cmn'
      include 'basic.cmn'
      include 'dist.cmn'
      include 'grapht.cmn'
      dimension xpp(3)
      logical iesd
      call DefaultDist
      call SetRealArrayTo(dt,9,0.)
      call SetRealArrayTo(tfirst,9,0.)
      call SetRealArrayTo(tfirst,9,1.)
      call SetIntArrayTo(nt,9,1)
      call CopyVek(xpp,tfirst,ndimi)
      call CopyVekI(NxMod,nt,ndimi)
      call CopyVek (DxMod,dt,ndimi)
      if(NPar.eq.IdDrawDist) then
        dmdk=yomn
        dmhk=yomx
        iuhl=0
      else if(NPar.eq.IdDrawVal) then
        iuhl=0
        dmdk=0.
        dmhk=DrawDMax
      else if(NPar.eq.IdDrawAngles) then
        dmdk=0.
        dmhk=DrawDMax
        iuhl=1
      endif
      do 3110i=1,ndimi
        do 3110j=2,ncomp
          nt(i,j)=nt(i,1)
          tfirst(i,j)=tfirst(i,1)
          tlast(i,j)=tlast(i,1)
          dt(i,j)=dt(i,1)
3100    continue
3110  continue
      do 3130j=1,ncomp
        ntall(j)=1
        do 3120i=1,ndimi
          ntall(j)=ntall(j)*nt(i,j)
3120    continue
3130  continue
      ieach=1
      fullcoo=1
      VolaToDist=.false.
      call inm40(iesd)
      return
      end
      subroutine GrtLocator
      include 'params.cmn'
      include 'basic.cmn'
      include 'fepc.cmn'
      include 'grapht.cmn'
      include 'contour.cmn'
      character*8  SvFile
      if(OpSystem.ge.0) then
        SvFile='full.pcx'
      else
        SvFile='full.bmp'
      endif
      call FeSaveImage(XMinGrWin,XMaxGrWin,YMinGrWin,YMaxGrWin,SvFile)
      Xpos=(XminGrWin+XmaxGrWin)*.5
      Ypos=(YminGrWin+YmaxGrWin)*.5
      call FeMoveMouseTo(Xpos,Ypos)
      write(Cislo,100) FeX2Xo(XPos),FeY2Yo(YPos)
      call FeQuestStringEdwOpen(ContourEdwInfo(1),Cislo)
      AllowChangeMouse=.false.
      TakeMouseMove=.true.
      j=ContourEdwInfo(1)+EdwFr-1
      call FeMouseShape(1)
1000  if(DeferredOutput) call FeReleaseOutput
1010  call FeEvent(1)
      if(EventNumber.eq.0) go to 1010
      if(EventType.eq.EventMouse.and.EventNumber.eq.JeLeftDown) then

      else if(EventType.eq.EventMouse.and.EventNumber.eq.JeMove) then
        XPosO=FeX2Xo(XPos)
        YPosO=FeY2Yo(YPos)
        XPosO=max(xomn,XPosO)
        XPosO=min(xomx,XPosO)
        YPosO=max(yomn,YPosO)
        YPosO=min(yomx,YPosO)
        XPosP=FeXo2X(XPosO)
        YPosP=FeYo2Y(YPosO)
        if(abs(Xposp-Xpos).gt..5.or.abs(Yposp-Ypos).gt..5) then
          Xpos=Xposp
          Ypos=Yposp
          call FeMoveMouseTo(Xpos,Ypos)
        else
          Xpos=Xposp
          Ypos=Yposp
        endif
        write(Cislo,100) XPosO,YPosO
        call FeReDrTx(j,1,0,Cislo)
      else if(EventType.eq.EventMouse.and.EventNumber.eq.JeRightDown)
     1  then
        go to 1100
      endif
      go to 1000
1100  TakeMouseMove=.false.
      call FeMouseShape(0)
      call FePlotMode('N')
      call FeDeferOutput
      call FeQuestEdwClose(ContourEdwInfo(1))
      call FeLoadImage(XMinGrWin,XMaxGrWin,YMinGrWin,YMaxGrWin,SvFile,0)
      return
100   format(f7.3,f8.3)
      end
      subroutine GrtReadOptions(ich)
      include 'params.cmn'
      include 'basic.cmn'
      include 'grapht.cmn'
      include 'fepc.cmn'
      character*80 Veta
      logical CrwLogicQuest
      ich=0
      id=NextQuestId()
      xdq=120.
      xdqp=xdq*.5
      il=1
      call FeQuestCreate(id,-1.,-1.,xdq,0,il,' ',0,LightGray,0,0)
      il=1
      Veta='Indicate %commensurate t sections'
      tpom=5.
      xpom=tpom+FeTxLengthUnder(Veta)+5.
      call FeQuestCrwMake(id,tpom,il,xpom,il,Veta,'L',CrwXd,CrwYd,0,0)
      nCrwTSections=CrwLastMade
      call FeQuestCrwOpen(CrwLastMade,DrawTCommen)
      icont=0
1500  call FeQuestEvent(id,icont,ich)
      icont=1
      if(CheckType.ne.0) then
        call NebylOsetren
        go to 1500
      endif
      if(ich.eq.0) then
        DrawTCommen=CrwLogicQuest(nCrwTSections)
      endif
      call FeQuestRemove(id)
      return
      end
